/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.rqm.defects.web.client.internal.DefectsProviderClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.foundation.Status");

(function() {

var ServiceRequest					= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient				= com.ibm.team.repository.web.transport.TeamServerClient;
var ServiceResponseHandler			= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var Status							= com.ibm.team.repository.web.foundation.Status;

var SERVICE_URI				= "com.ibm.rqm.defects.service.internal.rest.IDefectsRestService";

com.ibm.rqm.defects.web.client.internal.DefectsProviderClient= {

	// ---- api ------------------------------------------------------------------------------------------------------------

 	getDefectsProviders: function(responceCallback) {
		return this._invokeDefectsRestService("getDefectsProviders", responceCallback);
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	_invokeDefectsRestService: function(method, serviceCallback, appArgs) {
		var serviceRequest= new ServiceRequest(SERVICE_URI, method, appArgs);
		var serviceResponseHandler= new ServiceResponseHandler({
			success: function(result) {
				serviceCallback(Status.OK_STATUS, result);
			},
			failure: function(error) {
				serviceCallback(new Status(Status.ERROR, error.message, error), null);
			}
		}, "success", "failure");

		TeamServerClient.invokeService(serviceRequest, serviceResponseHandler);
	},

	__sentinel: null // terminates this class definition
};

})();
