/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function(){
dojo.provide("com.ibm.asq.common.web.client.internal._catalog.Asset");
dojo.require("com.ibm.asq.common.web.client.internal._catalog._ConfigurationBase");
dojo.declare("com.ibm.asq.common.web.client.internal._catalog.Asset", com.ibm.asq.common.web.client.internal._catalog._ConfigurationBase, 
{
    // Get the id of the Asset. Returns null is the asset 
    // is not resolved.
    getId: function() {
        var part =  this.rootAttribute.getValue();
        if(part == null){
            return null;
        }  
        return part.instanceRoot.uuid;   
    },
    // Set the root Part of the Asset.
    setRoot: function(typeName) {
        var att = this.rootAttribute;
        att.setValue(typeName);
    },        
    // Set the root Part of the Asset.
    getRoot: function(typeName) {
        var att = this.rootAttribute;
        return att.getValue();
    },        
    // Get a duplicate of the Asset.
    clone: function() {
        var jsonStr = dojo.toJson(this.instanceObj,false);
        return new com.ibm.asq.common.web.client.internal._catalog.Asset(jsonStr);
    }
}   
)
})();
