/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

(function(){
dojo.provide("com.ibm.rational.test.lm.web.client.internal.collections");
    
dojo.require("com.ibm.rational.test.lm.web.client.internal.rawContainer");

dojo.declare("com.ibm.rational.test.lm.web.client.internal.collections",
             com.ibm.rational.test.lm.web.client.internal.rawContainer,
{
    constructor: function() {
        this.setServiceInterface('com.ibm.rational.test.lm.common.IResourceCollectionRestService');
    },

    _getProjectAreaArgs: function() {
        return { projectAreaItemId: com.ibm.team.process.web.projectArea.itemId };	    
	},
	
    getVirtualImageCollections: function(responseHandler) {
        return this._invokeService(responseHandler, "getManagedVirtualImageCollections", this._getProjectAreaArgs());
    },
    
    getVirtualMachineCollections: function(responseHandler) {
        return this._invokeService(responseHandler, "getManagedVirtualMachineCollections", this._getProjectAreaArgs());
    },
    
    // Associate a configuration to the collection.  Specify null for the configuration id to
    // remove the association.
    //
    setConfiguration: function(responseHandler, collId, configId) {
        var arg = { colUuid: collId };
        if (configId) {
            arg.configUuid = configId;
        }
        return this._invokeService(responseHandler, "postConfigurationToCollection", arg);
    }
});

})();
