/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient= {

	EXECUTION_SERVICE_URI: "com.ibm.rqm.executionframework.common.service.rest.IAdapterRequestRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
		if(appArgs.id)	
			actualArgs.id = appArgs.id;
		if(appArgs.selectedAdapterId)	
			actualArgs.selectedAdapterId = appArgs.selectedAdapterId;
		if(appArgs.responseJsonString)	
			actualArgs.responseJsonString = appArgs.responseJsonString;
		if(appArgs.isNew)	
			actualArgs.isNew = appArgs.isNew;
		if(appArgs.requestId)	
			actualArgs.requestId = appArgs.requestId;
		if(appArgs.properties)	
			actualArgs.propsJsonString = dojo.toJson(appArgs.properties);
		if(appArgs.requestType)	
			actualArgs.requestType = appArgs.requestType;
		if(appArgs.responseJsonString)	
			actualArgs.responseJsonString = dojo.toJson(appArgs.responseProperties);	
		if(appArgs.progress)
			actualArgs.progress = appArgs.progress;	
		if(appArgs.message)	
			actualArgs.message = appArgs.message;	
		if(appArgs.data)	
			actualArgs.data = appArgs.data;	
		if(appArgs.statusCode)	
			actualArgs.statusCode = appArgs.statusCode;	
		if(appArgs.adapterId)	
			actualArgs.adapterId = appArgs.adapterId;		
		if(appArgs.stateId)	
			actualArgs.stateId = appArgs.stateId;
		if(appArgs.projectAreaItemId)	
			actualArgs.projectAreaItemId = appArgs.projectAreaItemId;
		if(appArgs.state)	
			actualArgs.state = appArgs.state;
		}else{
			appArgs = {};
		}
		if(!appArgs.projectAreaItemId){
			actualArgs.projectAreaItemId = getCurrentPA().itemId;
		}
		var serviceRequest= new ServiceRequest(this.EXECUTION_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	postCreateRequest: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postCreateRequest", params);
	},
	
	getResponse: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getResponse", params);
	},
	
	getRequest: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getRequest", params);
	},
	
	getRequestDTO: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getRequestDTO", params);
	},
	
	postResponse: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postResponse", params);
	},
	
	getServerTime: function(serviceResponseHandler){
		this._invokeService(serviceResponseHandler, "getServerTime");
	}
	
};

})();
