/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.WorkItemUtils");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var WorkItemUtils          = com.ibm.rqm.planning.web.client.internal.WorkItemUtils;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient= {

	TEST_SUITE_SERVICE_URI: "com.ibm.rqm.execution.common.service.rest.ITestExecutionSuiteRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
			
			if(appArgs.ids)
                actualArgs.ids = appArgs.ids;			
			if(appArgs.name)
				actualArgs.name = appArgs.name;
			if(appArgs.owner)
				actualArgs.owner = appArgs.owner;
			if(appArgs.ownerId)
			    actualArgs.ownerId = appArgs.ownerId;
			if(appArgs.name)
				actualArgs.name = appArgs.name;								
			if(appArgs.id)
				actualArgs.id = appArgs.id;								
			if(appArgs.originator)
				actualArgs.originator = appArgs.originator;
			if(appArgs.description)
				actualArgs.description = appArgs.description;	
			
			if(appArgs.externalId)
				actualArgs.externalId = appArgs.externalId;
			if(appArgs.suiteElementsJsonString)
				actualArgs.suiteElementsJsonString = appArgs.suiteElementsJsonString;	
			if(appArgs.addRresultGroups)
				actualArgs.addRresultGroups = appArgs.addRresultGroups;	
			if(appArgs.removeResultGroups)
				actualArgs.removeResultGroups = appArgs.removeResultGroups;	
			if(appArgs.newTestExecutionSuite)
				actualArgs.newTestExecutionSuite = appArgs.newTestExecutionSuite;	
			if(appArgs.itemId)
				actualArgs.itemId = appArgs.itemId;
			if(appArgs.ewiId)
				actualArgs.ewiId = appArgs.ewiId;
			if(appArgs.resultGroupId)
				actualArgs.resultGroupId = appArgs.resultGroupId;
			if(appArgs.uuid_ts)
				actualArgs.uuid_ts = appArgs.uuid_ts;			
			if(appArgs.archive)
				actualArgs.archive = appArgs.archive;
			if(appArgs.testSuiteId)
				actualArgs.testSuiteId = appArgs.testSuiteId;
			if(appArgs.startTime)
				actualArgs.startTime = appArgs.startTime;		
			if(appArgs.suiteElementsJsonString)
				actualArgs.suiteElementsJsonString = appArgs.suiteElementsJsonString;	
			if(appArgs.endTime)
				actualArgs.endTime = appArgs.endTime;
			if(appArgs.stateId)
				actualArgs.stateId = appArgs.stateId;
			if(appArgs.isSerialExecution == true || appArgs.isSerialExecution == false)
				actualArgs.isSerialExecution = appArgs.isSerialExecution;
			if(appArgs.sectionJsonString)
				actualArgs.sectionJsonString = appArgs.sectionJsonString;
			if(appArgs.workItemsJsonString)
				actualArgs.workItemsJsonString = appArgs.workItemsJsonString;
			if(appArgs.sectionsOrder)
				actualArgs.sectionsOrder = appArgs.sectionsOrder;
			if(appArgs.sectionsRemoved)
				actualArgs.sectionsRemoved = appArgs.sectionsRemoved;
			if(appArgs.state)
				actualArgs.state = appArgs.state;
			if(appArgs.teamAreaItemId)
				actualArgs.teamAreaItemId = appArgs.teamAreaItemId;
			if(appArgs.projectAreaItemId)
				actualArgs.projectAreaItemId = appArgs.projectAreaItemId;
			if(appArgs.reservationUUIDs)
				actualArgs.reservationUUIDs = appArgs.reservationUUIDs;
			if(appArgs.resolveWorkItems){
				actualArgs.resolveWorkItems = appArgs.resolveWorkItems;
			}						
		}else{
			appArgs = {};
		}
		if(!appArgs.projectAreaItemId){
			actualArgs.projectAreaItemId = getCurrentPA().itemId;
		}
		var serviceRequest= new ServiceRequest(this.TEST_SUITE_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	getTestExecutionSuites: function(serviceResponseHandler, params) {
		this._invokeService(serviceResponseHandler, "getTestExecutionSuites", params);
	},
	
	getTestExecutionSuiteDTOs: function(serviceResponseHandler, params ){
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
		this._invokeService(actualHandler, "getTestExecutionSuiteDTOs", params);
	},
	
	getTestExecutionSuiteSummaryDTOs: function(serviceResponseHandler, params ){
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
		this._invokeService(actualHandler, "getTestExecutionSuiteSummaryDTOs", params);
	},
	
	postBulkChangeTestSuite: function (serviceResponseHandler, params )
	{
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
        this._invokeService(actualHandler, "postBulkChangeTestSuiteDTO", params);
	},
	
	postTestExecutionSuite: function(serviceResponseHandler, params )
	{
		this._invokeService(serviceResponseHandler, "postTestExecutionSuite", params);
	},
	
	postTestExecutionSuiteDTO: function(serviceResponseHandler, params )
	{
		var actualHandler = this.getWorkItemMappingHandler(serviceResponseHandler);
		this._invokeService(actualHandler, "postTestExecutionSuiteDTO", params);
	},
	
	archiveTestExecutionSuite: function(serviceResponseHandler, params )
	{
		this._invokeService(serviceResponseHandler, "postArchiveTS", params);
	},
		
	postExecute: function(serviceResponseHandler, params)
	{
		this._invokeService(serviceResponseHandler, "postExecute", params);
	},
	
    getWorkItemMappingHandler: function(responseHandler) {
        var start = new Date();
        var internalHandler = {
            success: function(testSuiteDTOs){
                //fixup each workitem for each test case
				if (dojo.isArray(testSuiteDTOs)) {
					testSuiteDTOs = WorkItemUtils.fixupArtifactsWorkItems(testSuiteDTOs);
				} else if (dojo.isObject(testSuiteDTOs)) {
					testSuiteDTOs = WorkItemUtils.fixupArtifactWorkItems(testSuiteDTOs);
				}
                responseHandler.doCallback(testSuiteDTOs);
            },
            failure: function(error){
                responseHandler.doErrorCallback(error);
            }
        };
        var handler = new ServiceResponseHandler(internalHandler, "success", "failure");
        return handler;
    }	
	
};

})();