/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient= {

	KEYWORD_SERVICE_URI: "com.ibm.rqm.keyword.common.service.rest.IKeywordRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
		if(appArgs.id)	
			actualArgs.id = appArgs.id;
		if(appArgs.externalId)	
			actualArgs.externalId = appArgs.externalId;
		if(appArgs.name)	
			actualArgs.name = appArgs.name;
		if(appArgs.newKeyword)	
			actualArgs.newKeyword = appArgs.newKeyword;
		if(appArgs.manualScript)	
			actualArgs.manualScript = appArgs.manualScript;
		if(appArgs.scripts)	
			actualArgs.scripts = appArgs.scripts;
		if(appArgs.tags)	
			actualArgs.tags = appArgs.tags;
		if(appArgs.defaultScript)	
			actualArgs.defaultScript = appArgs.defaultScript;
		if(appArgs.archive)
			actualArgs.archive = appArgs.archive;
		if(appArgs.includeArchived)
			actualArgs.includeArchived = appArgs.includeArchived;
		if(appArgs.stateId)
			actualArgs.stateId = appArgs.stateId;
		}else{
			appArgs = {};
		}
		if(!appArgs.projectAreaItemId){
			actualArgs.projectAreaItemId = getCurrentPA().itemId;	
		}
		var serviceRequest= new ServiceRequest(this.KEYWORD_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},

	getKeywords: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getKeywords", params);
	},
	
	getKeywordDTO: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getKeywordDTO", params);
	},
	
	postKeyword: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postKeyword", params);
	},
	postKeywordDTO:function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postKeywordDTO", params);
	},
	postArchiveKeyword: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postArchiveKeyword", params);
	}
};

})();
