/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.mapper.AllResultsMapper");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.SearchResultMapper");

dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultMapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper");

(function() { //module container

    var Constants      = com.ibm.rqm.planning.web.client.internal.Constants;

    var RESULT_DTO_CLASSNAME            = "com.ibm.rqm.execution.rest.dto:ExecutionResultSummaryDTO";
	var RESULT_GROUP_DTO_CLASSNAME      = "com.ibm.rqm.execution.rest.dto:ExecutionResultGroupSummaryDTO";
    var ResultMapper                    = com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultMapper;
	var ResultGroupMapper               = com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper;
	
	dojo.declare("com.ibm.rqm.execution.web.client.internal.mapper.AllResultsMapper",
	             com.ibm.rqm.planning.web.client.internal.mapper.SearchResultMapper, {				

        /**
         * Setup mappers with dummy callback to use their map() functions 
         */
        setupMappers: function() {
			var dummy = {
				success: function(){},
				failure: function(){}
			}
			if (!this.resultMapper) {
				this.resultMapper = new ResultMapper(dummy, "success", "failure");
			}
			if (!this.resultGroupMapper) {
                this.resultGroupMapper = new ResultGroupMapper(dummy, "success", "failure");
			}
		},
												
		//maps an array of mized DTO types (ExecutionResultSummaryDTO and ExecutionResultGroupSummaryDTO)
		map: function(summaryDTO) {
			this.setupMappers();
	        //determine which type of DTO
			if (summaryDTO._eQualifiedClassName == RESULT_DTO_CLASSNAME) {
				summaryDTO = this.resultMapper.map(summaryDTO);
				summaryDTO.type = Constants.TYPE_EWI;
			} else if (summaryDTO._eQualifiedClassName == RESULT_GROUP_DTO_CLASSNAME) {
				//summaryDTO = this.resultGroupMapper.map(summaryDTO);
				summaryDTO.type = Constants.TYPE_SUITE;
				summaryDTO.script = { name: Constants.getMessage("labelMultiple") };
				summaryDTO.testCase = { name: Constants.getMessage("labelMultiple")};
			}
			return summaryDTO;
		}
	});
})();