/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper");
dojo.require("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");

dojo.declare("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper",
             com.ibm.asq.common.web.client.internal.mapper.AbstractMapper, {
			 	
	// transforms a summary DTO to a full DTO
	map: function(summaryDTO) {
//		// elements workitem
		if (summaryDTO.elements!=null && summaryDTO.elements.length > 0) {
			for(var i=0;i<summaryDTO.elements.length;i++){
				summaryDTO.elements[i].workitem = {};
				summaryDTO.elements[i].workitem.id = summaryDTO.elements[i].ewiId;
				summaryDTO.elements[i].workitem.name = summaryDTO.elements[i].ewiName;
				summaryDTO.elements[i].workitem.itemId = summaryDTO.elements[i].ewiitemId;
				summaryDTO.elements[i].workitem.testCase = summaryDTO.elements[i].testCase;
				summaryDTO.elements[i].workitem.weight = summaryDTO.elements[i].ewiWeight;
				if(summaryDTO.elements[i].ewiDefaultScriptId){
					summaryDTO.elements[i].workitem.defaultScript = {};
					summaryDTO.elements[i].workitem.defaultScript.id = summaryDTO.elements[i].ewiDefaultScriptId;
					summaryDTO.elements[i].workitem.defaultScript.name = summaryDTO.elements[i].ewiDefaultScriptName;
					summaryDTO.elements[i].workitem.defaultScript.itemId = summaryDTO.elements[i].ewiDefaultScriptItemId;
					summaryDTO.elements[i].workitem.defaultScript.stateId = summaryDTO.elements[i].ewiDefaultScriptStateId;
					summaryDTO.elements[i].workitem.defaultScript.scriptType = {};
					summaryDTO.elements[i].workitem.defaultScript.scriptType.id = summaryDTO.elements[i].ewiDefaultScriptStateType;
				}else
					summaryDTO.elements[i].workitem.defaultScript = null;	
				summaryDTO.elements[i].workitem.stateId = summaryDTO.elements[i].ewiStateId;
				summaryDTO.elements[i].workitem.configuration = summaryDTO.elements[i].ewiConfigurationItemId;
				
				if(summaryDTO.elements[i].ewiPlanName){
					summaryDTO.elements[i].workitem.testPlan = {};
					summaryDTO.elements[i].workitem.testPlan.name = summaryDTO.elements[i].ewiPlanName;
					summaryDTO.elements[i].workitem.testPlan.id = summaryDTO.elements[i].ewiPlanId;
					summaryDTO.elements[i].workitem.testPlan.versionableItemId = summaryDTO.elements[i].ewiPlanVersionableItemId;
				}
				if(summaryDTO.elements[i].ewiPhaseName){
					summaryDTO.elements[i].workitem.phase = {};
					summaryDTO.elements[i].workitem.phase.name = summaryDTO.elements[i].ewiPhaseName;
					summaryDTO.elements[i].workitem.phase.itemId = summaryDTO.elements[i].ewiPhaseItemId;
				}
				
				delete summaryDTO.elements[i].ewiId;
				delete summaryDTO.elements[i].ewiName;
				delete summaryDTO.elements[i].ewiitemId;
				delete summaryDTO.elements[i].testCase;
				delete summaryDTO.elements[i].ewiDefaultScriptId;
				delete summaryDTO.elements[i].ewiDefaultScriptName;
				delete summaryDTO.elements[i].ewiDefaultScriptItemId;
				delete summaryDTO.elements[i].ewiDefaultScriptStateId;
				delete summaryDTO.elements[i].ewiDefaultScriptStateType;
				delete summaryDTO.elements[i].ewiConfigurationItemId;
				delete summaryDTO.elements[i].ewiStateId;
				delete summaryDTO.elements[i].ewiPhaseItemId;
				delete summaryDTO.elements[i].ewiPhaseName;
				delete summaryDTO.elements[i].ewiPlanVersionableItemId;
				delete summaryDTO.elements[i].ewiPlanName;
				delete summaryDTO.elements[i].ewiPlanId;
				delete summaryDTO.elements[i].ewiWeight;
			}
		}
		return summaryDTO;
	}
	
});