/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper");
dojo.require("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");

dojo.declare("com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper",
             com.ibm.asq.common.web.client.internal.mapper.AbstractMapper, {
			 	
	// transforms a summary DTO to a full DTO
	map: function(summaryDTO) {
		// current result group
		if (summaryDTO.currentResultGroupId!=null) {
			summaryDTO.currentResultGroup = {};
			summaryDTO.currentResultGroup.id = summaryDTO.currentResultGroupId;
			summaryDTO.currentResultGroup.state = {};
			summaryDTO.currentResultGroup.state.name = summaryDTO.currentResultGroupStateName;
			delete summaryDTO.currentResultGroupId;
			delete summaryDTO.currentResultGroupStateName;
		}
		
		// owner
		if(summaryDTO.ownerName){
			summaryDTO.owner = {};
			summaryDTO.owner.name = summaryDTO.ownerName;
			delete summaryDTO.ownerName;
		}
		
		//elements as workitem
		if (summaryDTO.elements!=null && summaryDTO.elements.length > 0) {
			for(var i=0;i<summaryDTO.elements.length;i++){
				summaryDTO.elements[i].workitem = {};
				summaryDTO.elements[i].workitem.id = summaryDTO.elements[i].ewiId;
				summaryDTO.elements[i].workitem.name = summaryDTO.elements[i].ewiName;
				summaryDTO.elements[i].workitem.itemId = summaryDTO.elements[i].ewiitemId;
				summaryDTO.elements[i].workitem.archived = summaryDTO.elements[i].ewiIsArchived;
				summaryDTO.elements[i].workitem.testCase = summaryDTO.elements[i].testCase;
				summaryDTO.elements[i].workitem.weight = summaryDTO.elements[i].ewiWeight;
				if(summaryDTO.elements[i].ewiPlanId){
					summaryDTO.elements[i].workitem.testPlan = {};
					summaryDTO.elements[i].workitem.testPlan.id = summaryDTO.elements[i].ewiPlanId;
					summaryDTO.elements[i].workitem.testPlan.name = summaryDTO.elements[i].ewiPlanName;
					summaryDTO.elements[i].workitem.testPlan.versionableItemId = summaryDTO.elements[i].ewiPlanVersionableItemId;
				}	
				if(summaryDTO.elements[i].ewiPhaseItemId){
					summaryDTO.elements[i].workitem.testPhase = {};
					summaryDTO.elements[i].workitem.testPhase.name = summaryDTO.elements[i].ewiPhaseName;
					summaryDTO.elements[i].workitem.testPhase.itemId = summaryDTO.elements[i].ewiPhaseItemId;
				}
				if(summaryDTO.elements[i].scriptId){
					summaryDTO.elements[i].script = {};
					summaryDTO.elements[i].script.id = summaryDTO.elements[i].scriptId;
					summaryDTO.elements[i].script.name = summaryDTO.elements[i].scriptName;
					summaryDTO.elements[i].script.itemId = summaryDTO.elements[i].scriptItemId;
					summaryDTO.elements[i].script.stateId = summaryDTO.elements[i].scriptStateId;
					summaryDTO.elements[i].script.scriptType = {};
					summaryDTO.elements[i].script.scriptType.id = summaryDTO.elements[i].scriptTypeId;
				}
				if(summaryDTO.elements[i].ewiDefaultScriptId){
					summaryDTO.elements[i].workitem.defaultScript = {};
					summaryDTO.elements[i].workitem.defaultScript.id = summaryDTO.elements[i].ewiDefaultScriptId;
					summaryDTO.elements[i].workitem.defaultScript.name = summaryDTO.elements[i].ewiDefaultScriptName;
					summaryDTO.elements[i].workitem.defaultScript.itemId = summaryDTO.elements[i].ewiDefaultScriptItemId;
					summaryDTO.elements[i].workitem.defaultScript.stateId = summaryDTO.elements[i].ewiDefaultScriptStateId;
					summaryDTO.elements[i].workitem.defaultScript.scriptType = {};
					summaryDTO.elements[i].workitem.defaultScript.scriptType.id = summaryDTO.elements[i].ewiDefaultScriptTypeId;
				}else
					summaryDTO.elements[i].workitem.defaultScript = null;
				summaryDTO.elements[i].workitem.stateId = summaryDTO.elements[i].ewiStateId;
				summaryDTO.elements[i].workitem.configuration = summaryDTO.elements[i].ewiConfigurationItemId;
				
				delete summaryDTO.elements[i].ewiId;
				delete summaryDTO.elements[i].ewiName;
				delete summaryDTO.elements[i].ewiitemId;
				delete summaryDTO.elements[i].ewiIsArchived;
				delete summaryDTO.elements[i].testCase;
				delete summaryDTO.elements[i].ewiDefaultScriptId;
				delete summaryDTO.elements[i].ewiDefaultScriptName;
				delete summaryDTO.elements[i].ewiDefaultScriptItemId;
				delete summaryDTO.elements[i].ewiDefaultScriptStateId;
				delete summaryDTO.elements[i].ewiDefaultScriptTypeId;
				delete summaryDTO.elements[i].ewiConfigurationItemId;
				delete summaryDTO.elements[i].ewiStateId;
				delete summaryDTO.elements[i].ewiPlanId;
				delete summaryDTO.elements[i].ewiPlanName;
				delete summaryDTO.elements[i].ewiPlanVersionableItemId;
				delete summaryDTO.elements[i].ewiPhaseItemId;
				delete summaryDTO.elements[i].ewiPhaseName;
				delete summaryDTO.elements[i].ewiWeight;
				
				delete summaryDTO.elements[i].scriptId;
				delete summaryDTO.elements[i].scriptName;
				delete summaryDTO.elements[i].scriptItemId;
				delete summaryDTO.elements[i].scriptStateId;
				delete summaryDTO.elements[i].scriptTypeId;
			}
		}
		
		return summaryDTO;
	}
	
});