/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.page.execution.ExecutionPageController");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

//Local clients needed
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorFactory");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() {

var ServiceResponseHandler 	       = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var EWIMapper					   = com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper;
var EditorFactory 				   = com.ibm.rqm.planning.web.ui.internal.util.EditorFactory;
var ExecutionWorkItemClient 	   = com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ExecutionResultClient		   = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var TestCaseClient   			   = com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
var getAuthenticatedContributor	   = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var Constants                      = com.ibm.rqm.planning.web.client.internal.Constants;
var ewi = null;

	dojo.declare("com.ibm.rqm.execution.web.ui.internal.page.execution.ExecutionPageController", null, 
	{ 
		
		constructor: function(executionView) 
		{	
			this._view = executionView;
			this._stepsHaveVerdict = false; 
		},
		
	   /*
		* Provide access to an EditorFactory instance.
		*/
		getEditorFactory: function() 
		{
			return EditorFactory;
		},
					
		init: function() 
		{
			this.viewEWI({name: Constants.getMessage("labelMyEWI")});
		},

		viewEwi: function(kwArgs) 
		{
			this._view.showEWI(kwArgs.name);				
		},	
		
		viewEwis: function(kwArgs)
		{
			var args;
			if(kwArgs.name == Constants.getMessage("labelMyEWI"))
					args = {name: kwArgs.name,owner: getAuthenticatedContributor().userId};
				else
					args = {name: kwArgs.name};
			var items = [];
			this._view.showAllEWIs(items, args);
		},
		
		viewResult: function(kwArgs)
		{
			this._view.showResult(kwArgs);
		},
		
		viewResults: function(kwArgs)
		{
			var self = this;
			var callbackObj = 
			{
				success: function(items) 
				{
					self._view.showAllResults(items, kwArgs.name);
				},
				failure: function(e) 
				{
					self._error(e);
				}				
			}			
			
			var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
			ExecutionResultClient.getExecutionResultDTOs(responseHandler);
		},
				
		startExecution: function(args)
		{
			this._view.startExecution(args);
		},
		
		viewExecutedItems: function(kwArgs)
		{
			var self = this;
			var callbackObj = 
			{
				success: function(items) 
				{
					self._view.showExecutedEWIs(items, kwArgs.name);
				},
				failure: function(e) 
				{
					self._error(e);
				}				
			}
			var responseHandler = new EWIMapper(callbackObj, "success", "failure");
			ExecutionWorkItemClient.getExecutionWorkItemSummaryDTOs(responseHandler, kwArgs);
		},
	
		viewEWIResults: function(kwArgs)
		{
			this._view.showEWIResults(kwArgs);
		},
		
		getStepsHaveVerdict: function()
		{
			return this._stepsHaveVerdict;
		},

		setStepsHaveVerdict: function(stepsHaveVerdict)
		{
			this._stepsHaveVerdict = stepsHaveVerdict;
		},
		
		_error: function(error) 
		{
			alert("Error invoking service; message: " + error.message + "@ ExecutionPage Controller _error");
		}	
		
	});
})();
