/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.page.home.HomePageView");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.home.HomePageView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.team.process.web.client.projectarea");

dojo.require("com.ibm.asq.common.web.client.internal.option");

dojo.require("com.ibm.rqm.planning.web.ui.internal.page.home.DashboardHomePage");
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.home.HomePageController");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBar");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.GlobalTaskBar");

//workaround Jazz dashboard missing dojo.require and variable declaration problem in M5a.
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var InitializationData     = com.ibm.team.repository.web.client.init.InitializationData;

(function()
{
	var PlatformUI			= net.jazz.ajax.ui.PlatformUI;
	var ActionRegistry		= null; // initialize later
	var root                = "com.ibm.rqm.planning.home.";
    var Dispatcher          = "actionDispatcher";
    var HomeViewAction      = "viewUserHome";
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var PreferenceClient = com.ibm.rqm.planning.web.client.internal.PreferenceClient;
	var EditorUtil          = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
	var getCurrentProjectArea  = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.home.HomePageView",
	  [dijit._Widget, dijit._Templated],
	{      
		controller: null,      
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/home/HomePageView.html"),
		
		_actions: ["showCurrentQuery", "actionDispatcher"],			
			
		/*
		 * Required by Jazz web framework to make hyperlinking and back/forward
		 * work.
		 */
		getController: function()
		{
			return (this.controller);
		},
		
		// initialization      
		postCreate: function() {
			this.controller = new com.ibm.rqm.planning.web.ui.internal.page.home.HomePageController(this);
			this.controller.registerDispatchAction(HomeViewAction, dojo.hitch(this, "showUserDashboard"));
            
			// lazily initialize the ActionRegistry alias
			ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();

			// register actions			
			for (var i = 0; i < this._actions.length; i++) {
				var actionName = this._actions[i];
		        ActionRegistry.registerAction(root + actionName, this.controller, actionName);
			}	
							
			this._initUI();	
            this.controller.initTrackTabChange();			
		},				
		
		_initUI: function()
		{
			this._homePageCreated = false;
			
			PreferenceClient.getCurrentUserPreferences(this, this.showRelatedInfo, Constants.USER_UI_CUSTOMISE_ACTIONBAR_RELATEDINFO_CATEGORY.key);

			// There is only one page for the HomePage View with only one content area.
			// Set a unique id for the one and only one the content area.
			//
			var contentAreaArg = { id: "one-and-only-one-com-ibm-rqm-web-home-page-content-area" };
			this._contentArea = new com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea(contentAreaArg);
			this._contentArea.initialize();
			this._centerArea.appendChild(this._contentArea.domNode);

            // Subscribe to tabbed view selected event and let the view drive the
            // contents of the related info area.  "this._contentArea.tabs.id" is
            // the id of the TabContainer that we subscribe to.
            //
            dojo.subscribe(this._contentArea._tabs.id+"-selectChild", this, "onSelectTab");

            
			PreferenceClient.getCurrentUserPreferences(this, this.showActionBar, Constants.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY.key);
        },
		
		showRelatedInfo: function(userPreference) {
			var args = {
				open: true,
				parent: this
			}
			if (userPreference.key == Constants.USER_UI_CUSTOMISE_ACTIONBAR_RELATEDINFO_CATEGORY.key) {
				args.open = (userPreference.value == true);
			}
			this.openRelatedInfo = args.open;
			
			this._relatedInfo = new com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo(args);
			this._relatedInfoArea.appendChild(this._relatedInfo.domNode);

            // create a blank related info panel
            this.blankRelatedInfo = new com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoPanel();
            this._relatedInfo.setCurrentPanel("_BLANK", this.blankRelatedInfo)

            this._getRelatedLinks();       		
		},
		
		_getRelatedLinks: function(infoPanel) {
			infoPanel = infoPanel ? infoPanel : this._relatedInfo;
            //set default related links
            var self = this;  
            this._relatedLinks = Constants.RELATED_LINKS_PREFERENCE_DEFAULTS.concat([]);  //copy the array                          
            var handlerObj = {
                success: function(preference) {
                    if (preference != null) {
                        self._relatedLinks = dojo.fromJson(preference.value);
                    }
                    self._addRelatedLinks(infoPanel);
                },
                
                error: function(error) {
                    console.error(error);                   
                    self._addRelatedLinks(infoPanel);
                    self._relatedInfo.addAction(Constants.getMessage("labelRelatedSites"), (function(){}), "Error Loading...", {});
                }
            }

            var option = new com.ibm.asq.common.web.client.internal.option();
            var handler = new ServiceResponseHandler(handlerObj, "success", "error");
            option.getProjectPreferences(handler, getCurrentProjectArea().itemId, Constants.RELATED_LINKS_PREFERENCE_KEY);			
		},
		
		_addRelatedLinks: function(infoPanel) {
			infoPanel = infoPanel ? infoPanel : this._relatedInfo;
			for (var i = 0; i < (this._relatedLinks ? this._relatedLinks.length : 0); i++) {
                infoPanel.addLink(Constants.getMessage("labelRelatedSites"), this._relatedLinks[i].name, this._relatedLinks[i].url);				
			}
		},
		
		showActionBar: function(userPreference)
		{
			var dispatcherName = root + "actionDispatcher";
			
			this.actionBarIsHorizontal = false;
			if(userPreference.key == Constants.USER_UI_CUSTOMISE_ACTIONBAR_CATEGORY.key){
				this.actionBarIsHorizontal = (userPreference.value == "actionBarHorizontal");
			}

            var menuBarContainer = dojo.byId("rqm-global-task-bar");
            if (this.actionBarIsHorizontal && menuBarContainer) {
                // create the horizontal menu bar
                this._menuBar = new com.ibm.rqm.planning.web.ui.internal.view.common.ActionBar();
                this._menuBar.initialize(this._contentArea, this._popupMenuArea, dispatcherName, true);
            
                // append menu bar to QMPage by DOM element id
                menuBarContainer.appendChild(this._menuBar.getMenuBar().domNode);
                
                // check if the Home button is created and relocate it to be part of the menu bar
                // for accessability
                var activeHomeButton = dojo.getObject("com-ibm-rqm-planning-web-home-widget");
                if (activeHomeButton) {
                    this._menuBar.getMenuBar().addChild(activeHomeButton, 0);
                }
            } else {
                this.actionBarIsHorizontal = false;
                // ===================================================================================================
                // TODO: need to update preference storage that it is now vertical if it is not already vertical
                // ===================================================================================================

                // create the vertical action bar
                this._actionBar = new com.ibm.rqm.planning.web.ui.internal.view.common.ActionBar();
                this._actionBar.initialize(this._contentArea, this._popupMenuArea, dispatcherName);
                this._actionBarArea.appendChild(this._actionBar.domNode);
            }
			
			// update the display to render proper style and hide the not used action bar
            //
            var _bannerBottom = dojo.byId("rqm-banner-bottom");
            var _leftIconBottom = dojo.byId("rqm-left-icon-bottom");
            var _titleImageBottom = dojo.byId("rqm-title-image-bottom");
            var _rightImageBottom = dojo.byId("rqm-right-image-bottom");

            // update 2 pixel top of the global task bar that is not part of the action bar
            if (_bannerBottom)
                _bannerBottom.className = "banner-bottom-" + (this.actionBarIsHorizontal ? "horizontal" : "vertical");
            if (_leftIconBottom)
                _leftIconBottom.className = "left-icon-bottom-" + (this.actionBarIsHorizontal ? "horizontal" : "vertical");
            if (_titleImageBottom)
                _titleImageBottom.className = "title-image-bottom-" + (this.actionBarIsHorizontal ? "horizontal" : "vertical");
            if (_rightImageBottom)
                _rightImageBottom.className = "right-image-bottom-" + (this.actionBarIsHorizontal ? "horizontal" : "vertical");
        
            // update background of the global task bar to reflect the action bar
            var _globalTaskBar = dojo.byId("rqm-global-task-bar");
            if (_globalTaskBar)
                _globalTaskBar.className = "global-task-bar-" + (this.actionBarIsHorizontal ? "horizontal" : "vertical");
				
			//set rtl attribute:
			if(dojo.isFF == 2)
				this.switchBidiContentArea(this.openRelatedInfo);
        },
    
        showCurrentQuery: function()
        {            
            window.location.hash = "#action=" + root + Dispatcher + "&subAction=" + HomeViewAction;
        },
        
		showUserDashboard: function( data )
		{
			if (!this._homePageCreated) {
				this.homePage = new com.ibm.rqm.planning.web.ui.internal.page.home.DashboardHomePage();

                // adjust the vertical action bar top right corner cap position here because we
                // have to make sure the action bar is added to the DOM tree to determine its width
                if (!this.actionBarIsHorizontal) {
                    // vertical action bar only not horizontal
                    var verticalActionBarCap = dojo.byId("rqm-vertical-actionbar-cap");
                    // the corner cap is defined in the header banner of QMPage
                    if (verticalActionBarCap) {
                        var actionBarWidth = this._actionBar._actionBar.clientWidth;
                        // set left offset of the corner cap for the banner product icon on its left
                        verticalActionBarCap.style.marginLeft = (actionBarWidth - 49) + "px";
                        // show it, the default is hidden for horizontal action bar
                        verticalActionBarCap.style.display = "block";
                    }
                }

			}
			
			var userItemId = dojo.getObject("com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR").itemId;
			
			this.homePage.showPrivateDashboard(userItemId, data[ "id" ], data[ "tab" ] );
				
			if( !this._homePageCreated )
			{
				var args = {};
				
				args = {
					name: Constants.getMessage("labelHome"),
					uri: "#action=" + root + Dispatcher + "&subAction=" + HomeViewAction,
					noSelect: true,
					content: this.homePage
				};					
				
				var page = this._contentArea.addPage(args, 0);
				
				page.homePage = this.homePage;
				
				this._homePageCreated = true;
			}
            this.updateHomeButton(true);
		},
		
        onTabContainerStartup: function() {
            window.resizeBy(0, 1);
            window.resizeBy(0, -1);
        },
        
        updateHomeButton: function(homeTabSelected) {
            var activeHomeButton = dojo.getObject("com-ibm-rqm-planning-web-home-widget");
            if (activeHomeButton) {
                activeHomeButton.setDisabled(homeTabSelected);
                if (!homeTabSelected)
                    // Dojo button "_focused" flag is set when set disabled from clicking
                    // the home button.  Need to clear it when set enabled.
                    activeHomeButton._focused = false;

            }
        },

        // Handler that is called when a page (a view in the tabbed content area)
        // is selected.
        //
        onSelectTab: function(page) {
            if (!page) {
                return;
            }
			
			if( dojo.isIE && page.domNode.childNodes.length == 1 )
			{
				//For some reason hiding the non-selected tabs does not
				//work for the dashboard page, when the dashboard as been
				//added to it.  If the dashboard page is also not displayed, then
				//the tab to display can be set correctly by the widget.
				//Unhiding the homePage (dashboard page)
				page.domNode.childNodes[ 0 ].style.display = "";
			}
			
            var staticPanel = null;
            
            // clear the related info with blank panel
            //
            this._relatedInfo.setCurrentPanel("_BLANK", this.blankRelatedInfo);
            
            // check the page if it use static related info content pane
			var widget = page.contentWidget;
            if (widget && dojo.isFunction(widget.getStaticRelatedInfo)) {
                // there is static related info pane for the page
                staticPanel = widget.getStaticRelatedInfo();                
                if (staticPanel) {
                    if (!staticPanel.addedDefalutRelatedLinks) {
                        // If the 'Related Sites' group exists, do not clear it out.  Duplicate links will be ignored.
                        // Add the default related sites links from the preference to the static panel.
                        this._addRelatedLinks(staticPanel);
                        //this._getRelatedInfo(); //TODO - auto refresh from admin pref. every time ?
                        
                        // add the default related info links only once from preference
                        staticPanel.addedDefalutRelatedLinks = true;
                    }
                    
                    // put up the static related info panel as current panel
					var id = dojo.isFunction(widget.getStaticRelatedInfoId) ? widget.getStaticRelatedInfoId() : null;
                    this._relatedInfo.setCurrentPanel(id ? id : page.title, staticPanel);
//                    console.debug(" - used static related info panel from page");
                }
            }

            // check the page if it use method to set up the related info only if there is no static panel
            if (!staticPanel) {
                if (widget && dojo.isFunction(widget.setupRelatedInfo)) {
                    var dynamicPanel = this._relatedInfo.getDynamicPanel(true);

                    // pass the blank dynamic info panel to the page to set up
                    widget.setupRelatedInfo(dynamicPanel);
                    console.debug(" - page is setting up the dynamic related info panel");
                    // ensure there is something in the panel before setting it into the related info area
                    if (!dynamicPanel.isEmpty()) {
                        this._relatedInfo.setCurrentDynamicPanel();
                    } else {
//                        console.debug(" - but nothing is added, skip to use the default panel");
                    }
                }
            }
			
			//If a widget has the onActivated method then call it.  This is particularly for InventoryView because the uri stays the same
			//and just bringing the page to the top does not make the page update for the new deploying of a virtual image.
			if(widget && dojo.isFunction(widget.onActivated)) {
				page.contentWidget.onActivated();
			}
			if( page.homePage )
			{
				//Put back the body click handler that was removed when moving away from the dashboard
				//See DashboardPage.navigateAwayEvent.  This also will add back the class that is needed
				//for the dashboard functionality to work properly.
				if( page.homePage._checkNavigateAwayHandle )
					page.homePage._checkNavigateAwayHandle();
				
				net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(page.homePage.getDashboardTitle());
				net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = document.title;
			}else if (page.browserTitle) {
				net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(page.browserTitle);
				net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = page.browserTitle;
			}			
			// update the home button
            this.updateHomeButton(page.homePage);
        },
				
		switchBidiContentArea: function(hasRelatedInfo) {
			if (EditorUtil.isDirectionRtl()) {
				var wide = dojo.marginBox(this.domNode).w;
				this._centerArea.className = "contentarea-rtl"
				if(this.actionBarIsHorizontal){
					if(hasRelatedInfo) {
						this._centerArea.style.width = wide - 222 + "px";
					}
					else {
						this._centerArea.style.width = wide - 22 + "px";
					}
				}
				else {
					if(hasRelatedInfo) {
						this._centerArea.style.width = wide - 293 + "px";
					}
					else {
						this._centerArea.style.width = wide - 93 + "px";
					}
				}
			}
		}
	});
})();
