/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractContentArea");

(function(){
	var ServiceResponseHandler		= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var Constants 					= com.ibm.rqm.planning.web.client.internal.Constants;
	var PreferenceClient 			= com.ibm.rqm.planning.web.client.internal.PreferenceClient;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractContentArea, {
        
		// need to overwrite the templateString in the concrete class
		templateString: '<div>' +
				        '<table>' +
				        '<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp"></span></td></tr>' +
				        '<tr><td><div dojoAttachPoint="_content">' +
				        '</div></td></tr>' +
				        '</table>' +
				        '</div>',
        
		// need to set a valid Category key in the concrete class.
		key: null,
		
        userPreference: [],
		
		//This method is only for display radio button. If this method is not enough, please overriden it.
		displayUserPreference: function(userPreference){
			for(var i = 0; i < userPreference.length; i++){
				if(this[userPreference[i].value])
                    	this[userPreference[i].value].setChecked(true);
			}
		},
		
		
		//@abstract  MUST be overriden, return the values in concrete class
		//  Example: 
		//     returen [{
        //         key: Constants[key].key,
        //         value: this.TOCAllSection.getValue()
        //     }];
		//
        getValues: function(){
			
        },
		
		//
		// @abstract 
		// If this preference need logout/login to become active, return true. Or, return false. 
		//
		isHotSwitchable: function(){
			return true;
		},
		
		// @override for AbstractContentArea
        setText: function(){
			
        },
		
		// @override for AbstractContentArea
		setContent: function(){

        },
		
		setOldValues: function(userPreference){
			this.userPreference = userPreference;
		},
		
		getOldValues: function(){
			return this.userPreference;
		},
		
		getDefaultValues: function(){
			return [Constants[this.key]];
		},
		
		restoreDefault: function(){
			this.displayUserPreference(this.getDefaultValues());
		},
		
		matchingDefalutValues: function(){
			if(dojo.toJson(this.getDefaultValues()) == dojo.toJson(this.getValues())){
				return true;
			}else{
				return false;
			}
		},
		
		matchingOldValues: function(){
			if(dojo.toJson(this.getOldValues()) == dojo.toJson(this.getValues())){
				return true;
			}else{
				return false;
			}
		},
		
		// set the corresponding user preference for this content area
		setUserPreference: function(userPreference){
			for(var i = 0; i < userPreference.length; i++){
				if(userPreference[i].key == Constants[this.key].key){
					this.setOldValues([userPreference[i]]);
				}
			}
			this.displayUserPreference(this.getOldValues());
		},
		
        _addCSHelpID: function(){
            var csHelp = new com.ibm.asq.common.web.ui.internal.util.CSHelp();
            csHelp.contextID = this.csHelpId;
             if(this.csHelpLabel) {
                csHelp.setButtonLabel(this.csHelpLabel);
            }
            this._cshelp.appendChild(csHelp.domNode);
        },
		
		_error: function(e){
			if(e && e.message){
				console.debug("Error in AbstractPreferenceContentArea: " + e.message);
			}
		}
    });
    
})();
