/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyEditor");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );

(function(){
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
   	var SelectUtility = dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );

    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyEditor", [dijit._Widget, dijit._Templated], {
        templateString: '<div class="com-ibm-rqm-test-administrator">' +
                        '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                        '   <table dojoAttachPoint="_tableNode" class="top-table">' +
                        '       <tr><td colspan="2"><span dojoAttachPoint="_title" class="title"></span></td></tr>' +
                        '       <tr>' + 
                        '           <td class="selector">' +
                        '                  <label><select dojoAttachPoint="_nameSelector" size="15" class="table-content"></select></label>' +
                        '           </td>' +
                        '           <td class="content-area" dojoAttachPoint="_contentArea">' +
                        '           </td>' + 
                        '       </tr>' + 
                        '       <tr align="right"><td colspan="2" class="button-area" align="right" dojoAttachPoint="_buttonArea"></td></tr>' +
                        '   </table>' +
                        '  </div>' +
                        '</div>',
						
		widgetsInTemplate: true,
        
        labelSelectArea: Constants.getMessage("labelSelectArea"),
        defaultProperty: "", //default selection name
        _nameContentPairs: [],
        
        postCreate: function(){
            this.setTitle();
            this.setNameContentPairs();
            this.setButtonArea();
            
            this._initNameSelector();
            this._initEvent();
            this._displayDefaultContent();
        },
        
        setTitle: function(){
			this.viewHeaderNode.setTitle(this.headerTitle);
        },
        
        /*
         * Abstract
         */
        setNameContentPairs: function(){
        
        },
        
        /*
         * Abstract
         */
        setButtonArea: function(){
        
        },
        
        _initEvent: function(){
            dojo.connect(this._nameSelector, "onchange", this, "displayContent");
        },
        
        _initNameSelector: function(){
            dojox.data.dom.removeChildren(this._nameSelector);
//            this._nameSelector.size = this._nameContentPairs.length;
            for (var i = 0; i < this._nameContentPairs.length; i++) {
                var option = new Option(this._nameContentPairs[i].name, this._nameContentPairs[i].name);
				option.tabindex = "-1";
				option.title = this._nameContentPairs[i].name;
				option.selected = (this.defaultProperty == this._nameContentPairs[i].name);
				SelectUtility.add( this._nameSelector, option );
            }
        },
        
        _displayDefaultContent: function(){
            dojox.data.dom.removeChildren(this._contentArea);
            for (var i = 0; i < this._nameContentPairs.length; i++) {
                if (this._nameContentPairs[i].name == this.defaultProperty) {
                    this._contentArea.appendChild(this._nameContentPairs[i].content.domNode);
                    this._currentContentArea = this._nameContentPairs[i].content;
                    this._initDisplayContentArea();
                    break;
                }
            }
        },
        
        displayContent: function(){
            dojox.data.dom.removeChildren(this._contentArea);
            var name = this.getName();
            for (var i = 0; i < this._nameContentPairs.length; i++) {
                if (this._nameContentPairs[i].name == name) {
                    this._contentArea.appendChild(this._nameContentPairs[i].content.domNode);
                    this._currentContentArea = this._nameContentPairs[i].content;
					this._initDisplayContentArea();
                    break;
                }
            }
        },
        
		_initDisplayContentArea: function() {
            if(this._currentContentArea.refresh && dojo.isFunction(this._currentContentArea.refresh))
               this._currentContentArea.refresh();
		},
		
        getCurrentContentArea: function(){
            return this._currentContentArea;
        },
        
        getName: function(){
            var name = this._nameSelector.value;
            //        for (var i = 0; i < this._nameSelector.options.length; i++) {
            //            if (this._nameSelector.options[i].selected) {
            //                var name = this._nameSelector.options[i].value;
            //                break;
            //            }
            //        }
            return name;
        }
    });
    
})();
