/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.CPUNumberContentArea");

dojo.require("dijit.form.ValidationTextBox");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.CPUNumberTableViewer");

(function(){
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var ServiceResponseHandler  = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var KEY = Constants.GLOBAL_SOFT_CPU_LIMIT;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.CPUNumberContentArea", [com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPropertyContentArea], {
//        templateString: '<div>' +
//        '<table>' +
//        '<tr><td class="content-name"><span dojoAttachPoint="_name"></span></td></tr>' +
//        '<tr><td class="content-text"><span dojoAttachPoint="_text"></span><span dojoAttachPoint="_cshelp"></span></td></tr>' +
//        '<tr><td><div dojoAttachPoint="_content">' +
//		'<table>' +
//		'<tr><td>${labelCPULimit}</td><td><label><input type="text" width="300px" dojoAttachPoint="_cpuLimit"' +
//        '        dojoType="dijit.form.ValidationTextBox"' +
//        '        regExp="^\\d+$"' +
//        '        required="true"' +
//        '        invalidMessage="${labelOnlyNonnegativeInteger}" /></label>' +
//		'</td></tr>' +
//		'<tr><td>${labelCPUCount}</td><td dojoAttachPoint="_cputCount"></td></tr>' +
//		'</table>' + 
//		'</div></td></tr>' +
//        '</table>' +
//        '</div>',
        
		widgetsInTemplate: true,
        name: "",
        text: "",
        content: "",
        csHelpId: "rqm_admin_global_cpu.html",
        csHelpLabel: Constants.getMessage("labelGlobalCPULimitationHelp"),
		labelCPULimit: Constants.getMessage("labelCPULimit"),
		labelCPUCount: Constants.getMessage("labelCPUCount"),
		labelOnlyNonnegativeInteger: Constants.getMessage("labelOnlyNonnegativeInteger"),

        setName: function(){
            this.name = Constants.getMessage("labelCPUNumber");
            dojox.data.dom.removeChildren(this._name);
            var name = document.createTextNode(this.name);
            this._name.appendChild(name);
        },
        
        setText: function(){
            this.text = Constants.getMessage("labelSetCPUNumber");
            dojox.data.dom.removeChildren(this._text);
            var text = document.createTextNode(this.text);
            this._text.appendChild(text);
        },
        
        setContent: function(){
			var args = {
				parent: this,
//				saveActionHandler: dojo.hitch(this, "_handleSaveClick"),
				refreshActionHandler: dojo.hitch(this, "_getSystemOptions")
			}
			dojox.data.dom.removeChildren(this._content);
			this.CPUNumberTableViewer = new com.ibm.rqm.planning.web.ui.internal.view.administration.CPUNumberTableViewer(args);
			this.CPUNumberTableViewer.initialize();
			this._content.appendChild(this.CPUNumberTableViewer.domNode);
            net.jazz.ajax.core.internal.loader.load_async("com.ibm.rational.test.lm.web.client.internal.admin", dojo.hitch(this, "_getSystemOptions"));
        },
        
        //@Abstract: Override to refresh the table when we're in display.
        refresh: function(){
			if(this.CPUNumberTableViewer)
                this.CPUNumberTableViewer.refreshContent();
        },

		_getSystemOptions: function(){
			var admin = new com.ibm.rational.test.lm.web.client.internal.admin();
			var responsehandler = new ServiceResponseHandler(this, "_displayCPULimitation", "_error")
			admin.getSystemOptions(responsehandler);
		},
		
//		_displayCPULimitation: function(options){
//			this._cpuLimit.setValue(options.globalCpuSoftLimit);
//			this._cputCount.appendChild(document.createTextNode(options.numGlobalCpus));
//		},
		
		_displayCPULimitation: function(options){
			this.options = options ? options : null;
			if(this.CPUNumberTableViewer){
				this.CPUNumberTableViewer.refresh(options.globalCpuSoftLimit, options.numGlobalCpus);
				this.setDirty(false);
			}
		},
		
		_handleSaveClick: function(){
			var option = new com.ibm.asq.common.web.client.internal.option();
			var self = this;
			
			var saveProjectPreferences = function(optionItemId){
				var handler = {
					success: function(results){
						self.parent.saveFinished();
						self._getSystemOptions(results);
					},
					error: function(e){
						self.parent.saveFinished();
						self._error(e);
					}
				}
		
				var responsehandler = new ServiceResponseHandler(handler, "success", "error");
				if(optionItemId){
					option.updateGlobalPreferences(responsehandler, optionItemId, dojo.toJson(self.CPUNumberTableViewer.getGlobalCpuSoftLimit()));
				}else{
					option.createGlobalPreferences(responsehandler, KEY, dojo.toJson(self.CPUNumberTableViewer.getGlobalCpuSoftLimit()));
				}
				self.setDirty(false);
			};
			
			var handler = {
				success: function(option){
					//start save
					self.parent.addSaveParticipantNum();
					var optionItemId = (option && option.itemId) ? option.itemId : null
					saveProjectPreferences(optionItemId);
				},
				error: function(){
					self._error();
				}
			}
			var responseHandler2 = new ServiceResponseHandler(handler, "success", "error");
			option.getGlobalPreferences(responseHandler2, KEY);
		},
		
        getValues: function(){
            return [{
				key: KEY,
				value: this.CPUNumberTableViewer.getGlobalCpuSoftLimit()
			}];
        },
        
        _addCSHelpID: function(){
            var csHelp = new com.ibm.asq.common.web.ui.internal.util.CSHelp();
            csHelp.contextID = this.csHelpId;
            this._cshelp.appendChild(csHelp.domNode);
			csHelp.setButtonLabel(Constants.getMessage("labelGlobalCPULimitationHelp"));
        },
		
		onSave: function(){
			this._handleSaveClick();
		},
		
		_error: function(error){
            var message = error && error.message ? error.message : Constants.getMessage("msgSysPropErrorNoDetails");
            this.setErrorMessage(Constants.getMessage("msgSysPropError"), message);
		}
    });
    
})();
