/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.RelatedInformationContentArea");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");

(function(){
	var ServiceResponseHandler			= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.RelatedInformationContentArea", com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea, {
        templateString: '<div>' +
				        '<table>' +
				        '<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp"></span></td></tr>' +
				        '<tr><td><div dojoAttachPoint="_content">' +
				        '<table>' +
						'	<tr><td>' +
				        '			<label><input type="checkbox" dojoAttachPoint="relatedInfoOpen" name="relatedinfo" dojoType="dijit.form.CheckBox"/><span style="float:left" class="pref-relatedinfo-icon-24"></span><span>${labelOpenRelatedInfo}</span> </label>' +
				        '	</td></tr>' +
						'	<tr><td>' +
				        '			<label class="note-text">${labelNote}</label><label class="note-text">${msgPreferenceBeActive}</label>' +
				        '	</td></tr>' +
				        '</table>' +
				        '</div></td></tr>' +
				        '</table>' +
				        '</div>',
        
		key: Constants.USER_UI_CUSTOMISE_ACTIONBAR_RELATEDINFO_CATEGORY.key,
		widgetsInTemplate: true,
		
		labelOpenRelatedInfo: Constants.getMessage("labelOpenRelatedInfo"),
		labelNote: Constants.getMessage("labelNote"),
		msgPreferenceBeActive: Constants.getMessage("msgPreferenceBeActive"),
		
		postCreate: function(){
			this.csHelpId = "rqm_pref_related_info.html";			
            this.csHelpLabel = Constants.getMessage("labelRelatedInfoHelp");
            
			this.inherited("postCreate", arguments);
			dojo.connect(this.relatedInfoOpen, "onChange", this, "onChange");
		},
		
		// @override for AbstractContentArea
		displayUserPreference: function(userPreference){
			for(var i = 0; i < userPreference.length; i++){
                this.relatedInfoOpen.setChecked(userPreference[i].value);
			}
		},
        
		// @override for AbstractContentArea
        setName: function(){
			dojox.data.dom.removeChildren(this._name);
            this._name.appendChild(document.createTextNode(Constants.getMessage("labelRelatedInformation")));
        },
		
		// @overrie for AbstractPreferenceContentArea
        getValues: function(){
            return [{
                key: this.key,
                value: this.relatedInfoOpen.checked
            }];
        },
		
		// @overrie for AbstractPreferenceContentArea
		isHotSwitchable: function(){
			return false;
		}
    });
    
})();
