/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Load: com.ibm.rqm.planning.web.ui.internal.view.administration.RequirementConnectionTableViewer");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.RequirementConnectionTableViewer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var YesNoDialog = com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
	
    dojo.declare("RequirementConnectionTableViewer.TableListener", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
        constructor: function(parentView) {
	        this.parentView = parentView;
	    },
    
    	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    	{
        	if (callback != null && dojo.isFunction(callback)) {
		        callback();
		   	}  
    	},
		
		// Summary:
	    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
	    //   called.
	    //
	    rowCheckStateChanged: function(tableViewer, rowObject, state)
	    {
			var selectionCount = tableViewer.getCheckedRows().length;
	        if (this.parentView.removeActionNode)
	            this.parentView.removeActionNode.setDisabled(selectionCount == 0);
			if (this.parentView.testActionNode)
				this.parentView.testActionNode.setDisabled(selectionCount != 1);
			if (this.parentView.synchronizeActionNode)
				this.parentView.synchronizeActionNode.setDisabled(selectionCount != 1 || rowObject.itemId < 0);
			if (this.parentView.startSyncNowNode)
				this.parentView.startSyncNowNode.setDisabled(selectionCount != 1 || rowObject.itemId < 0);
	    }
    });
    
    dojo.declare("RequirementConnectionTableViewer.CellModifier", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier, {
        tableViewer: null,
		
		constructor: function(parentView)	{
	        	this.parentView = parentView;
	    },
        
        cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
            switch (columnIndex) {
                case 0:
                    rowObject.hostname = newValue;
//					this.parentView.saveActionNode.setDisabled(false);
					this.parentView.parent.setDirty(true);
                    break;
                case 1:
                    rowObject.port = newValue;
					this.parentView.parent.setDirty(true);
                    break;
                default:
                    break;
            }
        },
		
		cellActionInvoked: function(rowObject, columnIndex)
	    {
//			if(columnIndex == 2) {
//				this.parentView._handleStopSynchronization(rowObject);
//			}
	    }
    });
    
    dojo.declare("RequirementConnectionTableViewer.TableProvider", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, {
        getNumColumns: function(content){
            return 3;
        },
        
        getColumnHeading: function(content, index){
            var headings = [Constants.getMessage("labelReqProConnHostName"), Constants.getMessage("labelReqProConnPortNum"), Constants.getMessage("labelReqProSynStatus")];
            return headings[index];
        },
        
        getIsColumnSortable: function(content, atColumnIndex){
            return true;
        },
		
        getColumnWidth: function(content, atColumnIndex){
            var width = 2;
            switch (atColumnIndex) {
                case 0:
                    width = 50;
                    break;
                case 1:
                    width = 45;
                    break;
				case 2:
                    width = 5;
                    break;
            }
            return width;
        },
		
        getIsCellEditable: function(rowData, atColumnIndex){
			if(atColumnIndex < 2){
				return true;
			}else{
				return false;
			}
        },
        
        // Summary:
        //    The only assumptions the table have on the data that it displays
        //    is that it's an array contents. These are the data content/object that
        //    will be displayed in the table rows.
        //
        getContentObjects: function(content){
            // our content is already an array of objects
            return content;
        },
        
        getRowDataId: function(rowData){
            return rowData.itemId;
        },
        
        // Summary:
        //    Returns the type of the cell to be displayed. By default, the TableViewer
        //    will support a set of cell types. The type of the cell will map to a specific
        //    cell renderer (to be discussed).
        getCellDisplayType: function(rowData, atColumnIndex){
			if(rowData.itemId < 0 && atColumnIndex < 2){
				return TableConstants.RENDER_TYPE_EDITABLE_TEXT;
			}else{
				return TableConstants.RENDER_TYPE_TEXT;
			}
        },
        
        // Summary:
        //    Returns the display data of the cell. For cell renderer type of TEXT, this will
        //    be the string. Others cell render type would be Date, or integer value, etc. If the 
        //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
        //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
        //    cell types such as image where it could have multiple values for different states, the 
        //    client also needs to implement the next method.
        //    
        //    Client must implement this method to provide the cell data.
        //    
        getCellDisplayData: function(rowData, atColumnIndex){
            var val = "data";
            switch (atColumnIndex) {
                case 0:
                    val = rowData.hostname;
                    break;
                case 1:
                    val = rowData.port;
                    break;
				case 2:
                    if(rowData.syncStopped === ""){
						val = rowData.syncStopped;
					}else if(rowData.syncStopped === true){
						val = Constants.getMessage("labelReqProStartSyn");
					}else{
						val = Constants.getMessage("labelReqProStopSyn");;
					}
                    break;
            }
            return val;
        },
		
		getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
	    {  
	        var val = null;
//	        if(atColumnIndex == 2){
//				val = {};
//				if(rowData.syncStopped === false){
//					val.image = ImageCache.PAUSE_ICON;
//				}else if(rowData.syncStopped === true){
//					val.image = ImageCache.RESUME_ICON;
//				}
//			}
	        return val;
	    }  
    });
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.RequirementConnectionTableViewer", [dijit._Widget, dijit._Templated], {
        templateString: '<div dojoAttachPoint="domNode" tabindex="-1"></div>',
        widgetsInTemplate: true,
        
        constructor: function(args){
            this.content = null;
			this.newItemId = -1;
			this.newConnections = [];
        },
        
        postCreate: function(){
            this.inherited("postCreate", arguments);
        },
        
        initialize: function(args){
//			this.parentController = args.parentController;
            var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
			tableViewer.actionsTD.setAttribute("nowrap", "nowrap");
            this.domNode.appendChild(tableViewer.domNode);
            this.tableViewer = tableViewer;
			
            var contentProvider = new RequirementConnectionTableViewer.TableProvider();
            
            tableViewer.setContentPageSize(20);
			tableViewer.addAction("add", Constants.getMessage("labelReqProAddConn"), null, "add-icon-image", dojo.hitch(this, "_handleAddNewClick"));
    		this.removeActionNode = tableViewer.addAction("remove", Constants.getMessage("labelReqPeoRemoveConn"), null, "delete-icon-image", dojo.hitch(this, "_handleDeleteClick"));
			this.removeActionNode.setDisabled(true);
			this.testActionNode = tableViewer.addAction("test", Constants.getMessage("labelReqProTestConn"), null, "test-connection-icon-image", dojo.hitch(this, "_handleTestClick"));
			this.testActionNode.setDisabled(true);
			this.synchronizeActionNode = tableViewer.addAction("synchronize", Constants.getMessage("labelEnableSynch"), null, "sychronize-icon-image", dojo.hitch(this, "_handleStopSynchronization"));
			this.synchronizeActionNode.setDisabled(true);
			this.startSyncNowNode = tableViewer.addAction("startSyncNow", Constants.getMessage("labelSyncNow"), null, "syncnow-icon-image", dojo.hitch(this, "_handleSynchronizeNow"));
			this.startSyncNowNode.setDisabled(true);
//			this.saveActionNode = tableViewer.addAction("save", Constants.getMessage("labelReqProSaveConn"), null, "save-icon-image", dojo.hitch(this, "_handleSaveClick"));
//			this.saveActionNode.setDisabled(true);
			tableViewer.addAction("refresh", Constants.getMessage("labelReqProRefreshConn"), null, "refresh-icon-image", dojo.hitch(this.parent, "loadConnections"));
            
			tableViewer.setContent(this.content);
            tableViewer.setContentProvider(contentProvider);
			tableViewer.setTableRowsCheckable(this.parent.isEditable(), /* isSingleSelect */ false);  
			tableViewer.setTableListener(new RequirementConnectionTableViewer.TableListener(this));
			tableViewer.setCellModifier(new RequirementConnectionTableViewer.CellModifier(this));
            tableViewer.show();
            tableViewer.setEditable(this.parent.isEditable());
        },
		
		refresh: function(connections) {
	      this.tableViewer.setContent(connections);
		  this.removeActionNode.setDisabled(true);
		  this.testActionNode.setDisabled(true);
		  this.synchronizeActionNode.setDisabled(true);
		  this.startSyncNowNode.setDisabled(true);
//		  this.saveActionNode.setDisabled(true);
	      this.tableViewer.show();
		  this.newItemId = -1;
		  this.newConnections = [];
		  this._refreshActionStatus();
	    },
		
		_refreshActionStatus: function() {
			this.removeActionNode.setDisabled(true);
			this.testActionNode.setDisabled(true);
			this.synchronizeActionNode.setDisabled(true);
			this.startSyncNowNode.setDisabled(true);
		},
        
        getSelectedConnections: function() {
	    	return this.tableViewer.getCheckedRows();
		},
		
		removeSelectedConnections: function(){
			var connections = this.getSelectedConnections();
			var newConnections = [];
			var deletedConnections = [];
			for(var i = 0; i < connections.length; i++){
				deletedConnections.push(connections[i]);
				var isNewConnectionRemoved = false;
				for(var j = 0; j < this.newConnections.length; j++){
					if(connections[i].itemId < 0 && connections[i].itemId == this.newConnections[j].itemId){
						isNewConnectionRemoved = true;
					}
				}
				if(isNewConnectionRemoved == false){
					newConnections.push(connections[i]);
				}
			}
			this.newConnections = newConnections;
			this.tableViewer.setContent(this._deleteItems(this.tableViewer.getContent(), deletedConnections));
			this.tableViewer.refresh();
			this._refreshActionStatus();
		},
		
		validateNewConnections: function(){
			var connections = this.tableViewer.getContent();
			for(var i = 0; i < connections.length; i++){
				if(connections[i].itemId < 0 && connections[i].hostname != "" && connections[i].port != ""){
					for(var j = 0; j < connections.length; j++){
						if(this._checkDuplication(connections[i], connections[j])){
							return Constants.getMessage("msgReqProSaveConn", connections[i].hostname, connections[i].port);
						}
					}
				}
			}
			return "";
		},
		
        _handleAddNewClick: function(){
			var obj = {
                hostname: "",
                port: "",
				syncStopped: "",
				itemId: this.newItemId
            };
			this.newItemId--;
			var content = this.tableViewer.getContent();
			content.push(obj);
            this.tableViewer.setContent(content);
            this.tableViewer.refresh();
            this._refreshActionStatus();
        },
		
		_handleDeleteClick: function(){
			var connections = this.getSelectedConnections();
			if(connections.length == 0){
				this._displayAlertDialog("", Constants.getMessage("msgReqProRemoveConn"));
				return;
			}
            var confirmMsg = "";
            if (connections.length > 1) {
                confirmMsg = Constants.getMessage("msgReqProPromoptRemoveConn", connections.length);
            } else {
                confirmMsg = Constants.getMessage("msgReqProPromoptRemoveConn1", connections[0].hostname);
            }
			var args = {
				title: "",
				message: confirmMsg,
				yesCallback: dojo.hitch(this.parent, "deleteConnection"),
				yesCallbackData: connections,
				noCallback: function(){
					return;	
				}
			}
			this._displayYesNoDialog(args);
		},
		
		_handleTestClick: function(){
			var connections = this.getSelectedConnections();
			if(connections.length > 1){
				this._displayAlertDialog("", Constants.getMessage("msgReqProTestConn"));
				return;
			}else if(connections.length == 0){
				this._displayAlertDialog("", Constants.getMessage("msgReqProTestConn1"));
				return;
			}
			if(dojo.isArray(connections) && connections.length == 1){
				this.parent.testConnection(connections[0]);
			}
		},
		
		_handleSaveClick: function(){
			var connections = this.tableViewer.getContent();
			this.newConnections = [];
			for(var i = 0; i < connections.length; i++){
				if(connections[i].itemId < 0 && connections[i].hostname != "" && connections[i].port != ""){
					this.newConnections.push(connections[i]);
				}
			}
			this.parent.saveConnection(this.newConnections);
		},
		
		_handleStopSynchronization: function(){
			var connections = this.getSelectedConnections();
			if(connections.length > 1){
				this._displayAlertDialog("", Constants.getMessage("msgSelectOnlyOneConn"));
				return;
			}else if(connections.length == 0){
				this._displayAlertDialog("", Constants.getMessage("msgSelectOneConn"));
				return;
			}else if(connections.length == 1 && connections[0].syncStopped !== ""){
				var actionType = "";
				if(connections[0].syncStopped === true){
					actionType = "enable";
				}else if(connections[0].syncStopped === false){
					actionType = "disable";
				}
				var args = {
					title: "",
					message: Constants.getMessage("msgReqProStopSyn", actionType, connections[0].hostname),
					yesCallback: dojo.hitch(this.parent, "stopSynchronization"),
					yesCallbackData: connections[0],
					noCallback: function(){
						return;
					}
				}
				this._displayYesNoDialog(args);
			}else{
				this._displayAlertDialog("", Constants.getMessage("msgReqProSaveConn1"));
			}
		},
		
		_handleSynchronizeNow: function() {
			var connections = this.getSelectedConnections();
			
			if(connections.length == 0) {
				this._displayAlertDialog("", Constants.getMessage("msgSelectOneConnToSync"));
				return;
			}else if(connections.length > 1) {
				this._displayAlertDialog("", Constants.getMessage("msgSelectOnlyOneConnToSync"));
				return;
			}else if(connections.length == 1) {
				var args = {
					title: "",
					message: Constants.getMessage("msgReqProSyncNow", connections[0].hostname),
					yesCallback: dojo.hitch(this.parent, "startSynchronization"),
					yesCallbackData: connections[0],
					noCallback: function() {
						return;
					}
				}
				this._displayYesNoDialog(args);
			}else{
				this._displayAlertDialog("", Constants.getMessage("msgReqProSaveConn1"));
			} 
		},
		
		_checkDuplication: function(firstConn, secondConn){
			if(firstConn.hostname == secondConn.hostname && firstConn.port == secondConn.port && firstConn.itemId != secondConn.itemId){
				return true;
			}else{
				return false;
			}
		},
		
		_deleteItems: function(items, deletedItems){
			var newItems = [];
			for(var i = 0; i < items.length; i++){
				var deleted = false;
				for(var j = 0; j < deletedItems.length; j++){
					if(items[i].itemId == deletedItems[j].itemId){
						deleted = true;
					}
				}
				if(!deleted){
					newItems.push(items[i]);
				}
			}
			return newItems;
		},
		
		_displayAlertDialog: function(title, message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.setSecondaryTitle(title);
            alertDialog.open();
        },
		
		_displayYesNoDialog: function(args){
            var dialog = new YesNoDialog(args);
            dialog.setSecondaryTitle(args.title);
            dialog.open();
        },
		
        _error: function(errorObj){
            alert(errorObj.message);
        }
    });
    
})();
