/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.PropertiesSection");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.PropertiesSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

(function(){

//    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var EWIClient = com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var CSHelp 	  = com.ibm.asq.common.web.ui.internal.util.CSHelp;
	
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.PropertiesSection", [dijit._Widget, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.configuration.web", "ui/internal/view/templates/configuration/PropertiesSection.html"),
        
		labelGenerationProperties: Constants.getMessage("labelGenerationProperties"),
		
        constructor: function(args, frag){
            if (args.controller == null) {
                throw new Error("PropertiesSection#constructor: Missing required parameter 'args.controller'");
            }
			this.showWorkItemDistribution = (args.showWorkItemDistribution) ? args.showWorkItemDistribution : false;
            this.controller = args.controller;
			this._genProCsHelpId = "rqm_ex_ewi_coverage.html";
        },
        
        postCreate: function(){
			this._initTemplateLabel();
            this._initTC();
			this._initWorkItemDistribution();
			this._initCSHelp();
        },
		
		_initTemplateLabel: function(){
			this._CoverageLabel.appendChild(document.createTextNode(Constants.getMessage("labelCoverage") + ":"));
			this._coverageOption1.appendChild(document.createTextNode(Constants.getMessage("labelCoverageOption1")));
			this._coverageOption2.appendChild(document.createTextNode(Constants.getMessage("labelCoverageOption2")));
			this._coverageOption3.appendChild(document.createTextNode(Constants.getMessage("labelCoverageOption3")));
			this._coverageOptionAll.appendChild(document.createTextNode(Constants.getMessage("labelCoverageOptionAll")));
			this._WIDLabel.appendChild(document.createTextNode(Constants.getMessage("labelWorkItemDistribution") + ":"));
			this._workItemDisOption1.appendChild(document.createTextNode(Constants.getMessage("labelWorkItemDisOption1")));
			this._workItemDisOption2.appendChild(document.createTextNode(Constants.getMessage("labelWorkItemDisOption2")));
		},
        
        _initTC: function(){
            this.disableSelectOptions("coverage", [1]);
        },
        
		_initWorkItemDistribution: function(){
			if(!this.showWorkItemDistribution){
				dojo.addClass(this._applyToTestGroup, "hidden");
			}
		},
		
		_initCSHelp: function(){
			var csHelp = new CSHelp();
            csHelp.contextID = this._genProCsHelpId;
			csHelp.setButtonLabel(Constants.getMessage("labelEWICoverageCSHelp"));
            this._cshelp.appendChild(csHelp.domNode);
		},
		
        getCoverage: function(){
            var options = this._coverage.options;
            if (options) {
				var value;
                for (var i = 0; i < options.length; i++) {
                    if (options[i].selected) {
                        value = options[i].value;
                    }
                }
                return value;
            }
        },
		
        getWorkItemDistribution: function(){
            var options = this._workItemDis.options;
            if (options) {
				var value;
                for (var i = 0; i < options.length; i++) {
                    if (options[i].selected) {
                        value = options[i].value;
                    }
                }
                return value;
            }
        },
		
        disableSelectOptions: function(selectName, optionEnableValues){
            var options = null;
            if (selectName == "coverage") {
                this._coverage.disabled = true;
            }
        },
        
        enableSelectOptions: function(selectName, number/*The number of selected environment types in EnvironmentSection*/){
            var options = null;
            if (selectName == "coverage") {
                this._coverage.disabled = false;
                options = this._coverage.options;
            }
            if (options) {
                for (var i = 0; i < options.length; i++) {
					if(i < number || i == options.length -1){
						options[i].disabled = false;
					}else{
						options[i].disabled = true;
						options[i].selected = false;
					}
                }
            }
        },
        
        _error: function(errorObj){
            alert("Error: (message: '" + errorObj.message + "') from PropertiesSection#_error");
        }
    });
    
})();
