/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionScriptElementList");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionScriptElementList");

dojo.require("dojo.parser");
dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._editor.plugins.AlwaysShowToolbar");
dojo.require("dijit.Toolbar");
dojo.require("dijit.Menu");
dojo.require("dojo.dnd.Source");
dojo.require("net.jazz.ajax.ui.internal.HoverPopup");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function() { // module container

/* Jazz objects */
var ServiceResponseHandler 	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var DOWNLOAD_SERVICE_URI 	= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
var HoverPopup 				= net.jazz.ajax.ui.internal.HoverPopup;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

/* QM objects */
var TestScriptClient 		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var CSHelp					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
var RegistryClient 			= com.ibm.rqm.planning.web.client.internal.RegistryClient;
var ImageCache				= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var Editor 					= com.ibm.rqm.planning.web.ui.internal.view.construction.manualscripteditor.StatementEditor;
var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants;
var SelectUtility 			= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
var COMMENT_VIEW_TYPE		= "commentView";
var ATTACHMENT_VIEW_TYPE	= "attachmentView";
var COMPARE_VIEW_TYPE		= "compareView";

dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionScriptElementList",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/ExecutionScriptElementList.html"),
		// object initializer
		widgetsInTemplate: true,
		constructor: function(args){
			this._steps = [];
			this._elementTypes = [];
			this.lastClickedRow = "none";
			this.prevStepNum = -1;
			this.stepProperties = [];
			this.scriptObjects = [];
			this._connects = {};
		},

		postCreate: function() { 
			this.DEFAULT_STEP_TYPE = "Execution Step";
			this.ID_SUMMARY_ROW = this.id+"row_summary_step_";
			this.ID_EDITOR = this.id+"__stepEditor";
			this.ID_DETAIL_EDITOR_DIV = this.id+"row_detail_editor_div_";
			this.ID_TYPE_DROPDOWN = this.id+"dropdownIcon";
			this.ID_TYPE_DROPDOWN2 = this.id+"dropdownIcon2_";
			this.ID_STEP_TYPE = this.id+"_stepType";
			this.ID_KW_TYPE = this.id+"_kwType";
			this.ID_STEP_SUMMARY = this.id+"_stepSummary";
			this.ID_KW_SUMMARY = this.id+"_kwSummary";
			this.ID_ATTACH_CELL = this.id+"_attachCell";
			this.ID_COMMENT_CELL = this.id+"_commentCell";
			this.ID_COMPARE_CELL = this.id+"_compareCell";
			this._tooltips = [];
		},
		
		initialize: function(args) {
			if (args.parentController == null) {
				throw new Error("ExecutionScriptElementList#initialize: Missing required parameter 'parentController'");
			}
			this.stepProperties = [];
			this._steps = [];
			if ( args.steps != null && args.steps.length > 0 ) {
				for (var i = 0; i < args.steps.length; i++) {
					this._steps.push(args.steps[i]);
					this.stepProperties[i] = (args.steps[i].properties != null ? this._getPropertiesInArrayFormat(args.steps[i].properties) : []);	
				}				
			}	
			if(args.parentCallBack)
				this.parentCallBack = args.parentCallBack;		
			this._initElementTypes();
			this._createSplitContainer();
            dojo.subscribe("/dnd/drop",this, "_dndDrop");            
		},		
		
		isReadOnly: function() {
			if ((this.parentCallBack && dojo.isFunction(this.parentCallBack.isReadOnly))) {
				return this.parentCallBack.isReadOnly();
			}
			return false; //default to non read only mode
		},
		
        _dndDrop:function(source,nodes,iscopy,target){			
			if(source){
               if(nodes[0]["editorId"]){
				   	if(nodes[0]["editorId"] != this.id) // the keyword drop isnt meant for me
	                    return;
					this.parentCallBack._setEditorDirty(true);	
	                var row = target.anchor.nextSibling;
					if(!row)
						row = target.anchor.previousSibling;
					if(row){
						dojo.dnd.manager().target = null;
                        var item = source.getItem(nodes[0].id);
                        if(item){
                            var keyword = item.data.scriptObj;
                            if(row.id || row.id != ""){ // insert before an existing step/keyword
                                this._addKeyword(row,keyword,false,true);   
                            }else{ //insert before a "Click to Add... " row
                                this._addKeyword(null,keyword,false,true);
                            }
							this._showSteps();
                        }
	                }
				}
				else if(target.accept[this.ID_SUMMARY_ROW]){ // the steps drop is meant for me
					this.parentCallBack._setEditorDirty(true);				
					dojo.dnd.manager().target = null;
					this._preserveEditedContent();
					this._destroyEditor();
					var newSteps = [];
					var newProps = [];
					var stepNum = 0;
					for(var i=0;i<this._stepsTableBody.rows.length-1 ; i++){
						stepNum = this._getStepNumForRow(this._stepsTableBody.rows[i]);
						newSteps.push(this._steps[stepNum-1]);
						newProps.push(this.stepProperties[stepNum-1]);
					}					
					this._steps = newSteps;
					this.stepProperties = newProps;
					this._showSteps();
				}
            }
        },

        _createSplitContainer: function() {			
			if (!this.isReadOnly()) {
				this._kwView = new com.ibm.rqm.planning.web.ui.internal.view.construction.KeywordLibraryView({editor: this});
				this._kwContainer.appendChild(this._kwView.domNode);			
				this.stepsDndSource = new dojo.dnd.Source(this._stepsTableBody, {
					accept: [this.id, this.ID_SUMMARY_ROW],
					creator: this._dndCreator
				});
			} else {			
				//if read-only, no need to show keywords
				this._kwContainer.style.display = "none";
			}
			this._editorContainer.setAttribute("tabIndex", -1);
        },
		
		_showSteps: function() {
			dojox.data.dom.removeChildren(this._stepsTableBody);
			this.stepBeingEdited  = -1;
			this.lastClickedRow = "none";
			if (this.stepsDndSource) {
				this.stepsDndSource.clearItems();
			} else {
				dojox.data.dom.removeChildren(this._stepsTableBody);
			}
			this._destroyEditor();				
			if ( this._steps != null && this._steps.length > 0 ) {
				for ( var i = 0; i < this._steps.length; i++ ) {
					this._steps[i].num = i + 1;
					this._insertStepRow(null, this._steps[i], false);
				}
			}
			if (!this.isReadOnly()) {
				this._appendNewStepLinkRow();
			}
			var step1 = dojo.byId(this.ID_STEP_SUMMARY + 1);
			if(step1)
				step1.parentNode.focus();
		},
		
		updateSteps: function(steps) {
			this._steps = steps ? steps : this._steps;
			this.stepProperties = [];
			this._destroyEditor();
			for ( var i = 0; i < this._steps.length; i++ ) {
				this._steps[i].num = i + 1;
				this.stepProperties[i] = (this._steps[i].properties != null ? this._getPropertiesInArrayFormat(this._steps[i].properties) : []);
				var row = this._stepsTableBody.rows[i] ? this._stepsTableBody.rows[i] : null;
				this._insertStepRow(row, this._steps[i], false);
			}
			if(row){
				this.prevStepNum = this._getStepNumForRow(row) -1;
				this._createCurrentProperties(this.stepProperties[this._getStepNumForRow(row) -1])
			}
		},
		_getEmptyRow: function() {
			var row = document.createElement("tr");
			row.className = "steps-table-row";
			return row;
		},
		
		_getEmptyCell: function(span, align) {
			var cell = document.createElement("td");
			cell.className = "steps-table-cell";
			if ( span != null ) {
				cell.colSpan = span;
			}
			if ( align != null ) {
				cell.align = align;
			}
			return cell;
		},
		
		_buildDetailRow: function(step) {
			//build details row
			var detailsDiv = document.createElement("div");
			detailsDiv.id = this.ID_DETAIL_EDITOR_DIV + step.num;	
			dojo.addClass(detailsDiv, "step-detail-container");				
			if (step && step.content) {
				detailsDiv.innerHTML = unescape(step.content);
			}
			return detailsDiv;		
		},
		
		_attachEditor: function(id) {
			var heightValue= '';
			var nodeId = this.ID_DETAIL_EDITOR_DIV + id;
			var attachNode = dojo.byId(nodeId);
			if(!attachNode){
				this.stepBeingEdited  = -1;
				this._changeBGColor();
				this.lastClickedRow = "none";
				return;
			}
			this.stepBeingEdited = id;
			if(!this.editor){
				if(!this.toolbar || !this.toolbar.domNode){
					//toolbar domnode becomes null when editor cannot be destroyed completely.
					this.toolbar = new dijit.Toolbar();
					dojox.data.dom.removeChildren(this._editorHeader);	
					this._editorHeader.appendChild(this.toolbar.domNode);
				}
				var args = {
					height: '',
					minHeight: '25px',
					focusOnLoad: true,
					parentNodeId: this.ID_SUMMARY_ROW+id,
					parentWidget: this,
					extraPlugins: ['foreColor', 'hiliteColor', 'fontSize','insertimage', 
									'attachments','comments','pastecompare','datapool',
									'dijit._editor.plugins.AlwaysShowToolbar'],
					toolbar: this.toolbar,
					_editorCommandsLocalized:true
				};
				this.editor = new Editor(args, attachNode);
			}else{
				this.editor.endEditing(true);
				var prevEditorState = this.editor.getState();
				var prevAttachNode = this.editor.domNode;
				dojo.removeClass(prevAttachNode,"step-detail-container");
				var prevId = this.editor.domNode.id.split(this.ID_DETAIL_EDITOR_DIV)[1];
				prevId = parseInt(prevId,10);
				this.lastClickedRow = this.ID_SUMMARY_ROW +prevId;
				this._steps[prevId -1].content = escape(this.editor.getValue());
				this.editor.srcNodeRef = attachNode;
				this.editor.parentNodeId = this.ID_SUMMARY_ROW+id;
				this.editor.open(attachNode);
				var detailsDiv = this._buildDetailRow(this._steps[prevId -1]);
				prevAttachNode.parentNode.replaceChild(detailsDiv,prevAttachNode);
			}
			var content = this._steps[parseInt(id, 10) -1].content? unescape(this._steps[parseInt(id, 10) -1].content):"";
			this.editor.replaceValue(content);
			var row = dojo.byId(this.ID_SUMMARY_ROW+id);
			this._changeBGColor(row);
			setTimeout(dojo.hitch(this, this._updateToolBarState,prevEditorState), 100);//Not calling directly IE is not ready for it.
		},
		
		_updateToolBarState: function(state){
			if(state){
				this.editor.setState(state);
			}
			if(dojo.isIE)
				setTimeout(dojo.hitch(this.editor, function(){
					this._IEFocus();
				}), 400);
		},
		
		_insertRowinBetween:function(stepNumber,/*boolean*/before,stepType,/*in case of keyword*/keyword){
			var stepNum = parseInt(stepNumber, 10);
			var updatedSteps = [];
			var updatedProperties = [];
			var j = 0;
			for ( var i = 0; i < this._steps.length; i++ ) {
				if ( i != (stepNum - 1) ) {
					this._steps[i].num = j + 1;
					var id = i + 1;
					var typeNode = dojo.byId(this.ID_STEP_TYPE + id);		
					if(typeNode == null)
						typeNode = dojo.byId(this.ID_KW_TYPE + id);	
					if (typeNode.stepType) this._steps[i].elementType = this._getElementTypeByName(typeNode.stepType);
					updatedSteps.push(this._steps[i]);
					updatedProperties[j]= this.stepProperties[i];
					j = j + 1;
				}else if(i==stepNum-1) {
					var newstep;
					if(before == true){
						newstep = {num: j + 1};
						this._steps[i].num = j + 2;
					}
					else{
						this._steps[i].num = j + 1;
						newstep = {num: j + 2};
					}
					newstep.elementType = this._getElementTypeByName(stepType);
					newstep.content = "";
					newstep.summary = "";
					if(keyword)
						newstep.script = keyword;
					var id= i + 1;
					var typeNode = dojo.byId(this.ID_STEP_TYPE + id);		
					if(typeNode == null)
						typeNode = dojo.byId(this.ID_KW_TYPE + id);	
					if (typeNode.stepType) this._steps[i].elementType = this._getElementTypeByName(typeNode.stepType);
					var	content = this._steps[i].content;
					var summary = this._steps[i].summary;
					this._steps[i].summary = summary?dojo.trim(summary):"";
					this._steps[i].content = content?dojo.trim(content):"";
					if(before == true){
						updatedSteps.push(newstep);
						j = j + 1;
						updatedSteps.push(this._steps[i]);
						updatedProperties[j]= this.stepProperties[i];
					}
					else{
						updatedSteps.push(this._steps[i]);
						updatedProperties[j]= this.stepProperties[i];
						j = j + 1;
						updatedSteps.push(newstep);
					}
					j = j + 1;
				}
			}
			this._steps = null;
			this._steps = updatedSteps;
			this.stepProperties = null;
			this.stepProperties = updatedProperties;			
		},
		
		_handleRowInsert:function(currentRow){
			// cant destroy the editor which is calling this function
			setTimeout(dojo.hitch(this, this._rowInsertInternal,currentRow), 200);
		},
		_rowInsertInternal:function(currentRow){
			this._preserveEditedContent();
			var stepNum = this._getStepNumForRow(currentRow);
			stepNum = parseInt(stepNum, 10);
			this._insertRowinBetween(stepNum,false,"Execution Step");
			this.prevStepNum = stepNum -1;
			try{
				this._showSteps();
				stepNum = stepNum+1;
				var descriptionElement = dojo.byId(this.ID_STEP_SUMMARY + stepNum);
				if (descriptionElement) {
					dojox.data.dom.removeChildren(descriptionElement);
					var detailsDiv = this._buildDetailRow({num: stepNum});
					descriptionElement.appendChild(detailsDiv);
					this._attachEditor(stepNum);
				}
			}catch(e){console.error("ESEL: Row Insert failed." + e.message);}
			this.parentCallBack._setEditorDirty(true);
		},
		_handleAddClick: function(e, currentRow) {
			var row = null;
			var newRow = false;
			if(currentRow){
				row = currentRow.nextSibling;
				if(row.id == "")
					newRow = true;
				if(row.id != ""){
					if(row.isKeyword){
						return;
					}else{
						var arr = (row.id).split(this.ID_SUMMARY_ROW);
						var id = arr[1];
						this._attachEditor(id);
					}
				}	
			}	
			if(e){
				newRow = true;
				row = e.currentTarget.parentNode;
			}
			if(newRow){
				this._insertStepRow(row, null, true, true);
				this._appendNewStepLinkRow();
			}
			if(this.prevStepNum != -1){
				this.prevStepNum = this._getStepNumForRow(row) -1;
				this._createCurrentProperties(this.stepProperties[this._getStepNumForRow(row) -1])
			}else{
				this.prevStepNum = this._getStepNumForRow(row) -1;
			}
			this.currentRemovedAttachments = this.removedAttachments? this.removedAttachments[this.prevStepNum]:null;
		},
		
		_handleEditClick: function(e, stepNum, currentRow) {
			this.parentCallBack._setEditorDirty(true);
			var row = null;
			if(currentRow)
				row = currentRow;
			if(e){
				//dojo.stopEvent(e);
				row = e.currentTarget.parentNode;
			}
			if(this.prevStepNum != -1){
				if(currentRow){
					this.prevStepNum = this._getStepNumForRow(currentRow) -1;
				}else
					this.prevStepNum = this._getStepNumForRow(row) -1;
				this._createCurrentProperties(this.stepProperties[this._getStepNumForRow(row) -1])
			}
			else{
				this.prevStepNum = this._getStepNumForRow(row) -1;
				this._createCurrentProperties(this.stepProperties[this._getStepNumForRow(row) -1])
			}
			this._insertStepRow(row, this._getStepForRow(row), true, true);
			this.currentRemovedAttachments = this.removedAttachments? this.removedAttachments[this.prevStepNum]: null;
		},	
		_changeBGColor: function(row){
			if(this.lastClickedRow != "none" && this.lastClickedRow != ""){
				var prevRow = document.getElementById(this.lastClickedRow)
				if(prevRow){
					prevRow.className = "steps-table-row"
					dojo.removeClass(prevRow, "selected-row");
				}
			}
			if(row){
				this.lastClickedRow = row.id;
				dojo.addClass(row, "selected-row");
			}else
				this.lastClickedRow = "none";			
		},
		
		updateStepType: function(index){
			if(this.changedStepId){
				this.parentCallBack._setEditorDirty(true);
				var stepNum = this.changedStepId;
				var img = dojo.byId(this.ID_STEP_TYPE+stepNum);
				var step=this._steps[this.changedStepId-1];
				if(index.abrv =="es")
					step.elementType = this._getElementTypeByName("Execution Step")
				if(index.abrv =="vp")
					step.elementType = this._getElementTypeByName("Verification Point")
				if(index.abrv =="rp")
					step.elementType = this._getElementTypeByName("Reporting Step")
				
				img.title = step.elementType.name;
				img.alt= step.elementType.name;
				img.src= ImageCache.getTypeIconURL(step.elementType);
				img.stepType = step.elementType.name;
				this.changedStepId = null;		
			}
		},
		_updatePasteCompareProperty:function(properties){
			if(this.lastClickedRow != "none" && this.lastClickedRow != ""){
				var row = dojo.byId(this.lastClickedRow);
				var stepNum = this._getStepNumForRow(row);
				var pasteComparePropertyFound = false;
				if(this.stepProperties[stepNum - 1]){
					if(properties && properties.length >0){
						for(var i=0;i<this.stepProperties[stepNum - 1].length;i=i+3){
							if(this.stepProperties[stepNum - 1][i] == properties[0]){
								this.stepProperties[stepNum - 1][i+1] = properties[1];
								this.stepProperties[stepNum - 1][i+2] = properties[2];
								pasteComparePropertyFound = true;
								break;
							}
						}
					}
				}
				else
					this.stepProperties[stepNum - 1]=[];
				if(properties && !pasteComparePropertyFound){
					this.stepProperties[stepNum - 1].push(properties[0]);
					this.stepProperties[stepNum - 1].push(properties[1]);
					this.stepProperties[stepNum - 1].push(properties[2]);							
				}
				this._updateProperties(stepNum);
			}
		},		
		
		_updateCommentProperty:function(properties){
			if(this.lastClickedRow != "none" && this.lastClickedRow != ""){
				var row = dojo.byId(this.lastClickedRow);
				var stepNum = this._getStepNumForRow(row);
				var commentPropertyFound = false;
				if(this.stepProperties[stepNum - 1]){
					if(properties && properties.length >0){
						for(var i=0;i<this.stepProperties[stepNum - 1].length;i=i+3){
							if(this.stepProperties[stepNum - 1][i] == properties[0]){
								this.stepProperties[stepNum - 1][i+1] = properties[1];
								this.stepProperties[stepNum - 1][i+2] = properties[2];
								commentPropertyFound = true;
								break;
							}
						}
					}
				}
				else
					this.stepProperties[stepNum - 1]=[];
				if(properties && !commentPropertyFound){
					this.stepProperties[stepNum - 1].push(properties[0]);
					this.stepProperties[stepNum - 1].push(properties[1]);
					this.stepProperties[stepNum - 1].push(properties[2]);							
				}
				this._updateProperties(stepNum);
			}
		},
		
		_updateAttachmentProperty:function(properties,removedAttachments){
			if(this.lastClickedRow != "none" && this.lastClickedRow != ""){
				var row = dojo.byId(this.lastClickedRow);
				var stepNum = this._getStepNumForRow(row);
				var stepProperties = this.stepProperties[stepNum - 1];
				var newProperties = [];
				if(stepProperties){
					for(var i=0;i<stepProperties.length;i=i+3){
						if(stepProperties[i] != ATTACHMENT_VIEW_TYPE){
							newProperties.push(stepProperties[i]);
							newProperties.push(stepProperties[i+1]);
							newProperties.push(stepProperties[i+2]);
						}
					}
				}
				if(properties && properties.length > 0){
					for(var j=0;j<properties.length;j++){
						newProperties.push(properties[j]);
					}
				}
				this.stepProperties[stepNum - 1] = newProperties;
				if(!this.removedAttachments)
					this.removedAttachments = new Array();
				this.removedAttachments[stepNum - 1] = removedAttachments;
				this._updateProperties(stepNum);
			}		
		},

		_updateProperties:function(stepNum){
			this.parentCallBack._setEditorDirty(true);
			this._createCurrentProperties(this.stepProperties[stepNum - 1]);
			this.currentRemovedAttachments = this.removedAttachments? this.removedAttachments[stepNum - 1]:null;
			var attachCell = dojo.byId(this.ID_ATTACH_CELL+stepNum);
			var commentCell = dojo.byId(this.ID_COMMENT_CELL+stepNum);
			var compareCell = dojo.byId(this.ID_COMPARE_CELL+stepNum);
			var propshtml = this._createPropertiesHtml(stepNum,this.currentProperties);
			attachCell.parentNode.replaceChild(propshtml[0],attachCell);
			commentCell.parentNode.replaceChild(propshtml[1],commentCell);
			compareCell.parentNode.replaceChild(propshtml[2],compareCell);
		},
		
		_getProperties:function(){
			return [this.currentProperties,this.currentRemovedAttachments];
		},
		
		_appendNewStepLinkRow: function() {
			var row = this._getEmptyRow();
			var cell = this._getEmptyCell(5);
			cell.appendChild(document.createTextNode(Constants.getMessage("labelClickToAdd")));	
			row.appendChild(cell);
			cell.setAttribute("tabIndex", 0);
			this._stepsTableBody.appendChild(row);
			if (!this.isReadOnly()) {
				cell.add_click_handle = dojo.connect(cell, "onclick", this, this._handleAddClick);
				cell.add_enter_handle = dojo.connect(cell, "onkeypress", this, this._keyPressHandler);
				cell.add_focus_handle = dojo.connect(cell, "onfocus", cell, function(e){
					this.style.color = "#8A9084";
				});	
				cell.add_blur_handle = dojo.connect(cell, "onblur", cell, function(e){
					this.style.color = "#000";
				});	
			}
		},
		_keyPressHandler:function(e){
			if (e.keyCode == dojo.keys.ENTER || e.keyCode == dojo.keys.SPACE) {
                //perform the open new section dialog on ENTER pressed 
                this._handleAddClick(e);
            }
		},
	    _dndCreator:function(row,hint){
			if(row.id){
				var lastIndex = row.id.lastIndexOf("_");
				var rowNumber = row.id.substr(lastIndex + 1);
				var rowId = row.id.substr(0,lastIndex);
	            if(hint == "avatar"){
	                var tr = document.createElement("tr");
					var td = document.createElement("td");
	                td.appendChild(document.createTextNode(rowNumber));
	                tr.appendChild(td);
					return {node: tr, data: row, type: [rowId]};
	            }
	           return {node: row, data: row, type: [rowId]};				
			}
			var newRow = document.createElement("tr");	
            return {node: newRow, data: null, type: []};
        },

		_isRowEditable: function(row) {
			var stepNum = this._getStepNumForRow(row);
			var typeElement = document.getElementById(this.ID_STEP_TYPE + stepNum);
			var descElement = document.getElementById(this.ID_DETAIL_EDITOR_DIV + stepNum);
			return ( 
				typeElement != null && descElement != null &&
				(descElement.tagName.toUpperCase() == "DIV")
			);
		},				
		_createPropertiesHtml: function(stepNum,properties){
			var attachCell = this._getEmptyCell();
			attachCell.id = this.ID_ATTACH_CELL+stepNum;
			attachCell.align = "right"; 
			var attachmentsHtml = document.createElement("span");
			var attachmentsHtmlContent = attachmentsHtml.appendChild(document.createElement("table"));
			
			var commentCell = this._getEmptyCell();
			commentCell.id = this.ID_COMMENT_CELL+stepNum;
			commentCell.align = "right";
			var commentsHtmlContent = document.createElement("span");

			var compareCell = this._getEmptyCell();
			compareCell.id = this.ID_COMPARE_CELL+stepNum;
			compareCell.align = "right";
			var compareHtmlContent = document.createElement("span");
			
			var attachmentFound = false;
			var commentFound = false;
			var compareFound = false;
			var attachmentCount= 0;
			
			if(properties) {
				for(var i=0;i<properties.length;i++){
					switch(properties[i].propertyType){
						case ATTACHMENT_VIEW_TYPE:
							if(attachmentFound == false){
								var attachImg = document.createElement("img");
								attachImg.alt= Constants.getMessage("labelAttachment");
								attachImg.src = ImageCache.ATTACHMENT;
								attachImg.className = "type-image";
								attachCell.appendChild(attachImg);
								attachImg.setAttribute("tabIndex", 0);
								attachmentFound = true;
								dojox.data.dom.removeChildren(attachmentsHtmlContent);
							}
							attachmentCount++;
							var attachmentsHtmlContentRow = this._getEmptyRow();
							var attachmentsHtmlContentCell = this._getEmptyCell();
							var attachmentsAnchor = document.createElement("a");
							attachmentsAnchor.target = "_blank";
							var valueArr = properties[i].propertyValue.split(":");
							var attachmentsText = valueArr[0];
							attachmentsAnchor.appendChild(document.createTextNode(attachmentsText));
							attachmentsAnchor.href = TeamServerClient._getServicePrefix()+ DOWNLOAD_SERVICE_URI + valueArr[3];
							dojo.style(attachmentsAnchor,"fontSize","0.7em");
							attachmentsHtmlContentCell.appendChild(attachmentsAnchor);
							attachmentsHtmlContentRow.appendChild(attachmentsHtmlContentCell);
							attachmentsHtmlContent.appendChild(attachmentsHtmlContentRow);
							break;
							
						case COMMENT_VIEW_TYPE:
							commentFound = true;
							dojox.data.dom.removeChildren(commentsHtmlContent);
							commentsHtmlContent.appendChild(document.createTextNode(properties[i].propertyValue));
							commentImg = document.createElement("img");
							commentImg.alt= Constants.getMessage("labelComment");
							commentImg.src = ImageCache.COMMENT;
							commentImg.className = "type-image";
							commentImg.setAttribute("tabIndex", 0);
							commentCell.appendChild(commentImg);
							break;
						
						case COMPARE_VIEW_TYPE:
							compareFound = true;
							dojox.data.dom.removeChildren(compareHtmlContent);
							var value = properties[i].propertyValue.replace(/&colon;/g, ":");
							compareHtmlContent.appendChild(document.createTextNode(value));
							compareImg = document.createElement("img");
							compareImg.alt= Constants.getMessage("labelComment");
							compareImg.src = ImageCache.COMPARE;
							compareImg.className = "type-image";
							compareImg.setAttribute("tabIndex", 0);
							compareCell.appendChild(compareImg);
							break;
						default:
							//do Nothing
					}
				}	
			}
			var tooltip;
			if(attachmentCount>0){
				var _attachmentTooltipSpan = document.createElement("span");
				attachCell.appendChild(_attachmentTooltipSpan);
				var attachmentCountText = document.createTextNode("("+attachmentCount+")");
				dojo.style(attachCell,"fontSize","0.7em");
				attachCell.appendChild(attachmentCountText);
				tooltip = new HoverPopup({connectNode: [attachImg],label: attachmentsHtml.innerHTML}, _attachmentTooltipSpan);
			}
			if(commentFound ===true){
				var _commentTooltipSpan = document.createElement("span");
				commentCell.appendChild(_commentTooltipSpan);
				tooltip = new HoverPopup({connectNode: [commentImg],label:commentsHtmlContent.innerHTML}, _commentTooltipSpan);				
			}			
			if(compareFound ===true){
				var _compareTooltipSpan = document.createElement("span");
				compareCell.appendChild(_compareTooltipSpan);
				tooltip = new HoverPopup({connectNode: [compareImg],label:compareHtmlContent.innerHTML}, _compareTooltipSpan);				
			}			
			return [attachCell,commentCell,compareCell];
		},			
					
		_insertStepRow: function(targetRow, step, editable, expanded) {
			editable = editable != null && editable == true ? true : false ;
			if(step == null){
				this.parentCallBack._setEditorDirty(true);
			}
			var stepNum = step != null ? step.num : (targetRow == null ? this._steps.length + 1 : this._getStepNumForRow(targetRow));
			if (targetRow == null) {
				//build empty target row
				targetRow = this._getEmptyRow();
				targetRow.id = this.ID_SUMMARY_ROW + stepNum;
				if (this.stepsDndSource) {
				    this.stepsDndSource.insertNodes(false,[targetRow]);
				} else {
					this._stepsTableBody.appendChild(targetRow);
				}
			} else {				
				if (step == null) {
					//new step - (add clicked)	
					step = {num: stepNum};
					this._steps.push(step);	
					targetRow.id = this.ID_SUMMARY_ROW + step.num;
				}
			}
			if(step.elementType && step.elementType.name == "Keyword"){
				var keywordId = null;
				var keywordExternalId = null;
				for(var i=0;i<this.stepProperties[stepNum-1].length;i=i+3){
					if(this.stepProperties[stepNum-1][i]=="keyword"){
						if(this.stepProperties[stepNum-1][i+1] == "keywordExternalId")
							keywordExternalId = this.stepProperties[stepNum-1][i+2];
						else if(this.stepProperties[stepNum-1][i+1] == "keywordId")
							keywordId = this.stepProperties[stepNum-1][i+2];
						break;
					}
				}
				if(!keywordId && !keywordExternalId)
					return;
				if (keywordId != null) {
					var keyword = this.scriptObjects[keywordId];
					if (keyword) {
						this._addKeyword(targetRow, keyword, true);
						return;
					}
				}
				var self = this;
				var callbackObj = {
					success: function(keywords){
						self._addKeyword(targetRow, keywords[0], true);
					},
					failure: function(e){
						self._error(e);
					}
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				if (keywordId != null) {
					com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.getKeywordDTO(responseHandler, {
						id: keywordId,
						includeArchived: true
					});
				}
				else if (keywordExternalId != null) {
					com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.getKeywordDTO(responseHandler, {
						externalId: keywordExternalId,
						includeArchived: true
					});
				}
				return;
			}
			dojox.data.dom.removeChildren(targetRow);
			var numCell = this._getEmptyCell();
			numCell.align = "center";
			numCell.appendChild(document.createTextNode(stepNum));
			targetRow.appendChild(numCell);
			var typeCell = this._getEmptyCell();
			typeCell.align = "left";
			typeCell.vAlign = "center";
			var typeElement = null;
			if ( editable ) {
				//create & populate a select element
				typeElement = document.createElement("img");
				typeElement.id = this.ID_STEP_TYPE + step.num;
				if(this._elementTypes && step.elementType == null){
					step.elementType = this._getElementTypeByName("Execution Step");
				}
				typeElement.title = step.elementType.name;
				typeElement.alt= step.elementType.name;
				typeElement.src= ImageCache.getTypeIconURL((step.elementType != null ? step.elementType : null));
				typeElement.className = "type-image";
				typeElement.stepType = step.elementType.name;
			} else {
				typeElement = document.createElement("img");
				typeElement.id = this.ID_STEP_TYPE + step.num;
				typeElement.title = step.elementType.name;
				typeElement.alt= step.elementType.name;
				typeElement.src= ImageCache.getTypeIconURL(step.elementType);
				typeElement.className = "type-image";
				typeElement.stepType = step.elementType.name;			
			}
			typeElement.align = "right";
			typeCell.appendChild(typeElement);
			dojo.removeClass(typeCell,"steps-table-cell");
			dojo.addClass(typeCell,"steps-table-cell-image");
			targetRow.appendChild(typeCell);
			var dropdownCell = this._getEmptyCell();
			var dropdown = document.createElement("img");
			dropdown.id = this.ID_TYPE_DROPDOWN + step.num;
			dropdown.src = ImageCache.DROPDOWN_ARROW;
			dropdown.align = "left";
			dropdown.setAttribute("tabIndex", 0);
			dropdownCell.appendChild(dropdown);
			dojo.removeClass(dropdownCell,"steps-table-cell");
			dojo.addClass(dropdownCell,"steps-table-cell-image");
			targetRow.appendChild(dropdownCell);
            if (!this.isReadOnly()) {
				this._createContextMenu(dropdown.id,step.num);//Create step change context menu for the image only
			}
			//step name / description cell
			var descriptionCell = this._getEmptyCell();
			var descriptionElement = null;
			descriptionElement = document.createElement('div');
			descriptionElement.id = this.ID_STEP_SUMMARY + step.num;
			var detailsDiv = this._buildDetailRow(step);
			descriptionElement.appendChild(detailsDiv);	
			descriptionCell.appendChild(descriptionElement);
			targetRow.appendChild(descriptionCell);
			if ( editable ) {
				this._attachEditor(step.num);
			}
			//Properties
			var properties= null;
			this._createCurrentProperties(this.stepProperties[step.num -1])
			if(this.currentProperties.length != 0)
				properties = this.currentProperties;//FIXME:now this is an array format and now 2D array
			var propshtml = this._createPropertiesHtml(stepNum,properties);
			targetRow.appendChild(propshtml[0]);
			targetRow.appendChild(propshtml[1]);
			targetRow.appendChild(propshtml[2]);
			
			//save button
			var actionCell = this._getEmptyCell();
			actionCell.align = "right";
			var dropdownCell2 = this._getEmptyCell();
			targetRow.appendChild(dropdownCell2);		
			targetRow.appendChild(actionCell);
			//show remove action button, if not in read-only mode
			if (!this.isReadOnly()){
				var dropdown2 = document.createElement("img");
				dropdown2.id = this.ID_TYPE_DROPDOWN2 + step.num;
				dropdown2.src = ImageCache.DROPDOWN_ARROW;
				dropdown2.align = "right";
				dropdownCell2.appendChild(dropdown2);
				dojo.removeClass(dropdownCell2,"steps-table-cell");
				dojo.addClass(dropdownCell2,"steps-table-cell-image");
				var menu = this._createInsertContextMenu(dropdown2.id,targetRow.id);
				dropdown2.insertMenu = menu; 
				dropdown2.setAttribute("tabIndex", 0);
				dojo.connect(dropdown2, "onclick", this, function(evt){evt.currentTarget.insertMenu._openMyself(evt);});
				dojo.connect(dropdown2, "onkeypress", this, function(evt){
					if (evt.keyCode == dojo.keys.ENTER || evt.keyCode == dojo.keys.DOWN_ARROW)
						evt.currentTarget.insertMenu._openMyself(evt);
					});
				var removeButton = document.createElement("img");
				removeButton.src = ImageCache.REMOVE_DISABLED;
				removeButton.alt = Constants.getMessage("labelRemoveStep");
				removeButton.title = Constants.getMessage("labelRemoveStep");
				removeButton.setAttribute("tabIndex", 0);
				dojo.connect(removeButton, "onclick", this, this.onStepRemove);
				dojo.connect(removeButton, "onkeypress", dojo.hitch(this, function(evt){
					if (evt.keyCode == dojo.keys.ENTER || evt.keyCode == dojo.keys.SPACE){
						this.onStepRemove(evt);
					}
					}));
				dojo.connect(removeButton, "onmouseover", this, this._onRemoveMouseOver);
				dojo.connect(removeButton, "onfocus", this, this._onRemoveMouseOver);
				dojo.connect(removeButton, "onmouseout", this, this._onRemoveMouseOut);
				dojo.connect(removeButton, "onblur", this, this._onRemoveMouseOut);		
				actionCell.appendChild(removeButton);				
			}		
			if ( editable ) {
				//if editable, bring it into focus
				dijit.scrollIntoView(targetRow);
				if(window.pageYOffset && window.pageYOffset> 150)
					window.scrollBy(0,20);
			} 
			if (!this.isReadOnly()) {
				descriptionCell.setAttribute("tabIndex", 0);
				descriptionCell.edit_click_handle = dojo.connect(descriptionCell, "onclick", this, this._handleEditClick);
				descriptionCell.edit_enter_handle = dojo.connect(descriptionCell, "onkeypress", 
					dojo.hitch(this,function(e){
						if (e.keyCode == dojo.keys.ENTER || e.keyCode == dojo.keys.SPACE)
							this._handleEditClick(e);
					}));
			}
		},
		
		_insertKeyword:function(targetRow,keywordName,script,stepNum){
			var numCell = this._getEmptyCell();
			numCell.align = "center";
			numCell.appendChild(document.createTextNode(stepNum));
			targetRow.appendChild(numCell);
			targetRow.isKeyword = true;
			//step type cell
			var typeCell = this._getEmptyCell();
			typeCell.align = "left";
			typeCell.vAlign = "top";
			var typeElement = null;
			typeElement = document.createElement("img");
			typeElement.id = this.ID_KW_TYPE + stepNum;
			typeElement.title = Constants.getMessage("labelKeyword");
			typeElement.alt= Constants.getMessage("labelKeyword");
			typeElement.src= ImageCache.getTypeIconURL(this._getElementTypeByName("Keyword"));
			typeElement.stepType = "Keyword";
			typeElement.className = "type-image";			
			typeCell.appendChild(typeElement);			
			targetRow.appendChild(typeCell);
			var dropdownCell = this._getEmptyCell();
			var dropdown = document.createElement("text");
			dropdown.id = this.ID_TYPE_DROPDOWN + stepNum;
			dropdown.align = "left";
			dropdownCell.appendChild(dropdown);
			dojo.removeClass(dropdownCell,"steps-table-cell");
			dojo.addClass(dropdownCell,"steps-table-cell-image");
			targetRow.appendChild(dropdownCell);
			//step name / description cell
			var descriptionCell = this._getEmptyCell(4);	
			var descriptionElement = document.createElement("table");
			var descriptionElementBody = document.createElement("tbody");
			descriptionElement.id = this.ID_KW_SUMMARY + stepNum;
			descriptionElement.width = "100%";
			var descriptionRow = this._getEmptyRow();
			var descriptionInnerCell = this._getEmptyCell(20);
			var detailsDiv = document.createElement('div');
			detailsDiv.innerHTML = keywordName;
			descriptionInnerCell.appendChild(detailsDiv);
			descriptionRow.appendChild(descriptionInnerCell);
			descriptionElementBody.appendChild(descriptionRow);
			descriptionElement.appendChild(descriptionElementBody);
			descriptionCell.appendChild(descriptionElement);
			targetRow.appendChild(descriptionCell); 
			descriptionCell.setAttribute("tabIndex", 0);			
			//script statements
			if(script && script.elements){	
				for(var i=0;i<script.elements.length;i++){
					var keywordStepsRow = this._getEmptyRow();
					var typeCell2 = this._getEmptyCell();
					dojo.style(typeCell2,"width","16px");
					typeElement = document.createElement("img");
					typeElement.id = this.ID_KW_TYPE + stepNum;
					typeElement.title = Constants.getMessage("labelKeyword");
					typeElement.alt= Constants.getMessage("labelKeyword");
					typeElement.src= ImageCache.getTypeIconURL(this._getElementTypeByName(script.elements[i].elementType.name));
					typeElement.className = "type-image";
					typeElement.stepType = script.elements[i].elementType.name;
					typeCell2.appendChild(typeElement);
					keywordStepsRow.appendChild(typeCell2);
					var keywordCell = this._getEmptyCell(20);
					var keywordSteps = document.createElement('div');
					keywordSteps.innerHTML = this._getStepContent(script.elements[i]);
					keywordCell.appendChild(keywordSteps);
					keywordCell.width = "90%";
					keywordStepsRow.appendChild(keywordCell);
					var properties = script.elements[i].properties;
					var propshtml = this._createPropertiesHtml(stepNum+"_"+i,properties);
					keywordStepsRow.appendChild(propshtml[0]);
					keywordStepsRow.appendChild(propshtml[1]);
					keywordStepsRow.appendChild(propshtml[2]);
					descriptionElementBody.appendChild(keywordStepsRow);
				}
			}	
			//remove button
			var actionCell = this._getEmptyCell();
			actionCell.align = "right";
			var dropdownCell2 = this._getEmptyCell();
			targetRow.appendChild(dropdownCell2);
			targetRow.appendChild(actionCell);
			if (!this.isReadOnly()) {
				var dropdown2 = document.createElement("img");
				dropdown2.id = this.ID_TYPE_DROPDOWN2 + stepNum;
				dropdown2.src = ImageCache.DROPDOWN_ARROW;
				dropdown2.align = "right";
				dropdownCell2.appendChild(dropdown2);
				dojo.removeClass(dropdownCell2,"steps-table-cell");
				dojo.addClass(dropdownCell2,"steps-table-cell-image");
				var menu = this._createInsertContextMenu(dropdown2.id,targetRow.id);
				dropdown2.insertMenu = menu; 
				dropdown2.setAttribute("tabIndex", 0);
				dojo.connect(dropdown2, "onclick", this, function(evt){evt.currentTarget.insertMenu._openMyself(evt);});
				dojo.connect(dropdown2, "onkeypress", this, function(evt){
					if (evt.keyCode == dojo.keys.DOWN_ARROW)
						evt.currentTarget.insertMenu._openMyself(evt);
					});
				var removeButton = document.createElement("img");
				removeButton.src = ImageCache.REMOVE_DISABLED;
				removeButton.alt = Constants.getMessage("labelRemoveStep");
				removeButton.title = Constants.getMessage("labelRemoveStep");
				removeButton.setAttribute("tabIndex", 0);
				dojo.connect(removeButton, "onclick", this, this.onStepRemove);
				dojo.connect(removeButton, "onkeypress", dojo.hitch(this, function(evt){
					if (evt.keyCode == dojo.keys.ENTER || evt.keyCode == dojo.keys.SPACE)
						this.onStepRemove(evt);
					}));
				dojo.connect(removeButton, "onmouseover", this, this._onRemoveMouseOver);
				dojo.connect(removeButton, "onfocus", this, this._onRemoveMouseOver);
				dojo.connect(removeButton, "onmouseout", this, this._onRemoveMouseOut);
				dojo.connect(removeButton, "onblur", this, this._onRemoveMouseOut);
				actionCell.appendChild(removeButton);
			}
		},
		
		_addKeyword: function(targetRow,keyword,replaceCurrent, updateView) {
			var stepNum =0;
			this._preserveEditedContent();
			this._destroyEditor();
			if (targetRow == null) {
				stepNum = this._steps.length + 1;
				var step = {num: stepNum};
				this._steps.push(step);				
				//build empty target row
				targetRow = this._getEmptyRow();
				targetRow.id = this.ID_SUMMARY_ROW + stepNum;
				if (this.stepsDndSource) {
					this.stepsDndSource.insertNodes(false, [targetRow]);
				} else {
					this._stepsTableBody.appendChild(targetRow);
				}
			}
			else{
				stepNum = this._getStepNumForRow(targetRow);
				if(replaceCurrent == false){
					this._insertRowinBetween(stepNum,true,"Keyword",keyword.id);
                    if(!this.stepProperties[stepNum-1])
					    this.stepProperties[stepNum-1] = [];
					this.stepProperties[stepNum-1].push("keyword");
					this.stepProperties[stepNum-1].push("keywordId");
					this.stepProperties[stepNum-1].push(keyword.id);
					if(!updateView)
						this._showSteps();
					return;
				}
			}
            if(!this.stepProperties[stepNum-1] || replaceCurrent == true)
				this.stepProperties[stepNum-1] = [];
			this.stepProperties[stepNum-1].push("keyword");
			this.stepProperties[stepNum-1].push("keywordId");
			this.stepProperties[stepNum-1].push(keyword.id);			
			dojox.data.dom.removeChildren(targetRow);
			this._steps[stepNum-1].content=escape(keyword.name);
			this._steps[stepNum-1].summary=escape(keyword.name);
			this._steps[stepNum-1].elementType = this._getElementTypeByName("Keyword");
			this._steps[stepNum-1].script=keyword.defaultScript?keyword.defaultScript.id+'':keyword.manualScript.id+'';
			this.scriptObjects[keyword.id] = keyword;
			var script = null;
			if(!keyword.defaultScript || keyword.defaultScript.itemId == keyword.manualScript.itemId)
				script = keyword.manualScript;
			this._insertKeyword(targetRow,keyword.name,script,stepNum);	
		},
		
		_onRemoveMouseOver: function(e)	{
			e.target.src = ImageCache.REMOVE_ENABLED;
		},
		
		_onRemoveMouseOut: function(e) {
			e.target.src = ImageCache.REMOVE_DISABLED;
		},	
		
		_sortSteps: function() {
			var sorted = [];
			for (var i = 0; i < this._steps.length; i++) {
				var stepI = this._getStepByNum(i + 1);
				sorted.push(stepI);
			}		
			this._steps = sorted;	
		},
		
		_getStepContent: function(step) {
			//return step.summary ? unescape(step.summary) : "Summary of Step Number " + step.num;
			//Renamed _getStepSummary to _getStepContent
			//Changing the Summary to content....WI 3005
			return step.content ? unescape(step.content) : "";
		},
		
		_getStepByNum: function(num) {
			for (var i = 0; i < this._steps.length; i++) {
				if (this._steps[i].num == num) {
					return this._steps[i];	
				}
			}
			return null;
		},
		
		_getStepNumForRow: function(row) {
			var rowIndex = row.sectionRowIndex;
			if ( row.id && dojo.trim(row.id).length > 0 ) {
				return row.id.substr(row.id.lastIndexOf("_") + 1);
			} else 
				return (rowIndex+1);
		},		
		
		_getStepForRow: function(row) {
			return this._steps[this._getStepNumForRow(row) - 1];			
		},		
		
		getElements: function() {
			this._sortSteps();
			return this._steps;
		},			
		
		_initElementTypes: function() {
			var handler = new ServiceResponseHandler(this, "_setElementTypes", "_error");
			RegistryClient.getAllExecutionElementTypes(handler);			
		},
		
		_getElementTypeByName: function(typeName) {
			for ( var i = 0; i < this._elementTypes.length; i++ ) {
				if ( this._elementTypes[i].name == typeName ) {
					return this._elementTypes[i];
				}
			}
			return null;
		},	
		
		_setElementTypes: function(allTypes) {
			this._elementTypes = allTypes;
			this._showSteps();
		},
		
		validateElements: function() {
			this._preserveEditedContent();
			this._destroyEditor();
			for ( var i = this._steps.length; i >0 ; i-- ) {
				if ( !this.onStepSave(this._stepsTableBody.rows[i-1]) ) {
					return false;
				}
			}
			return true;
		},			
			
		onCancel: function(){
			if(this.parentCallBack)
				this.parentCallBack.setHeaderStatus(Constants.getMessage("msgChangesNotSaved"), Constants.HEADER_STATUS_WARNING);
			else
				alert(Constants.getMessage("msgChangesNotSaved"));
		},
		
		handleRowDelete: function(id, row){
			this._preserveEditedContent();
			this.parentCallBack._setEditorDirty(true);
			var currentEId = id.split(this.ID_DETAIL_EDITOR_DIV);
			var currId = currentEId[currentEId.length -1];
			var prevId = parseInt(currId, 10) -1;
			var prevRow = row.previousSibling;
			if(prevRow && this.prevStepNum != -1){
				this.prevStepNum = this._getStepNumForRow(prevRow);
				this._attachEditor(this.prevStepNum);
				this._createCurrentProperties(this.stepProperties[this.prevStepNum -1]);
			}
		},
		
		onStepRemove: function(e) {
			var row = e.currentTarget.parentNode.parentNode;
			var stepNum = this._getStepNumForRow(row);
			var args = {
            	'message': Constants.getMessage("msgConfirmRemoveStep", stepNum),
            	'yesCallback': 
               	 	function(view) {
                    	view._deleteAction(stepNum);
                	},
            	'yesCallbackData': this,
            	'noCallback': null,
            	'noCallbackData': null
        	};
        	var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        	confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
			confirmDialog.open();
			return false;
		},
		_deleteAction: function(stepNum) {	
			this.parentCallBack._setEditorDirty(true);
			var updatedSteps = [];
			var updatedProperties = [];
			var newRemovedAttachments = [];
			var j = 0;
			this._preserveEditedContent();
			this._destroyEditor();
			for ( var i = 0; i < this._steps.length; i++ ) {
				if ( i != (stepNum - 1) ) {
					this._steps[i].num = i + 1;
					updatedSteps.push(this._steps[i]);
					updatedProperties[j]= this.stepProperties[i];
					newRemovedAttachments = this.removedAttachments? this.removedAttachments[i]:null;
					j=j+1;
				}else{
					this.prevStepNum = this.ID_STEP_SUMMARY+i;
					this.lastClickedRow = this.ID_STEP_SUMMARY+i;
				}
			} 
			this._steps = null;
			this._steps = updatedSteps;
			this.stepProperties = null;
			this.stepProperties = updatedProperties;
			this.removedAttachments = newRemovedAttachments;
			this._showSteps();
		},
		_preserveEditedContent: function(){
			if(this.stepBeingEdited != -1 && this.editor){
				this.editor.endEditing(true);
				this._steps[this.stepBeingEdited-1].content = escape(this.editor.getValue());
				this._steps[this.stepBeingEdited-1].summary = this._getSummary();
				var typeNode = dojo.byId(this.ID_STEP_TYPE + this.stepBeingEdited);
				if (typeNode && typeNode.stepType) 
					this._steps[this.stepBeingEdited-1].elementType = this._getElementTypeByName(typeNode.stepType);
			}
			this.stepBeingEdited  = -1;
		},
		onStepSave: function(target /* a row or an element within a table cell */) {
			var row = target;
			if ( target.currentTarget != null ) {
				row = target.currentTarget.parentNode.parentNode;
			}
			var stepNum = this._getStepNumForRow(row);
			var typeNode = dojo.byId(this.ID_STEP_TYPE + stepNum);
			if(typeNode == null)
				typeNode = dojo.byId(this.ID_KW_TYPE + stepNum);	
			if ( typeNode && typeNode.value && dojo.trim(typeNode.value).length == 0) {
				if (this.parentCallBack) {
					this.parentCallBack.setHeaderStatus(Constants.getMessage("msgStepTypeRequired", stepNum), 
							Constants.HEADER_STATUS_ERROR);
				}else
					alert(Constants.getMessage("msgStepTypeRequired", stepNum));
				return false;
			}			
			var content = this._steps[stepNum -1].content;
			var summary = this._steps[stepNum -1].summary;
			if ( !content || dojo.trim(content).length == 0 || unescape(content).indexOf("br _moz_editor_bogus_node") != -1 || unescape(content) === '<br />') {
				var stepNumInt = parseInt(stepNum, 10);
				// ensure both the step content and its properties are empty before discarding it
				if( stepNumInt === this._steps.length && 
					!(this.stepProperties[stepNumInt -1] && this.stepProperties[stepNumInt-1].length > 0)){
					this._steps.pop();
					if(this.stepProperties[stepNumInt -1])
						this.stepProperties.pop();
					this._stepsTableBody.removeChild(row);
					return true;
				}else{
					if (this.parentCallBack) {
						this.parentCallBack.setHeaderStatus(Constants.getMessage("msgStepContentRequired", stepNum), 
								Constants.HEADER_STATUS_ERROR);
					}else
						alert(Constants.getMessage("msgStepContentRequired", stepNum));
					this._preserveEditedContent();
					this._attachEditor(stepNum);
					return false;
				}
			}
			var stepObj = this._getStepByNum(stepNum);
			if ( stepObj == null ) {
				stepObj = {};
				this._steps.push(stepObj);
			}
			stepObj.num = stepNum;
			if (typeNode.stepType) stepObj.elementType = this._getElementTypeByName(typeNode.stepType);
			if (summary != null && summary.length > 0) {
				//only send up summary if changed or new
				if (!stepObj.summary || stepObj.summary != summary) {
					stepObj.summary = summary;
				}
			}
			stepObj.content = content?dojo.trim(content):"";
			this._createCurrentProperties(this.stepProperties[parseInt(stepNum, 10) -1]);
			stepObj.properties = this.currentProperties;
			this.removedAttachments = new Array();
			this.currentRemovedAttachments = null;
			return true;
		},
		
        _getSummary:function() {
            // get the first text encountered. Replace images with "[Image]" text
            var summaryText = "";
			if(this.editor && this.editor.editNode && this.editor.editNode.childNodes){
				var imgCount = 0;
	            for (var i=0;i<this.editor.editNode.childNodes.length;i++){
	                var child = this.editor.editNode.childNodes[i];
	                if(child.tagName =='A'){
	                    if(child.getElementsByTagName("IMG").length>0){
	                        summaryText+="[Image] ";
	                        imgCount++;
	                    }
	                }
	                if(child.nodeValue){
	                    summaryText += dojo.trim(child.nodeValue);
	                    if(dojo.trim(summaryText).length>imgCount*8)
	                        break;
	                } 
	            }
	            summaryText = escape(summaryText);
	            if (summaryText.length>250)
	                summaryText = summaryText.substr(0,249);
	            if(summaryText.charAt(248)== '%')
	                summaryText = summaryText.substr(0, 248);
	            if(summaryText.charAt(247)== '%')
	                summaryText = summaryText.substr(0, 247);
	            return dojo.trim(summaryText);
			}
			return summaryText;            
        },
        
		setGlobalSaveInProgress: function(){
			this.prevStepNum = -2;
		},
		
		_createCurrentProperties: function(propertyArray){
			this.currentProperties =[];
			if(propertyArray){
				for(var i=0;i<propertyArray.length;i=i+3){
					var property = {
						propertyType:propertyArray[i],
						propertyName:propertyArray[i+1],
						propertyValue:propertyArray[i+2]
					}
					if(property.propertyValue != null && property.propertyValue.length>0)
						this.currentProperties.push(property);
				}
			}
		},
		
		_getPropertiesInArrayFormat: function(stepProperties){
			var properties = []
			for(var i=0;i<stepProperties.length;i++){
				properties.push(stepProperties[i].propertyType);
				properties.push(stepProperties[i].propertyName);
				properties.push(stepProperties[i].propertyValue);
			}
			return properties;
		},

		fClick: function(){
			var callbackObj = this.callback;
			if(!this.callback.changedStepId)
				this.callback.changedStepId = this.stepId;
			if(this.typeId)
				callbackObj.updateStepType({abrv: this.typeId})
		},

		_createContextMenu: function(nodeId,stepId){
			var callback = this;
			var pMenu = new dijit.Menu({_contextMenuWithMouse:true, targetNodeIds:[nodeId]});
            pMenu.addChild(new dijit.MenuItem({label:Constants.getMessage("labelExecutionStep"), 
				iconClass: "ExecutionStepIcon", stepId: stepId, typeId:"es", callback: callback, onClick:this.fClick}));
            pMenu.addChild(new dijit.MenuItem({label:Constants.getMessage("labelVerificationPoint"), 
				iconClass: "VerificationPointIcon",  stepId: stepId, typeId:"vp", callback: callback, onClick:this.fClick}));
            pMenu.addChild(new dijit.MenuItem({label:Constants.getMessage("labelReportingStep"), 
				iconClass: "ReportingStepIcon",  stepId: stepId, typeId:"rp", callback: callback, onClick:this.fClick}));
            pMenu.startup();
			//Enable the same menu for left click also			
			this.Menu = pMenu;
			dojo.connect(document.getElementById(nodeId), "onclick", this, this._openPopUp)
			dojo.connect(document.getElementById(nodeId), "onkeypress", dojo.hitch(this, function(e){
				if(e.keyCode == dojo.keys.DOWN_ARROW)
					this._openPopUp(e);
				}));
		},
		
		_openPopUp: function(e){
			this.changedStepId = this._getStepNumForRow(e.currentTarget.parentNode.parentNode);
			this.Menu._openMyself(e);
			return false;
		},
		
		_createInsertContextMenu:function(nodeId,rowId){
			var pMenu = new dijit.Menu({_contextMenuWithMouse:true, targetNodeIds:[nodeId]});
			var callback = this;
            pMenu.addChild(new dijit.MenuItem({
				label:Constants.getMessage("labelInsertStepBelow"), 
				iconClass: "ExecutionStepIcon", 
				rowId:rowId,
				callback:callback,
				onClick:function(){
					var row = dojo.byId(rowId);
					this.callback._handleRowInsert(row);
				}
			}));
            pMenu.startup();
			return pMenu;
		},
		_error: function(e){
			console.error("An error occurred: [" + e.message + "] @ ExecutionScriptElementEditor#_error");
		},

		onDestroy: function() {
			while (this.tooltips.length > 0)
				this.tooltips.pop().destroy();
		},

		_destroyEditor: function(){
			if(this.editor){
				try{
					this.editor.endEditing(true);
					this.editor.destroy(true);
					this.toolbar = null;
				}catch(e){
					console.debug("Exception in _destroyEditor ESEL errorMsg -> " + e.message);
					dijit.registry.remove(this.editor.id);//couldnt destroy the editor, remove it from registry
				}
			}
			this.editor = null;
			this.stepBeingEdited  = -1;
			this._changeBGColor();
			this.lastClickedRow = "none";
		},

		_getDatapool: function() {
			if(this.parentCallBack) {
				var datapool = this.parentCallBack.getSelectedDataPool();
				return (datapool)? datapool : null;
			}
			return null;
		},

		_removeAllVariables: function(){
			for(var i=0; i<this._steps.length; i++){
				var content = this._steps[i].content;
				content = unescape(content);
				while (true) {
					var p1 = content.indexOf("<button");
					if (p1 == -1) 
						break;
					var p2 = content.indexOf("</button>", p1 + 2);
					content = content.substring(0, p1) + content.substring(p2 + 9);
				}
				this._steps[i].content = content;
			}
			this.updateSteps();
		}
	}
);
})();
