/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading.. com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemEditor");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemEditor");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemEditor");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){ // module container
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var WorkItemUtil = com.ibm.team.workitem.web.client.util;
    var checkNotNull = net.jazz.ajax.toolbox.lang.checkNotNull;
    var WorkItemClient = com.ibm.team.workitem.web.client.internal.WorkItemClient;
    var DEFAULT_TAB = "overview";
    
    var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
    var isGuest = com.ibm.team.repository.web.client.session.isGuest;
    
    
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemEditor", [com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemEditor], {
    
    
        setCallback: function(/* Function */callbackObj){
            this.callback = callbackObj;
        },
        
        _error: function(){
            alert("Error: (message: '" + errorObj.message + "') from DefectView#_error");
        },
        
        ////////////////////////////////////////////
        //OVERRIDDEN METHODS FROM WORKITEM EDITOR
        ////////////////////////////////////////////
        
        //@override from WorkItemEditor
        viewWorkItem: function(id, initialTab){
            checkNotNull(id);
            
            var self = this;
            var serviceObject = {
                viewWorkItemHandler: function(workItem){
                    if (workItem) {
                        self.setWorkItem(workItem, "overview");
                        //self.addDefect();
                        if (self.callback) {
                            self.callback(self._wiEditor._workItem);
                        }
                    } else {
                        alert(Constants.getMessage("msgWorkItemNotFound", id));
                    }
                },
                error: function(error){
                    self._error(error, "Error viewing work item");
                }
            };
            
            var responseHandler = new ServiceResponseHandler(serviceObject, "viewWorkItemHandler", "error");
            WorkItemClient.getWorkItemDTO(responseHandler, {
                id: id
            });
        },
        
        //@override from WorkItemEditor
        _saveCallback: function(savedWorkItemId, op){
            if (op) {
                this.parentController.finishOperation(op);
            }
            if (this.callback) {
                this.callback(savedWorkItemId);
            }
            else {
                this.parentController.setIsDirty(this, false);
                if (this.isNewWorkItem()) {
                    this.parentController.removeEditorTab(-1);
                    this.viewWorkItem(savedWorkItemId, this._getCurrentTab());
                } else {
                    this._editorParts.overview.clearNewCommentText();
                    this.refresh(/*skipConfirmation*/true);
                }
                this._isDirty = false;
            }
        },

        //@override from WorkItemEditor
        setWorkItem: function(workItem, tab){
            this.inherited("setWorkItem", arguments, [workItem, tab]);
        },
        
		//@override from WorkItemEditor. Update dialog's position when loading completely. 
		_setEditableProperties: function(workItem, editProps, presentationProps, initialTab,  retainedState, isTypeChange, newTypeId) {
			this.inherited("_setEditableProperties", arguments, [workItem, editProps, presentationProps, initialTab,  retainedState, isTypeChange, newTypeId]);
			if(this.parentController && this.parentController._workItemPageView && this.parentController._workItemPageView.dialog) {
				this.parentController._workItemPageView.dialog.updatePosition();
			}
		},
		
        //@override from WorkItemEditor
        _createTabPart: function(logicalName, widget, tabLinkLabel){
        
            this.inherited("_createTabPart", arguments, [logicalName, widget, tabLinkLabel]);
            if (this._tabLinkContainer) {
                for (var i = 0; i < this._tabLinkContainer.childNodes.length; i++) {
                    if (this._tabLinkContainer.childNodes[i] && this._tabLinkContainer.childNodes[i].__jazzTabName == logicalName) {
                        dojo.connect(this._tabLinkContainer.childNodes[i], "onclick", this, "_handleTabClick");
                    }
                }
            }
        },
		
        _handleTabClick: function(e)
        {
			if (e.stopPropagation) {
				e.stopPropagation();
            	e.preventDefault();
			}
			e.cancelBubble = true;
			e.returnValue = false;
            this.showTab(e.currentTarget.__jazzTabName);
			return false;
        },
		
		//In pop-up Work Item Editor, there is no "recent viewed vork item", so needn't it
		_sendChangedEvent: function(reason) {
//			dojo.publish("workitem/editorChanged", [this._workItem]);
		},
        		
        /**
         * Save the changes to work item currently displayed in the editor.
         */
        save: function() {
            // this gets run in the context of work item application controller
            var op= this.parentController.createOperation("Saving Work Item", "saveWorkitem");
            this.parentController.startOperation(op);
            this._editorParts.header.markBusy("Saving");
            this._editorParts.header.disableSave(true);

            
            var self= this;
            var serviceObj= {
                success: function(workItem) {
                    self._clearRetainedState();
                    self._saveCallback(workItem.attributes.id.id, op);
                },
                failure: function(errorObj) {
                    self._saveErrorCallback(errorObj, op);
                    self._editorParts.header.markFullyLoaded();
                }
            };
            var responseHandler= new ServiceResponseHandler(
                serviceObj,
                "success",
                "failure");

            var appArgs = this._getSaveAppArgs();
            
            WorkItemClient.postWorkItem(responseHandler, appArgs);
        }
		
    });
    
})();
