/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemPageController");

dojo.require("com.ibm.team.workitem.web.ui.internal.page.WorkItemPageController");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

(function() {
var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var WorkItemClient			= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var EventTopics				= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.properties._workItem.QMWorkItemPageController", [com.ibm.team.workitem.web.ui.internal.page.WorkItemPageController],
{
	_setPageTitle: function(title) {
	    //PlatformUI.getWorkbench().setTitle(title);
	},
	
	
		////////////////////////////////////////////
		//OVERRIDDEN METHODS FROM WORKITEM CONTROLLER TO UPDATE DIALOG
		////////////////////////////////////////////
		
	_fetchWorkItem: function(operation, typeId, categoryItemId) {
		var self = this;
		var handlerObj= {
			newWorkItemHandler: function(workItem) {
				self._promoteAttributes(workItem);
				self._workItemPageView.showWorkItemEditor(workItem);
				//Check if parentWidget and update Dialog
				if(self._workItemPageView.parentWidget)
					self._workItemPageView.parentWidget.updateDialog(self._workItemPageView._multipaneContentWidget.domNode);
				if (operation) {
					self.finishOperation(operation);
				}
				dojo.publish(EventTopics.INITIALIZE_QUERIES, []);
			},
			error: function(error) { 
				self.handleError(error, "Error creating new work item");
				dojo.publish(EventTopics.INITIALIZE_QUERIES, []);
			}
		};

		var responseHandler=
			new ServiceResponseHandler(handlerObj, "newWorkItemHandler", "error");

		typeId = typeId ? typeId : "defect";
		var args = { typeId: typeId, newWorkItem: "true" };
		if(categoryItemId) {
			args.categoryItemId = categoryItemId;
		}

		
		WorkItemClient.getWorkItem(responseHandler,args );
	},
	
	_updateURL: function(url){
		//Do Nothing
	}

	
});

})();
	 
