/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution");

//Dojo widget
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dijit.form.Button");
dojo.require("dojo.parser");

dojo.require("net.jazz.ajax.ui.internal.HoverPopup");
// Clients
dojo.require("com.ibm.team.repository.web.foundation.Status");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.defects.web.client.DefectsManager");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog");
dojo.require("com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredDialog");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.DeferredListDialog");
dojo.require("com.ibm.rqm.defects.web.ui.view.common.ProgressDialog");
dojo.require("com.ibm.rqm.defects.web.ui.utils.WindowUtil");
dojo.require("com.ibm.team.repository.web.foundation.NullProgressMonitor");

dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient");
// Require local widgets
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.KeywordExecution");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function() { // module container

var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var TeamServerClient 				= com.ibm.team.repository.web.transport.TeamServerClient;
var DOWNLOAD_SERVICE_URI 			= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/";
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var HoverPopup 						= net.jazz.ajax.ui.internal.HoverPopup;
var getCurrentProjectArea 			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

var ResultClient					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var ExecutionWorkItemClient 		= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var ImageCache						= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
var ERGClient						= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient;
var ExecutionClient					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient;

var TestScriptClient				= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
var RegistryClient     				= com.ibm.rqm.planning.web.client.internal.RegistryClient;
var DefectView						= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.DefectView;
var AttachmentView					= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.AttachmentView;
var CommentView						= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CommentView;
var CompareView						= com.ibm.rqm.planning.web.ui.internal.view.construction.properties.CompareView;
var StepResultStates				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates;
var ResultStates					= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;

var DatapoolClient           		= com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );

var getDefectsManager				= com.ibm.rqm.defects.web.client.DefectsManager.getInstance;
var WorkItemSelectionDialog			= com.ibm.rqm.defects.web.ui.workitems.WorkItemSelectionDialog;
var AssociatedWorkItemViewer		= com.ibm.rqm.defects.web.ui.workitems.AssociatedWorkItemViewer;

var ProgressDialog					= com.ibm.rqm.defects.web.ui.view.common.ProgressDialog;
var DeferredDialog					= com.ibm.rqm.defects.web.ui.view.common.DeferredDialog;
var WindowUtil						= com.ibm.rqm.defects.web.ui.utils.WindowUtil;
var NullProgressMonitor				= com.ibm.team.repository.web.foundation.NullProgressMonitor;

var COMMENT_VIEW_TYPE				= "commentView";
var DEFECT_VIEW_TYPE				= "defectView";
var RTC_DEFECT_VIEW_TYPE			= "rtcdefectView";
var ATTACHMENT_VIEW_TYPE			= "attachmentView";
var RESULT_ATTACTMENT_VIEW_TYPE		= "result AttachmentView";
var COMPARE_VIEW_TYPE				= "compareView";
var KEYWORD_TYPE					= "keyword";
var KEYWORD_STEP_COMPARE			= "keyword step";
var Status                          = "com.ibm.team.repository.web.foundation.Status";


dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ManualExecution",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/execution/ManualExecution.html"),
		
		labelType: Constants.getMessage("labelType"),
		labelResult: Constants.getMessage("labelResult"),
		labelDescription: Constants.getMessage("labelDescription"),
		labelKeywordExecutionProgress: Constants.getMessage("labelKeywordExecutionProgress"),
		labelAttachmentsView: Constants.getMessage("labelAttachmentsView"),
		labelDefectsView: Constants.getMessage("labelDefectsView"),
		labelCommentsView: Constants.getMessage("labelCommentsView"),
		
		widgetsInTemplate:true,
		ewi: null,
		script: null, 
		testcase: null,
		scriptId: null,
		_steps: [],
		_results: [],
		_stepTypes: [],	
		_startTime: null,
		_endTime: null,
		_currentStepNumber: 0,
		_currentIterNumber: 0,
		_resultId: null,
		_resultTypes: [],		
		parentController: null,
		kwScripts: [],
		inProgress: false,
		originalStepNum: null,
		isExecutionOver: false,
		//for Datapool: 
		_cells: [],
		keywordsWithoutVerdicts:[],

		postCreate: function() 
		{		
			//We will receive this.ewiItemId and this.runScriptId
			this.stepProperties = [];
			this.stepEERArray = [];
			
			this._stepTitle.innerHTML = Constants.getMessage("labelScriptSteps");
			this._attachment.src = ImageCache.ATTACHMENT_VIEW;
			this._comment.src = ImageCache.COMMENT_VIEW;
			this._defect.src = ImageCache.DEFECT_VIEW;
			this._dropdown.src = ImageCache.DROPDOWN_ARROW;
			this._pause.src = ImageCache.PAUSE_ICON;
			this._pause.title = Constants.getMessage("labelClickToPauseExe");
			this._resume.title = Constants.getMessage("labelClickToResumeExe");
			this._resume.style.display = 'none';
			this._attachment.title = Constants.getMessage("labelShowAttach")
			this._comment.title =Constants.getMessage("labelShowComments")
			this._defect.title = Constants.getMessage("labelShowDefects");
			this._stepsTable.className = "item-table";
			this._stepsHaveVerdict = this.parentController.getStepsHaveVerdict();
			
			this.ID_KW_TYPE= this.id+"_kwType";
			this.ID_KW_SUMMARY= this.id+"_kwSummary";
			this.TR_ID=this.id + "_tr";
			this.IMG_ID = this.id+"_img";
			this.STEP_DESC_ID = this.id+"_stepDesc";
			this.RESULT_ID = this.id+"_results"
			this.PROPS_ID = this.id+"_prop"
			this.DEFECT_ICON = this.id+"_defectIcon"
			this.DEFECT_ID	= this.id+"_defect"
			this.ATTACH_ICON = this.id+"_attachIcon"
			this.ATTACH_ID = this.id+"_attach"
			this.COMMENT_ICON = this.id+"_commentIcon"
			this.COMMENT_ID = this.id+"_comment"
			this.COMPARE_ICON = this.id+"_compareIcon"
			this.COMPARE_ID = this.id+"_compare"
			this._dropdown.id = this.id+"dropdownIcon";
			
			//Create 2 buttons for Apply and Apply All
			this._applyButton.src = ImageCache.APPLY;
			this._applyButton.title = Constants.getMessage("labelApply");
			this.applyButtonClickEvent = dojo.connect(this._applyButton, "onclick", this, this.onApply);
			this.applyButtonEnterEvent = dojo.connect(this._applyButton, "onkeypress", this, this._onEnterApply);
			
			this._applyAllButton.src = ImageCache.APPLY_ALL;
			this._applyAllButton.title = Constants.getMessage("labelApplyAll");
			this.applyAllButtonClickEvent = dojo.connect(this._applyAllButton, "onclick", this, this._applyVerdictForAllStepsRemaining);
			this.applyAllButtonEnterEvent = dojo.connect(this._applyAllButton, "onkeypress", this, this._onEnterApplyAll);
			
			if(window.screen.width < 1025){
				this._firstToolBarNode.style.width = "17%";
				this._lastToolBarNode.style.width = "60%";
			}
			var responseHandler = new ServiceResponseHandler(this, "_setInitialValues", "_error");			
			ExecutionWorkItemClient.getExecutionWorkItemByItemId(responseHandler, {itemId: this.ewiItemId});
		},

		_setInitialValues: function(ewi)
		{
			this.ewi = ewi;
			if(this.ewi.testCase != null)
				this.testcase = this.ewi.testCase.name;
			if(this.runScriptId == null)
				this.runScriptId = this.ewi.defaultScript.id;
			this._connectMouseListeners();
			
            var handler= new ServiceResponseHandler(this, "_initStateTypes", "_error");
			RegistryClient.getAllExecutionElementResultStateTypes(handler);
		},
		
		_initStateTypes: function(types)
		{
			dojox.data.dom.removeChildren(this._resultSelectBox);
			this._resultTypes = types;
			if(types != null){
				for (var i = 0; i < types.length; i++){
					if(types[i].id == "com.ibm.rqm.execution.common.state.complete")
						continue;
					var opt = new Option(types[i].name, types[i].id);
					if(types[i].id === "com.ibm.rqm.execution.common.state.passed")
						opt.selected = true;
					SelectUtility.add( this._resultSelectBox, opt );
				}
			}
			if(this._resultId == null){
				var responseHandler = new ServiceResponseHandler(this, "_initializeLog", "_error");			
				TestScriptClient.getTestScript(responseHandler, this.runScriptId);
			}else{
				var args = { resultItemId: this._resultId }
				var responseHandler = new ServiceResponseHandler(this, "_getResult", "_error");
		    	ResultClient.getExecutionResultDTO(responseHandler, args);
			}
		},
		
		_getResult: function(result)
		{
            this._ER = result;
			this._resultStateId = result.stateId;
			this._initializeLog([result.script]);
		},
		
		_initializeLog: function(params)
		{
			this.script = params[0];
			if(this.script.elements == null){
				this._displayAlertDialog(Constants.getMessage("msgNoStepInScript"));
				this._toggleApplyButton(true);
				this._disableImages();
				this._pause.src = ImageCache.NOIMAGE;
				this.script.elements = [];
				return;
			}
			// find the related datapool
			var self = this;
			var callbackObj = {
				success: function(results){
					self._datapool = results && results.length == 1 ? results[0] : null;
					self._iterations = (self._datapool && self._datapool.records && self._datapool.records.length > 0) ? self._datapool.records.length: 1;
					self.initIteration();
					self.initialise();
				},
				failure: function(e){
					console.error("Failed to find related Test Data");
				}
			}
			var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
			DatapoolClient.getDatapoolDTOs(responseHandler, {
				linkedTestScriptUUID: this.script.itemId,
				linkedTestScriptStateUUID: this.script.stateId,
				isIterationRequired: true,
				isDataRequired: true
			});
		},
	
	    initIteration: function(){
            if (this._datapool && this._datapool.records && this._datapool.records.length > 0) {
                for (var i = 1; i <= this._iterations; i++) {
                    var opt = new Option(i, i);
                    SelectUtility.add(this._iterationSelect, opt);
                }
                SelectUtility.select(this._iterationSelect, this._iterations);
                this._iterationSelect.style.display = "inline";
            } 
        },
		
		initialise: function(){
			this._steps = new Array(this.script.elements.length*this._iterations);
			this._stepTypes = new Array(this.script.elements.length*this._iterations);
			this._results = new Array(this.script.elements.length*this._iterations);
			this.kwScripts =  [];
			this.stepProperties = [];
			this._paused = false;
			for (var i = 0; i < this.script.elements.length * this._iterations; i++){
				this._stepTypes[i] = this.script.elements[i%this.script.elements.length].elementType.name; 
				this._steps[i] = this.script.elements[i%this.script.elements.length].content;
				this._results[i]="";
				if(this.script.elements[i%this.script.elements.length].properties != null && this.script.elements[i%this.script.elements.length].properties.length != 0)
					this.stepProperties[i] = this.script.elements[i%this.script.elements.length].properties;
				else
					this.stepProperties[i] = {}; 	
			}
            if(this._ER && this._ER.elementResults){
                for(var j=0;j<this._ER.elementResults.length;j++)
                    this.stepProperties[j] = this._ER.elementResults[j].properties;
            }
			this._disableResultSelectBox(false);
			if(this._resultId == null)
				this._collectDateTime("start");
            this._resume.style.display = 'none';    
			dojox.data.dom.removeChildren(this._stepsTableBody);
			
			// present the initial iteration
			for(var i = 0; i < this.script.elements.length; i++){
				this._appendEditableStepRow(null, i + this._currentIterNumber * this.script.elements.length, this.script.elements[i], this._currentIterNumber);
			}
			
			if (this._iterations > 1) {
				this._updateIteration();
			}

			if ((this._currentIterNumber + 1) == this._iterations) {
					//Add one extra row for pointer to move after execution
					this._appendEditableStepRow(null, this.script.elements.length * this._iterations, null, 1);	
			}
			if (this._resultId != null) {
                this._updateTableForIncompleteExecution(this._ER);
            }
            else {
                this.setProperties(this.stepProperties[this._currentStepNumber]);
                if (this._currentStepNumber == 0 && this._stepTypes[this._currentStepNumber] == "Keyword") {
                    var keywordId = this._getKeywordId(this._currentStepNumber, false);
                    if (this.kwScripts[keywordId] == null) {
                        this._waitTimer(keywordId);
                    }
                    else {
                        if (this.kwScripts &&
                        this.kwScripts[keywordId].script.scriptType.id != "com.ibm.rqm.planning.common.scripttype.manual") {
                            this._createKeywordDialog();
                        }else{
							this._disableResultSelectBox(false);
						}
                    }
                }
            }
		},
		
		_updateTableForIncompleteExecution: function(result){
			this._resultStateId = result.stateId;
			this._elementResults = result.elementResults;
            this._resultIdInt = result.id;
			var count = this._elementResults.length;
			this._currentStepNumber = 0;
			for(var i = 0; i < count; i++){
                this.stepEERArray[i] = this._elementResults[i];
				this._updateResult(this._elementResults[i].result, this._currentStepNumber);
				this._moveStepPointer(true);
				this._currentStepNumber = this._currentStepNumber+1;
			}
            if (this._currentStepNumber == this.script.elements.length * this._iterations) {
				this.parentWidget.updateProgress(100);
                this._setCurrentResult(this._elementResults[count-1],false);
                return;
            }
			this._updateProgressBar();
			//Update Properties for only last execution element result
			this.setProperties(this.stepProperties[this._currentStepNumber]);
			this._startTime = result.startTime;
			this._disableResultSelectBox(false);
			if(this._stepTypes[this._currentStepNumber] == "Keyword"){
                var keywordId = this._getKeywordId(this._currentStepNumber,false);
				if(!keywordId || this.kwScripts[keywordId] == null){
					this._waitTimer(this._currentStepNumber);
				}
				else{
					if(this.kwScripts && keywordId && 
                       this.kwScripts[keywordId].script.scriptType.id != "com.ibm.rqm.planning.common.scripttype.manual"){
                            this._createKeywordDialog();
					}
				}
			}
		},
		
        ////////////////////////////////
		// Layout 
		////////////////////////////////		
		_createPropertiesHtml: function(stepNum,properties){
			var attachCell = this._getEmptyCell();
			attachCell.id = this.ATTACH_ID+stepNum;
			attachCell.align = "right";  
            attachCell.width = "3%";
			var defectCell = this._getEmptyCell();
			defectCell.id = this.DEFECT_ID+stepNum;
			defectCell.align = "right";
            defectCell.width = "3%"; 
			var commentCell = this._getEmptyCell();
			commentCell.id = this.COMMENT_ID+stepNum;
			commentCell.align = "right";
            commentCell.width = "3%"; 
			var compareCell = this._getEmptyCell();
			compareCell.id = this.COMPARE_ID+stepNum;
			compareCell.align = "right";
            compareCell.width = "3%"; 

			var defectFound = false; var attachmentFound = false; var commentFound = false;
			var attachmentCount= 0;
			var defectCount = 0;
			var defectsHtml = document.createElement("span");
			var attachmentsHtml = document.createElement("span");
			var attachmentsHtmlTable = attachmentsHtml.appendChild(document.createElement("table"));
			var attachmentsHtmlContent = attachmentsHtmlTable.appendChild(document.createElement("tbody"));
			var commentsHtmlContent = document.createElement("span");
			if(properties){
				for(var i=0;i<properties.length;i++){
					switch(properties[i].propertyType){
						case DEFECT_VIEW_TYPE:
						case RTC_DEFECT_VIEW_TYPE:
							if(defectFound == false){
								var defectLabel = document.createElement("label");
								var defectImg = document.createElement("img");
								defectImg.alt= Constants.getMessage("labelDefects");
								defectImg.src = ImageCache.DEFECT;
								defectImg.className = "type-image";
								defectImg.id = this.DEFECT_ICON + stepNum;
								defectLabel.appendChild(defectImg);
								defectImg.setAttribute("tabIndex", 0);
								defectLabel.style.cursor = "pointer";
								defectCell.appendChild(defectLabel);
								defectLabel.onclick = dojo.hitch(this,this._showDefect,stepNum,properties[i].propertyType);
								if (dojo.isIE) {
									defectImg.onkeypress = dojo.hitch(this, function(){
										this._showDefectByPress(event, stepNum, defectImg);
									});
								}
								else {
									defectImg.onkeypress = dojo.connect(defectImg, "onkeypress", this, function(e){
										this._showDefectByPress(e, stepNum, defectImg);
									});
								}
								defectFound = true;
							}							
							defectCount++;							
							break;

						case ATTACHMENT_VIEW_TYPE:
						case RESULT_ATTACTMENT_VIEW_TYPE:
							var valueArr = properties[i].propertyValue.split(":");
							var attachmentsText = valueArr[0];
							var attachUrl = TeamServerClient._getServicePrefix()+ DOWNLOAD_SERVICE_URI + valueArr[3];
							if(attachmentFound == false){
								var attachImg = document.createElement("img");
								attachImg.alt= Constants.getMessage("labelAttachment");
								attachImg.src = ImageCache.ATTACHMENT;
								attachImg.className = "type-image";
								attachImg.id = this.ATTACH_ICON + stepNum;	
								attachImg.setAttribute("tabIndex", 0);							
								attachCell.appendChild(attachImg);
								attachmentFound = true;
								dojox.data.dom.removeChildren(attachmentsHtmlContent);
								if (dojo.isIE) {
									attachImg.onkeypress = dojo.hitch(this,function(){
										this._showAttachByPress(event, attachUrl);
									});
								}
								else {
									attachImg.onkeypress = dojo.connect(attachImg, "onkeypress", this, function(e){
										this._showAttachByPress(e, attachUrl);
									});
								}
							}
							attachmentCount++;
							var attachmentsHtmlContentRow = this._getEmptyRow();
							var attachmentsHtmlContentCell = this._getEmptyCell();
							var attachmentsAnchor = document.createElement("a");
							attachmentsAnchor.target = "_blank";
							attachmentsAnchor.appendChild(document.createTextNode(attachmentsText));
							attachmentsAnchor.href = attachUrl;
							attachmentsHtmlContentCell.appendChild(attachmentsAnchor);
							attachmentsHtmlContentRow.appendChild(attachmentsHtmlContentCell);
							attachmentsHtmlContent.appendChild(attachmentsHtmlContentRow);
							break;

						case COMMENT_VIEW_TYPE:
							commentFound = true;
							dojox.data.dom.removeChildren(commentsHtmlContent);
							commentsHtmlContent.appendChild(document.createTextNode(properties[i].propertyValue));
							var commentImg = document.createElement("img");
							commentImg.alt= Constants.getMessage("labelComment");
							commentImg.src = ImageCache.COMMENT;
							commentImg.className = "type-image";
							commentImg.id = this.COMMENT_ICON + stepNum;
							commentImg.setAttribute("tabIndex", 0);
							commentCell.appendChild(commentImg);
							break;
						case COMPARE_VIEW_TYPE:
							if(!dojo.byId(this.COMPARE_ICON + stepNum)){
								var compareButton = document.createElement("button");
								if(dojo.isIE >= 7)
									compareButton.style.backgroundColor = '#FFFFFF';
								else
									compareButton.style.background = "inherit";
								compareButton.style.border="0pt";
								var compareImg = document.createElement("img");
								compareImg.alt= Constants.getMessage("labelCompare");
								compareImg.src = ImageCache.COMPARE;
								compareImg.className = "type-image";
								compareImg.setAttribute("tabIndex", 0);
								compareButton.id = this.COMPARE_ICON + stepNum;
								compareButton.appendChild(compareImg);
								compareCell.appendChild(compareButton);
								dojo.connect(compareButton, "onclick", this,dojo.hitch(this,"_showCompareDialog",stepNum,null));
								break;
							}
						default:
							//do Nothing
					}
				}	
			}
			var tooltip;
			if(attachmentCount>0){
				var _attachmentTooltipSpan = document.createElement("span");
				attachCell.appendChild(_attachmentTooltipSpan);
				var attachmentCountText = document.createTextNode("("+attachmentCount+")");
				dojo.style(attachCell,"fontSize","0.7em");
				attachCell.appendChild(attachmentCountText);
				tooltip = new HoverPopup({connectNode: [attachImg],label: attachmentsHtml.innerHTML}, _attachmentTooltipSpan);
			}
			if(defectCount>0){
				var _defectTooltipSpan = document.createElement("span");
				defectCell.appendChild(_defectTooltipSpan);
				var defectCountText = document.createTextNode("("+defectCount+")");
				dojo.style(defectCell,"fontSize","0.7em");
				defectCell.appendChild(defectCountText);
				defectsHtml.appendChild(document.createTextNode(Constants.getMessage("labelDefectIconText")));
				tooltip = new HoverPopup({connectNode: [defectImg]}, defectsHtml);				
			}	
			if(commentFound ===true){
				var _commentTooltipSpan = document.createElement("span");
				commentCell.appendChild(_commentTooltipSpan);
				tooltip = new HoverPopup({connectNode: [commentImg],label:commentsHtmlContent.innerHTML}, _commentTooltipSpan);				
			}
			return [attachCell,defectCell,commentCell,compareCell];
		},		

		_appendEditableStepRow: function(targetRow, step, stepObj, iteration){
            var stepNum = step;
			if ( targetRow == null ){
				targetRow = this._getEmptyRow();
				targetRow.id = this.TR_ID+step;
				this._stepsTableBody.appendChild(targetRow);
			}
			dojox.data.dom.removeChildren(targetRow);
			//Step image
			var stepCell = this._getEmptyCell();
			var stepImg = document.createElement("img");
			stepImg.title = "";
			stepImg.alt= "";
			if((stepNum < this._iterations * this.script.elements.length) && (stepNum % this.script.elements.length == 0))
				stepImg.src = ImageCache.EXECUTION_ARROW;
			else
				stepImg.src= ImageCache.NOIMAGE;	
			stepImg.className = "type-image";
			stepImg.id = this.IMG_ID+ stepNum;
			
			stepCell.appendChild(stepImg);			
			targetRow.appendChild(stepCell);
			
			//step number cell
			var numCell = this._getEmptyCell();
            if(!stepObj)
                numCell.appendChild(document.createTextNode(""));
            else
			    numCell.appendChild(document.createTextNode(stepNum+1));
			targetRow.appendChild(numCell);
			
			//step type cell
			var typeCell = this._getEmptyCell();
			var typeImg = document.createElement("img");
            if (!stepObj) 
                typeImg.src = ImageCache.NOIMAGE;
            else {
                typeImg.title = this.script.elements[stepNum % this.script.elements.length].elementType.name;
                typeImg.alt = this.script.elements[stepNum % this.script.elements.length].elementType.name;
                typeImg.src = ImageCache.getTypeIconURL(this.script.elements[stepNum % this.script.elements.length].elementType);
            }
			typeImg.className = "type-image";
			typeCell.appendChild(typeImg);
			targetRow.appendChild(typeCell);
            
			//result type cell
			var resultCell = this._getEmptyCell();
			var resultSelect = document.createElement("img");
			resultSelect.title = "";
			resultSelect.alt = "";
			resultSelect.src = ImageCache.NOIMAGE;
			resultSelect.className = "";
			resultSelect.id = this.RESULT_ID + stepNum;
			resultCell.appendChild(resultSelect);			
			targetRow.appendChild(resultCell);
			
			//step name / description cell
			var descriptionCell = this._getEmptyCell();
			var descriptionInput = document.createElement('div');
            if(!stepObj){
                descriptionInput.innerHTML = "";
                this.execOverField =descriptionInput;
            }
            else
			    descriptionInput.innerHTML = unescape(this._steps[stepNum]);
			descriptionInput.id = this.STEP_DESC_ID + stepNum;
			descriptionCell.appendChild(descriptionInput);	
			targetRow.appendChild(descriptionCell);
			
			//deal with Datapool value: 
            if(stepObj)
				this._replaceVariable(descriptionInput, iteration);
            //keyword
            if(stepObj && stepObj.elementType && stepObj.elementType.name == "Keyword"){
				var keywordId = this._getKeywordId(step,false);
				var keywordExternalId = this._getKeywordId(step,true);
				if(!keywordId && !keywordExternalId)
					return;
                if(this.kwScripts && keywordId && this.kwScripts[keywordId]){
					this._insertKeyword(targetRow,this.kwScripts[keywordId], step);
                    return;
                }
                var self = this;
				var callbackObj = {
					success: function(items){
						self.kwScripts[items[0].id] = {};
                        self.kwScripts[items[0].id].name = items[0].name;
                        self.kwScripts[items[0].id].script = items[0].defaultScript ? items[0].defaultScript:items[0].manualScript;
						self.stepProperties[step].push({
							propertyName:"scriptId",
							propertyType:KEYWORD_TYPE,
							propertyValue:self.kwScripts[items[0].id].script.id+""
						});
						self.stepProperties[step].push({
							propertyName:"scriptStateId",
							propertyType:KEYWORD_TYPE,
							propertyValue:self.kwScripts[items[0].id].script.stateId
						});
						if(step == self._currentStepNumber)
						    self.setProperties(self.stepProperties[step]);
						self._insertKeyword(targetRow,self.kwScripts[items[0].id], step);
					},
					failure: function(e){
						self._error(e);
					}				
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				if (keywordId != null) {
					com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.getKeywordDTO(responseHandler, {
						id: keywordId,
						includeArchived: true
					});
				}else if(keywordExternalId != null)	{
					com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient.getKeywordDTO(responseHandler, {
						externalId: keywordExternalId,
						includeArchived: true
					});
				}
			}
			else {
                //Changes for Properties 
                var properties = [];
                if(stepObj)
                    properties = this.stepProperties[stepNum];
                propshtml = this._createPropertiesHtml(stepNum, properties);
                targetRow.appendChild(propshtml[0]);
                targetRow.appendChild(propshtml[1]);
                targetRow.appendChild(propshtml[2]);
                targetRow.appendChild(propshtml[3]);
            }                
		},
		
		_insertKeyword:function(targetRow,keyword,stepNum){
            var oldDescriptionCell = dojo.byId(this.STEP_DESC_ID + stepNum).parentNode;
			//step name / description cell
			var descriptionCell = this._getEmptyCell(5);	
			var descriptionElement = null;
			descriptionElement = document.createElement("table");
			var descriptionElementBody = document.createElement("tbody");
			descriptionElement.width = "100%";
			descriptionElement.id = this.ID_KW_SUMMARY + stepNum;
			var descriptionRow = this._getEmptyRow();
			var descriptionInnerCell = this._getEmptyCell(2);
            descriptionInnerCell.width = "70%";
			var detailsDiv = document.createElement('div');
			detailsDiv.innerHTML = unescape(keyword.name);
			descriptionInnerCell.appendChild(detailsDiv);
			descriptionRow.appendChild(descriptionInnerCell);
			descriptionElementBody.appendChild(descriptionRow);
			descriptionElement.appendChild(descriptionElementBody);
			descriptionCell.appendChild(descriptionElement);
			var properties = this.stepProperties[stepNum];
			var propshtml = this._createPropertiesHtml(stepNum,properties);
			descriptionRow.appendChild(propshtml[0]);
			descriptionRow.appendChild(propshtml[1]);
			descriptionRow.appendChild(propshtml[2]);
			descriptionRow.appendChild(propshtml[3]);			
            var script = keyword.script;
			//script statements
			if(script && script.elements)
			{	
				hasVerdict = false;
				for(var i=0;i<script.elements.length;i++)
				{
					var keywordStepsRow = this._getEmptyRow();
					var typeCell2 = this._getEmptyCell();
					dojo.style(typeCell2,"width","16px");
					var typeElementChild = document.createElement("img");
					typeElementChild.id = this.ID_KW_TYPE + stepNum;
					typeElementChild.title = script.elements[i].elementType;
					typeElementChild.alt= script.elements[i].elementType;
					typeElementChild.src= ImageCache.getTypeIconURL(script.elements[i].elementType);
					typeElementChild.className = "type-image";
					typeCell2.appendChild(typeElementChild);
					if(script.elements[i].elementType.name != "Execution Step")
						hasVerdict = true;
					keywordStepsRow.appendChild(typeCell2);					
					var keywordCell = this._getEmptyCell();
					var keywordSteps = document.createElement('div');
					keywordSteps.innerHTML = unescape(script.elements[i].content);
					keywordCell.appendChild(keywordSteps);
					keywordCell.width = "85%";
					keywordStepsRow.appendChild(keywordCell);
					var stepProperties = script.elements[i].properties;
					if(stepProperties){
						for(var j=0;j<stepProperties.length;j++){
							if(stepProperties[j].propertyType == COMPARE_VIEW_TYPE){
								this.stepProperties[stepNum].push({
									propertyName:i+"",
									propertyValue:stepProperties[j].propertyName+"#"+stepProperties[j].propertyValue,
									propertyType:KEYWORD_STEP_COMPARE
								});
							}
						}
					}
					var stepPropshtml = this._createPropertiesHtml(stepNum+"_"+i,stepProperties);
					keywordStepsRow.appendChild(stepPropshtml[0]);
					keywordStepsRow.appendChild(stepPropshtml[1]);
					keywordStepsRow.appendChild(stepPropshtml[2]);
					keywordStepsRow.appendChild(stepPropshtml[3]);
					descriptionElementBody.appendChild(keywordStepsRow);
				}
				if(!hasVerdict){
					this.keywordsWithoutVerdicts[stepNum] = true
				}
			}
            targetRow.replaceChild(descriptionCell,oldDescriptionCell);
			if(stepNum == this._currentStepNumber)
				this.setProperties(this.stepProperties[stepNum]);
		},
		
		_getEmptyRow: function() 
		{
			var row = document.createElement("tr");
			row.className = "item-table-row";
			return row;
		},
		
		_getEmptyCell: function(span, align) 
		{
			var cell = document.createElement("td");
			cell.className = "steps-table-cell";
			if ( span != null ){
				cell.colSpan = span;
			}
			if ( align != null ){
				cell.align = align;
			}
			return cell;
		},
        
		////////////////////////////////
		// Main Execution related stuff
		////////////////////////////////
		onSelectIteration: function(){
			this._iterations = this._iterationSelect.value;
			this.initialise();
		},

		onApply: function(returnToKeyword){
			if(!this._iterationSelect.disabled){
				this._iterationSelect.disabled = true;
			}

			if(this._resultId != null)
			{
				if(returnToKeyword == true)
					return;
				this._toggleApplyButton(true);
				this._pause.src = ImageCache.PAUSE_ICON;
				if(this._currentStepNumber == this.script.elements.length * this._iterations){
					this.parentWidget.enableNavigationToResultPage();
					return;
				}
                var result = this._getStepResult(this._currentStepNumber);
				//Call service to store the result: service needs index from 1
				var args = {	
					ewiItemId: this.ewi.itemId,
					stepIndex: this._currentStepNumber%this.script.elements.length,
					executionResult: this._resultId,
					resultElementStateTypeId: result.id,
					resultStateId:this._resultStateId
				}
				if(this._currentStepNumber == 1){
					args.startTime = parseInt(this._startTime);
					args.endTime = parseInt(this._startTime);	
				}
                if (this.stepEERArray[this._currentStepNumber]) {
                    args.stepItemId = this.stepEERArray[this._currentStepNumber].internalId;
                    args.resultElementStateTypeId = this._getStepResult(this._currentStepNumber).id;
                    var removeAttachmentItemIds = this._buildAttachmentIdList(this.stepEERArray[this._currentStepNumber].properties);
                    if(removeAttachmentItemIds.length>0)
                        args.removeAttachmentItemIds = removeAttachmentItemIds;
                }
    			var properties = this.getProperties();
                if(properties.length > 0)
                    args.addProperties = properties;
                var addAttachmentItemIds = this._buildAttachmentIdList(properties);
                if(addAttachmentItemIds.length > 0)
                    args.addAttachmentItemIds = addAttachmentItemIds;
				var defectIdList = this._buildDefectIdList(properties);
                if(defectIdList.length>0)
                    args.defectIds = defectIdList;
                if(this._currentStepNumber == this.script.elements.length * this._iterations -1){
				    this._collectDateTime("stop");
					args.startTime = parseInt(this._startTime);
					args.endTime =  parseInt(this._endTime);
					args.machine =  Constants.getMessage("labelLocalComputer");
					args.owner = getAuthenticatedContributor().userId;
                }
                else
                    args.resultState = ResultStates.IN_PROGRESS;
				var responseHandler=new ServiceResponseHandler(this, "isEndOfExecution", "_saveError");
	    		ResultClient.postApplyResult(responseHandler, args);
			}
			else{
				this._toggleApplyButton(true);
				this._collectDateTime("start");
				var par = {
					ewiItemId: this.ewi.itemId,
					testScriptItemid: this.script.itemId,
					owner: getAuthenticatedContributor().userId,
					ewiStateId:this.ewi.stateId,
					startTime:this._startTime
				}
				var self = this;
				var callbackObj ={
					success: function(result){
						self._resultId = result.itemId;
						self._resultIdInt = result.id;
						self._resultStateId = result.stateId;
						
						//Get the updated StateId of the EWI:(
						var innerclb ={
							 receive: function(ewis){
							 	self.ewi = ewis[0];
                                if(returnToKeyword && returnToKeyword == true )
							        self._createKeywordDialog();
						        else
						            self.onApply();
							 },
							 fail: function(){
							 	console.error("failed to fetch EWI")
							 }
						}
						var par = {
							id: self.ewi.id
						}
						var responseHandler = new ServiceResponseHandler(innerclb, "receive", "fail");			
						ExecutionWorkItemClient.getExecutionWorkItemDTOs(responseHandler, par);
						
						var innerCallback = {
							callSuccess: function(obj){
								self.requestStateId = obj.stateId;
								console.debug("received object" +obj.itemId);
							},
							callFailure: function(errorObj){
								console.debug("failure in fetchin object message " +errorObj.message);
								self._saveError(errorObj);
							}
						}
						var responseHandler=new ServiceResponseHandler(innerCallback, "callSuccess", "callFailure");
						if(self.requestId){
							var prop = {
								propertyName: "resultItemId",
								propertyValue: result.itemId,
								propertyType: "string"
							}
							var props = [];
							props.push(prop);
							var requestArgs = {isNew: false, id: self.requestId, properties: props};
							if(self.requestStateId)
								requestArgs.stateId = self.requestStateId;
							requestArgs.state = "com.ibm.rqm.executionframework.common.requeststate.taken";	
							ExecutionClient.postCreateRequest(responseHandler, requestArgs);
						}

						dojo.publish(GlobalEvents.ArtifactsAdded, [Constants.TYPE_EXE_LOG, [result]]); 
						self.parentWidget._resultId = self._resultId;//Update resultID in EPB for tabclosure
						dojo.publish(GlobalEvents.UpdateTabUri, [window.location.hash, Utility.startExecution(self.ewiItemId, self.runScriptId, self._resultId, self.requestId, self.ergId)]);
					},
					error: function(e){
						self._saveError(e);
					}				
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "error");			
				ExecutionWorkItemClient.postExecute(responseHandler, par);
			}			
		},

		_onEnterApply: function(e) {
			var charCode = (e.which) ? e.which : e.keyCode;
			if (charCode == 13 && this.applyButtonClickEvent) 	
			 	this.onApply();
		},
		
		_moveStepPointer: function(updateProps, currentStep, nextStep){
			//make image go to next line
			try{
			var current = "";
			var next = "";
			if(!isNaN(currentStep) && !isNaN(nextStep))	{
				current = currentStep;
				next = nextStep;
			}else{
				current = this._currentStepNumber;
				next = this._currentStepNumber + 1;
			}
			// present the next iteration
			if ((this._currentIterNumber + 1) < this._iterations 
				&& (current + 1) == (this._currentIterNumber + 1) * this.script.elements.length) {
				this._currentIterNumber = this._currentIterNumber + 1;
				this._updateIteration();
				// erase last iteration
				dojox.data.dom.removeChildren(this._stepsTableBody);
				for(var i = 0; i < this.script.elements.length; i++)
					this._appendEditableStepRow(null, i + this._currentIterNumber * this.script.elements.length, this.script.elements[i], this._currentIterNumber);
				if ((this._currentIterNumber + 1) == this._iterations) {
					//Add one extra row for pointer to move after execution
					this._appendEditableStepRow(null, this.script.elements.length * this._iterations, null, 1);	
				}
			}
			var imgCurr = dojo.byId(this.IMG_ID + current);
			var imgCellCurr = imgCurr.parentNode;
			dojox.data.dom.removeChildren(imgCellCurr);
			var stepImgCurr = document.createElement("img");
			stepImgCurr.title = "";
			stepImgCurr.alt= "";
			stepImgCurr.src= ImageCache.NOIMAGE;
			stepImgCurr.className = "type-image";
			stepImgCurr.id = this.IMG_ID+ current;
			imgCellCurr.appendChild(stepImgCurr);
			var tr = dojo.byId(this.TR_ID + current);
			if (tr.move_pointer_here) {
				dojo.disconnect(tr.move_pointer_here);
				tr.move_pointer_here = null;
			}
			if (tr.move_pointer_here_by_enter) {
				dojo.disconnect(tr.move_pointer_here_by_enter);
				tr.move_pointer_here_by_enter = null;
			}
			tr.move_pointer_here = dojo.connect(tr, "onclick", this, this._changeStepPointer);	
			tr.move_pointer_here_by_enter = dojo.connect(tr, "onkeypress", this, function(e){
				var charCode = (e.which) ? e.which : e.keyCode;
				if (charCode == 13 && this._changeStepPointer) 	
					this._changeStepPointer(e);
			});	
			if (dojo.isIE) {
				//for accessibility issue: when tab to focus, the row has no dashed border when tab to focus. 
				//changing text color to identify focused row
				tr.add_focus_handle = dojo.connect(tr, "onfocus", tr, function(e){
					this.style.color = "#8A9084";
				});
				tr.add_blur_handle = dojo.connect(tr, "onblur", tr, function(e){
					this.style.color = "#000";
				});
			}
			tr.setAttribute("tabIndex", 0);
			tr.style.cursor = "pointer";
			var img = dojo.byId(this.IMG_ID + next);
			var imgCell = img.parentNode;
			dojox.data.dom.removeChildren(imgCell);
			
			var stepImg = document.createElement("img");
			stepImg.title = "";
			stepImg.alt= "";
			stepImg.src= ImageCache.EXECUTION_ARROW;
			stepImg.className = "type-image";
			stepImg.id = this.IMG_ID+ next;
			imgCell.appendChild(stepImg);

			dijit.scrollIntoView(imgCell.parentNode);
			if(window.pageYOffset && window.pageYOffset> 150)
				window.scrollBy(0,20);
			if(updateProps == true){	
				var properties= this.stepProperties[current]	
				var attachCurr = dojo.byId(this.ATTACH_ID  + current);
				var defectCurr = dojo.byId(this.DEFECT_ID  + current);
				var commentCurr = dojo.byId(this.COMMENT_ID  + current);
				var compareCurr = dojo.byId(this.COMPARE_ID  + current);
				propshtml = this._createPropertiesHtml(current,properties);
				if(attachCurr)
					attachCurr.parentNode.replaceChild(propshtml[0],attachCurr);
				if(defectCurr)
					defectCurr.parentNode.replaceChild(propshtml[1],defectCurr);
				if(commentCurr)
					commentCurr.parentNode.replaceChild(propshtml[2],commentCurr);					
			}
			}catch(e){
				console.debug("Error in Move step Pointer");
			}
		},
		
		_updateIteration: function() {
			dojox.data.dom.removeChildren(this._iterationNode);
			this._iterationNode.innerHTML = Constants.getMessage("msgRunningDatapoolIteartion", this._currentIterNumber + 1);
		},
		
		_updateProgressBar: function(){
			if (!this.updatingProgress) {
				this.updatingProgress = true;
				var percent = (parseFloat(parseFloat(this._currentStepNumber) / parseFloat(this.script.elements.length * this._iterations)) * 100);
				this.parentWidget.updateProgress(percent);
				var self = this;
				if (this.requestId) {
					var innerCallback = {
						callSuccess: function(obj){
							self.updatingProgress = false;
							self.requestStateId = obj.stateId
							dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_REQUEST, [obj]]);
						},
						callFailure: function(errorObj){
							self.updatingProgress = false;
							self._saveError(errorObj);
						}
					}
					if(percent != 100){
						var responseHandler = new ServiceResponseHandler(innerCallback, "callSuccess", "callFailure");
						ExecutionClient.postResponse(responseHandler, {
							requestId: this.requestId,
							stateId: this.requestStateId,
							message: "",
							progress: parseInt(percent),
							statusCode: "200",
							projectAreaItemId: getCurrentProjectArea().itemId,
							data: "dummy"
						});
					}else{
						this.updatingProgress = false;
					}	
				} else
					this.updatingProgress = false;
			}
		},
		
		isEndOfExecution: function(resultElement){
			if(resultElement)
				this._resultStateId = resultElement.resultStateId;
			this.stepEERArray[this._currentStepNumber] = resultElement;
            this.stepProperties[this._currentStepNumber] = resultElement.properties;
			var result = this._getStepResult(this._currentStepNumber);
			this._updateResult(result, this._currentStepNumber);
			this._moveStepPointer(false);
			this._currentStepNumber = this._currentStepNumber+1;
			if(!this.oneStepExecution || this._currentStepNumber != this.script.elements.length * this._iterations)
				this._updateProgressBar();

			this._toggleApplyButton(false);
			this._disableResultSelectBox(false);
			//Updating Properties
			this.setProperties(this.stepProperties[this._currentStepNumber]);
			if(this._currentStepNumber == this.script.elements.length * this._iterations)	    	
                this._setCurrentResult(resultElement,true);
			else if(!this._paused && this._stepTypes[this._currentStepNumber] == "Keyword" ){
                var keywordId = this._getKeywordId(this._currentStepNumber,false);
                if(keywordId && this.kwScripts[keywordId].script.scriptType.id != "com.ibm.rqm.planning.common.scripttype.manual")
				    this._createKeywordDialog();
                else if(!this._paused && this.oneStepExecution)
				    this.onApply();
			}
			else if(!this._paused && this.oneStepExecution)
				this.onApply();
		},
        
		_applyVerdictForAllStepsRemaining: function(){
			this.oneStepExecution = true;
			this.onApply();
		},
		
		_onEnterApplyAll: function(e) {
			var charCode = (e.which) ? e.which : e.keyCode
			if (charCode == 13 && this.applyAllButtonClickEvent) 
			 	this._applyVerdictForAllStepsRemaining();
		},
        ////////////////////////////////
		// Keyword related stuff
		////////////////////////////////
		_createKeywordDialog: function(){
			if(this._resultId == null){
				console.error("cant proceed without result id");
				return;
			}
			this._toggleApplyButton(true);
			if (this.stepEERArray[this._currentStepNumber]) {
                if(this.stepEERArray[this._currentStepNumber].result.id == StepResultStates.INCONCLUSIVE )
				    this._executeKeyword();
				return;
			}
			var verdictName = Constants.getMessage("labelInconclusive");
			var verdictId = null;
			for(var count =0;count<this._resultTypes.length;count++){
				if(verdictName === this._resultTypes[count].name){
					verdictId = this._resultTypes[count].id;
					break;
				}	
			}
			var args = {	
					ewiItemId: this.ewi.itemId,
					stepIndex: this._currentStepNumber,
					executionResult: this._resultId,
					resultElementStateTypeId: verdictId,
					resultStateId:this._resultStateId
				}
				if(this._currentStepNumber == 1){
					args.startTime = parseInt(this._startTime);
					args.endTime = parseInt(this._startTime);	
				}
				var responseHandler=new ServiceResponseHandler(this, "_executeKeyword", "_saveError");
	    		ResultClient.postApplyResult(responseHandler, args);
		},
		
		_executeKeyword:function(eer){
			var eerInternalId = "";
			if(eer){
				this.stepEERArray[this._currentStepNumber] = eer;
				this._resultStateId = eer.resultStateId;
			}
			else 
				eerInternalId = this.stepEERArray[this._currentStepNumber].internalId;
			var requestIdValue = null;
            var keywordId = null;
			var keywordProps = this.propertiesMap[KEYWORD_TYPE].elements;
			for(var j=0;j<keywordProps.length;j++){
				if (keywordProps[j].propertyName == "requestId")
					requestIdValue = keywordProps[j].propertyValue;
                if (keywordProps[j].propertyName == "keywordId")
				    keywordId = keywordProps[j].propertyValue;
			}
            if (keywordId) {
                var widgetArgs = {
                    parentWidget: this,
                    ewiItemId: this.ewiItemId,
                    parentEditor: this.parentSection.parentEditor,
                    stepResultItemId: eer ? eer.internalId : eerInternalId,
                    resultId: this._resultIdInt + ""
                }
                if (requestIdValue != null) 
                    widgetArgs.requestId = requestIdValue;
                this._keywordExecutionViewer = new com.ibm.rqm.execution.web.ui.internal.view.execution.KeywordExecution(widgetArgs);
                this._keywordExecutionViewer.initialize(this.kwScripts[keywordId].script);
            }
            else
                this._toggleApplyButton(false);
		},
		
		updateCurrentKeywordResult: function(resultStateId){
			this._resultStateId = resultStateId;
            var eer = this.stepEERArray[this._currentStepNumber];
            var args = {
				ewiItemId: this.ewi.itemId,
				stepItemId: eer.internalId,
				executionResult: this._resultId,
				resultStateId:this._resultStateId			 
			};			
			var responseHandler=new ServiceResponseHandler(this, "finishKeywordExecution", "_saveError");
		    ResultClient.postApplyResult(responseHandler, args);
		},
        
		finishKeywordExecution:function(eer){
			this._resultStateId = eer.resultStateId;
            this.stepEERArray[this._currentStepNumber] = eer;
            if(eer.properties){
				for(var i=0;i<eer.properties.length ;i++)
					this.propertiesMap[eer.properties[i].propertyType].elements.push(eer.properties[i]);
			}
            this._updateCurrentStepProps();
            this._updateResultCombo(eer.result.id);
			var keywordProps = this.propertiesMap[KEYWORD_TYPE].elements;
			var newKeywordProps = [];
			//remove the requestId property
			for(var j=0;j<keywordProps.length;j++){
				if(keywordProps[j].propertyName != "requestId")
					newKeywordProps.push(keywordProps[j]);
			}
			this.propertiesMap[KEYWORD_TYPE].elements = newKeywordProps;
			this.onApply();
		},
		_updateKeywordProgress:function(percent){
			var percentMin = (parseFloat(parseFloat(this._currentStepNumber)/parseFloat(this.script.elements.length * this._iterations))*100);
			var percentMax = (parseFloat((parseFloat(this._currentStepNumber+1))/parseFloat(this.script.elements.length * this._iterations))*100);
			var scriptPercent = 0;
			if (percentMax > percentMin) {
				scriptPercent = percentMin + (((percentMax - percentMin) * (parseFloat(percent))) / 100);
			}
			this.parentWidget.updateProgress(scriptPercent);
			
		},
		
		_updateKeywordRequestId:function(requestId){
			this.propertiesMap[KEYWORD_TYPE].elements.push({ 
				propertyType:KEYWORD_TYPE,
				propertyName:"requestId",
				propertyValue:requestId
			});
			this._onStaleStepUpdate(this._currentStepNumber);
				
		},
		
        _getKeywordId: function(stepNum,getExternalId){
            var keywordId = null;
            var keywordExternalId = null;
            for(var j=0;j<this.stepProperties[stepNum].length;j++){
				if(this.stepProperties[stepNum][j].propertyType == KEYWORD_TYPE){
					if(this.stepProperties[stepNum][j].propertyName == "keywordId")
					    keywordId = this.stepProperties[stepNum][j].propertyValue;
					else if(this.stepProperties[stepNum][j].propertyName == "keywordExternalId")
						keywordExternalId = this.stepProperties[stepNum][j].propertyValue;
					break;
				}	
			}
            if(getExternalId)
                return keywordExternalId;
            else
                return keywordId;
        },
        
        _waitTimer: function(keywordId){
			var self = this;
			var _timer = setInterval(function(){
				if(self.kwScripts[keywordId]!=null){
					clearInterval(self.__timer);
					delete self.__timer;
					if (keywordId && self.kwScripts[keywordId].script.scriptType.id != "com.ibm.rqm.planning.common.scripttype.manual") {
						if (self._resultId != null) 
						    self._createKeywordDialog();
						else 
							self.onApply(true);
					}else{
						self._disableResultSelectBox(false);
					}
				}
			}, 500);
			this.__timer = _timer;
		
		},
		
        ////////////////////////////////
		// Misc Functions
		////////////////////////////////
        _collectDateTime: function(arg){
			var currentTime = new Date();
			if(arg == "start")
				this._startTime = Utility._convertDateToLong(currentTime);
			else
				this._endTime = Utility._convertDateToLong(currentTime);	
		},
		_updateResultCombo: function(resultId){
			var combo = this._resultSelectBox;
			
			for(var i=0;i< combo.options.length; i++){
				if(combo.options[i].value == resultId){
					this._resultSelectBox.selectedIndex = i;
					break;
				}	
			}
		},
        _showDefect:function(stepNum, propertyType){
			defectProps = [];
			var props = this.stepProperties[stepNum];
			if(props){
				for(var i=0;i<props.length ;i++)
					if(props[i].propertyType == propertyType)
						defectProps.push(props[i]);
			}
			this._defectIconClicked(null,"show",defectProps);
		},
		
		_showDefectByPress: function(e, stepNum, image) {
			var charCode = (e.which) ? e.which : e.keyCode;
			if (charCode == 13 && this._showDefect) {
				image.blur();
				this._showDefect(stepNum);
			}
		},
		
		_showAttachByPress: function(event, attachUrl) {
			var charCode = (event.keyCode) ? event.keyCode : event.which;
			if(charCode == 13)
				window.open(attachUrl, "_blank");
		},
		
        _createContextMenu: function(node){
			var callback = this;
			var pMenu = new dijit.Menu({_contextMenuWithMouse:true, targetNodeIds:[node.id]});
            pMenu.addChild(new dijit.MenuItem({label:Constants.getMessage("labelAddNewDefect"),onClick:dojo.hitch(this,this._defectIconClicked,null,"new")}));
            pMenu.addChild(new dijit.MenuItem({label:Constants.getMessage("labelAddExistingDefect"), onClick:dojo.hitch(this,this._defectIconClicked,null,"existing")}));
			pMenu.addChild(new dijit.MenuItem({label:Constants.getMessage("labelShowDefects"),onClick:dojo.hitch(this,this._defectIconClicked,null,"list")}));			
            pMenu.startup();

			//Enable the same menu for left click also			
			this.Menu = pMenu;
			return dojo.connect(node, "onclick", this, function(e){this.Menu._openMyself(e);});
		},
        
		_setCurrentResult: function(result,updateProgress){
			this.parentSection._resultItemId = this._resultId;
			this._resultStateId = result.resultStateId;			
			this.isExecutionOver = true;
			if(this.execOverField)
				this.execOverField.innerHTML = Constants.getMessage("msgExeOver");
			this._setPointerOnFinalStep(this._currentStepNumber);
			if(updateProgress && (this._currentStepNumber == this.script.elements.length * this._iterations)){
				var self = this;
				if(self.ergId){
					var innerCallback2 = {
						callSuccess: function(obj){
							self.ergStateId = obj.stateId;
							console.debug("received object" +obj.itemId);
						},
						callFailure: function(errorObj){
							console.debug("failure in fetchin object message " +errorObj.message);
							self._saveError(errorObj);
						}
					}
					var responseHandler2=new ServiceResponseHandler(innerCallback2, "callSuccess", "callFailure");
					var ergArgs = {id: self.ergId, addResults: [self._resultIdInt]};
					if(self.ergStateId)
						ergArgs.stateId = self.ergStateId;							
					ERGClient.postExecutionResultGroupDTO(responseHandler2, ergArgs)
				}
				if(self.requestId){
					var innerCallback = {
						callSuccess: function(obj){
							self.requestStateId = obj.stateId;
							dojo.publish(GlobalEvents.ArtifactsUpdated, [Constants.TYPE_REQUEST, [obj]]);
						},
						callFailure: function(errorObj){
							console.debug("failure in fetchin object message " +errorObj.message);
						}
					}
					var responseHandler=new ServiceResponseHandler(innerCallback, "callSuccess", "callFailure");

					var requestArgs = {isNew: false, id: self.requestId, progress: 100};
					if(self.requestStateId)
						requestArgs.stateId = self.requestStateId;
					requestArgs.state = "com.ibm.rqm.executionframework.common.requeststate.complete";	
					ExecutionClient.postCreateRequest(responseHandler, requestArgs);
				}

			}
			if (updateProgress) {
				var self = this;
				if (this.updatingProgress) {
					this.progressUpdateInterval = setInterval(function(){
						if (!self.updatingProgress) {
							clearInterval(self.progressUpdateInterval);
							delete self.progressUpdateInterval;
							self._updateProgressBar();
							self.parentWidget.enableNavigationToResultPage();
						}
					}, 500);
				}
				else {
					this._updateProgressBar();
					this.parentWidget.enableNavigationToResultPage();
				}
			}else {
				this.parentWidget.enableNavigationToResultPage();
			}
		},
		
		_updateResult: function(result, stepIndex){
			var resultValue = dojo.byId(this.RESULT_ID + stepIndex);
			var resultCell = resultValue.parentNode;
			dojox.data.dom.removeChildren(resultCell);
			var img = document.createElement('img');
			img.src = Utility.getImageForResult(result);
			img.title = result.name;
			img.alt = result.name;
			img.id = this.RESULT_ID + stepIndex;
			resultCell.appendChild(img);
			if(this._stepsHaveVerdict || (this._stepTypes[stepIndex]!= "Execution Step" && !this.keywordsWithoutVerdicts[stepIndex]))
				resultCell.appendChild(document.createTextNode(result.name));
            this._results[stepIndex] = result.id;
		},
        
        _disableResultSelectBox: function(disable){
			if(disable)
                this._resultSelectBox.disabled = true;
            else if(!this._stepsHaveVerdict && (this._stepTypes[this._currentStepNumber] == "Execution Step" || 
							this.keywordsWithoutVerdicts[this._currentStepNumber]==true))
					this._resultSelectBox.disabled = true;
				else 
					this._resultSelectBox.disabled = false;
			
		},
		
		_buildDefectIdList: function(properties){
            var defectIdList = [];
            if (properties) {
                for (var i = 0; i < properties.length; i++) {
                    if (properties[i].propertyType == DEFECT_VIEW_TYPE && properties[i].propertyValue != null) 
                        defectIdList.push(properties[i].propertyValue);
                }
            }
            return defectIdList;
		},
        
		_buildAttachmentIdList: function(properties){
            var attachmentIdList = [];
            if (properties) {
                for (var i = 0; i < properties.length; i++) {
                    var type = properties[i].propertyType
                    if (type == ATTACHMENT_VIEW_TYPE || type == RESULT_ATTACTMENT_VIEW_TYPE) {
                        var value = properties[i].propertyValue.split(":");
                        if (value.length > 3) 
                            attachmentIdList.push(value[3]);
                    }
                }
            }
            return attachmentIdList;
		},
        
		_toggleApplyButton: function(disable){
			this._applyAllButton.disabled = disable;
			this._applyButton.disabled = disable;
			if(!disable){
				this._applyButton.src = ImageCache.APPLY;
				this._applyButton.setAttribute("tabIndex", 0);
				this._applyAllButton.src = ImageCache.APPLY_ALL;
                if(this.applyButtonClickEvent)
                    dojo.disconnect(this.applyButtonClickEvent);
				if(this.applyButtonEnterEvent)
                    dojo.disconnect(this.applyButtonEnterEvent);
                if(this.applyAllButtonClickEvent)
                    dojo.disconnect(this.applyAllButtonClickEvent);
				if(this.applyAllButtonEnterEvent)
                    dojo.disconnect(this.applyAllButtonEnterEvent);
				this.applyButtonClickEvent = dojo.connect(this._applyButton, "onclick", this, this.onApply);
				this.applyButtonEnterEvent = dojo.connect(this._applyButton, "onkeypress", this, this._onEnterApply);
				this.applyAllButtonClickEvent = dojo.connect(this._applyAllButton, "onclick", this, this._applyVerdictForAllStepsRemaining);
				this.applyAllButtonEnterEvent = dojo.connect(this._applyAllButton, "onkeypress", this, this._onEnterApplyAll);
			}else{
				this._applyButton.src = ImageCache.APPLY_DISABLED;
				this._applyButton.setAttribute("tabIndex", -1);
				this._applyAllButton.src = ImageCache.APPLY_ALL_DISABLED;
				dojo.disconnect(this.applyButtonClickEvent);
				dojo.disconnect(this.applyButtonEnterEvent);
				dojo.disconnect(this.applyAllButtonClickEvent);
				dojo.disconnect(this.applyAllButtonEnterEvent);
                this.applyButtonClickEvent = null;
				this.applyButtonEnterEvent = null;
                this.applyAllButtonClickEvent = null;
				this.applyAllButtonEnterEvent = null;
			}
		},
        
        _getStepResult: function(stepNum){
            var result = null;
            if(!stepNum)
                stepNum = this._currentStepNumber;
			var selectedResult = this._resultSelectBox.value;
			if(!this._stepsHaveVerdict && (this._stepTypes[stepNum ] == "Execution Step" || this.keywordsWithoutVerdicts[stepNum] == true))
				selectedResult = "com.ibm.rqm.execution.common.state.complete";
			for (var i = 0; i < this._resultTypes.length; i++) {
				if(this._resultTypes[i].id == selectedResult){
					result = this._resultTypes[i];
                    break;
				}
			}
			return result;
		},

        _enableImages: function(){
			this._attachment.src = ImageCache.ATTACHMENT_VIEW;
			this._attachment.setAttribute("tabIndex", 0);
			this._comment.src = ImageCache.COMMENT_VIEW;
			this._comment.setAttribute("tabIndex", 0);
			this._defect.src = ImageCache.DEFECT_VIEW;
			this._defect.setAttribute("tabIndex", 0);
			this._dropdown.src = ImageCache.DROPDOWN_ARROW;
			this._dropdown.setAttribute("tabIndex", 0);
			this._pause.src = ImageCache.PAUSE_ICON;
			this._stepsTable.className = "item-table";
			this._disableResultSelectBox(false);
            this._connectMouseListeners();
		},
		
		_disableImages: function(){
			this._attachment.src = ImageCache.ATTACHMENT_VIEW_DISABLED;
			this._attachment.setAttribute("tabIndex", -1);
			this._comment.src = ImageCache.COMMENT_VIEW_DISABLED;
			this._comment.setAttribute("tabIndex", -1);
			this._defect.src = ImageCache.DEFECT_VIEW_DISABLED;
			this._defect.setAttribute("tabIndex", -1);
			this._dropdown.setAttribute("tabIndex", -1);
			this._pause.src = "";
			this._resume.src = ImageCache.RESUME_ICON;
			this._resume.setAttribute("tabIndex", 0);
			this._disableResultSelectBox(true);
			this._stepsTable.className = "item-table-disabled";
			if(!this.resumeEvent)
			    this.resumeEvent = dojo.connect(this._resume, "onclick", this, this._handleResumeClick);
			if(!this.resumeEnterEvent)
			    this.resumeEnterEvent = dojo.connect(this._resume, "onkeypress", this, function(e){
					var charCode = (e.which) ? e.which : e.keyCode;
					if (charCode == 13 && this.resumeEvent) 	
						this._handleResumeClick(e);
				});		
			//Disconnect events from icons except for Resume
			dojo.disconnect(this.addDefectEvent);
            this.addDefectEvent = null;
			dojo.disconnect(this.pauseEvent);
            this.pauseEvent = null;
			dojo.disconnect(this.attachmentImg);
            this.attachmentImg = null;
			dojo.disconnect(this.attachmentEnterEvent);
            this.attachmentEnterEvent = null;
			dojo.disconnect(this.commentImg);
            this.commentImg = null;
			dojo.disconnect(this.commentEnterEvent);
            this.commentEnterEvent = null;
			dojo.disconnect(this.dropdownEvent);
            this.dropdownEvent = null;
			dojo.disconnect(this.dropdownEnterEvent);
            this.dropdownEnterEvent = null;
		},
		
		_connectMouseListeners: function(){
            //Connect events to icons
            if(!this.addDefectEvent)
			    this.addDefectEvent = dojo.connect(this._defect, "onclick", this, this._defectIconClicked);
			if(!this.addDefectEnterEvent)
			    this.addDefectEnterEvent = dojo.connect(this._defect, "onkeypress", this, function(e){
					var charCode = (e.which) ? e.which : e.keyCode;
					if (charCode == 13 && this.addDefectEvent) 	
						this._defectIconClicked();
				});	
            if(!this.attachmentImg)
			    this.attachmentImg = dojo.connect(this._attachment, "onclick", this, this._attachmentIconClicked);
			if(!this.attachmentEnterEvent)
			    this.attachmentEnterEvent = dojo.connect(this._attachment, "onkeypress", this, function(e){
					var charCode = (e.which) ? e.which : e.keyCode;
					if (charCode == 13 && this.attachmentImg) 	
						this._attachmentIconClicked();
				});		
            if(!this.commentImg)
			    this.commentImg = dojo.connect(this._comment, "onclick", this, this._commentIconClicked);
			if(!this.commentEnterEvent)
			    this.commentEnterEvent = dojo.connect(this._comment, "onkeypress", this, function(e){
					var charCode = (e.which) ? e.which : e.keyCode;
					if (charCode == 13 && this.commentImg) 	
						this._commentIconClicked();
				});	
            if(!this.pauseEvent)
			    this.pauseEvent = dojo.connect(this._pause, "onclick", this, this._handlePauseClick);
			if(!this.pauseEnterEvent)
			    this.pauseEnterEvent = dojo.connect(this._pause, "onkeypress", this, function(e){
					var charCode = (e.which) ? e.which : e.keyCode;
					if (charCode == 13 && this.pauseEvent) 	
						this._handlePauseClick();
				});		
			if(this.dropdownEvent)
				this.dropdownEvent = dojo.connect(this._dropdown, "onclick", this, function(e){this.Menu._openMyself(e);});
			else
				this.dropdownEvent = this._createContextMenu(this._dropdown);
			this.dropdownEnterEvent = dojo.connect(this._dropdown, "onkeypress", this, 
				function(e){
					var charCode = (e.which) ? e.which : e.keyCode;
					if (charCode == 13 && this.dropdownEvent) 	
						this.Menu._openMyself(e);
				});
			dojo.disconnect(this.resumeEvent);
            this.resumeEvent = null;    
			dojo.disconnect(this.resumeEnterEvent);
            this.resumeEnterEvent = null;            
		},
		
        ////////////////////////////////
		// Icon clicks handling
		////////////////////////////////
		onEndOfExecution:function(){
			if(this._staleStepUpdated)
				this._onStaleStepUpdate(this._currentStepNumber);
		},
		onCancel: function(){
			if(this._currentStepNumber != 0){
				this._handlePauseClick();
				this._displayAlertDialog(Constants.getMessage("masCancelPausedScript"));
			}	
			else
				this._displayAlertDialog(Constants.getMessage("masCancelNewScript"));
            if(this._keywordExecutionViewer)
                this._keywordExecutionViewer.parentWidget = null;
			history.back();		
		},
        
		_handlePauseClick: function(e){
			if(e)
				e.preventDefault();
			this._pause.style.display = 'none';
			this._resume.style.display = 'inline';
			this._resume.setAttribute("tabIndex", 0);
			this._toggleApplyButton(true);
            if(this._keywordExecutionViewer)
                this._keywordExecutionViewer.parentWidget = null;
			this._disableImages();
			this._paused = true;
			this._resume.focus();
		},
		
		_handleResumeClick: function(e){
			e.preventDefault();
			this._pause.style.display = 'inline';
			this._resume.style.display = 'none';
			this._toggleApplyButton(false);
            if(this._keywordExecutionViewer)
                this._keywordExecutionViewer.parentWidget = this;	
			this._enableImages();
			if(this._paused)
				this._paused = false;
			this._pause.focus();
		},
	
		_attachmentIconClicked: function(e){             
			if(this._resultAttachmentView)
				this._resultAttachmentView.destroy();
			if(this._attachmentView)
				this._attachmentView.destroy();
			this._attachmentView = new AttachmentView();
			this._resultAttachmentView = new AttachmentView();
			
			this._attachmentView.initialize({hideForm:true});
			var spanAttach = document.createElement("span");
			spanAttach.appendChild(document.createTextNode(Constants.getMessage("labelAttachments")));
			spanAttach.style.fontSize = "11pt";
			spanAttach.style.fontWeight = "bold";
			var spanResultAttach = document.createElement("span")
			spanResultAttach.appendChild(document.createTextNode(Constants.getMessage("labelResultAttach")));
			spanResultAttach.style.fontSize = "11pt";
			spanResultAttach.style.fontWeight = "bold";
			this._attachmentView.setData(this.propertiesMap[ATTACHMENT_VIEW_TYPE].elements);
			this._resultAttachmentView.setData(this.propertiesMap[RESULT_ATTACTMENT_VIEW_TYPE].elements,this.removedAttachments);
			
			var dialogArgs = {
				primaryTitle: this.labelAttachmentsView,
	            isClosable: true,
				okCallback: dojo.hitch(this, function(){
					this.removedAttachments = this._resultAttachmentView.getRemovedAttachments();
					this.propertiesMap[RESULT_ATTACTMENT_VIEW_TYPE].elements = 
							this._convertProperties(this._resultAttachmentView.getData(RESULT_ATTACTMENT_VIEW_TYPE));
					this._updateCurrentStepProps(ATTACHMENT_VIEW_TYPE);
				}),
				cancelCallback: dojo.hitch(this, function(){
					this._attachment.focus();
				})
            };			
			this._attachmentsViewer = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
			this._attachmentsViewer.contentContainer.appendChild(spanAttach);
			this._attachmentsViewer.contentContainer.appendChild(this._attachmentView.domNode);
			this._attachmentsViewer.contentContainer.appendChild(document.createElement("hr"));
			this._attachmentsViewer.contentContainer.appendChild(spanResultAttach);
			this._attachmentsViewer.contentContainer.appendChild(this._resultAttachmentView.domNode);
			this._attachmentsViewer.open();
			//somehow the width doesnt get set correctly unless done after open
			this._attachmentsViewer.setWidth('600px');
		},
		
		_addNewDefectViaProvider: function() {
            var defectDescription = {
                summary: "",
                description: "",
                links: [],
				isExecResultRelated: false
            };
            
            var testCase = this.ewi.testCase;
            
            defectDescription["defectOriginItemId"] = this.ewiItemId;
            
            // create the defect's draft summary, ...
            defectDescription["summary"] = this.ewi.name != this.ewi.testCase.name ? Constants.getMessage("labelFailingTestCaseWithEWI", this.ewi.testCase.name, this.ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this.ewi.testCase.name) ;
            
            // ... it's description ...
            defectDescription["description"] = Constants.getMessage("labelTestScriptFailed", this.script.name);
            
            if (this.parentSection.parentEditor.envWidget.showEnvDetails) {
                var environment = this.parentSection.parentEditor.envWidget.ewiConfig;
                defectDescription["description"] += Constants.getMessage("labelEnvironmentWithColon");
                for (var i = 0; i < environment.envTypes.length; i++) {
                    defectDescription["description"] += environment.envTypes[i] + ": " + environment.envValue[i] + "\n";
                }
            }
            
            defectDescription["description"] += Constants.getMessage("labelToProduce");
            for (var i = 0; i <= this._currentStepNumber; i++) {
                defectDescription["description"] += (i + 1) + ") " + this._steps[i] + "\n";
            }
            
            defectDescription["description"] += Constants.getMessage("labelObserve");
            
            // ... and add a link to the EWI
            defectDescription["links"].push({
                type: "com.ibm.team.workitem.linktype.relatedartifact",
                uri: this._getEwiUri() + "?runScript=" + this.runScriptId, 
                comment: (this.ewi.name && this.ewi.name != this.ewi.testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", this.ewi.testCase.name, this.ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this.ewi.testCase.name)
            });
            var self = this;
            ProgressDialog.doRunWithProgress(Constants.getMessage("labelCreatedefect"), dojo.hitch(this, function(monitor){
                getDefectsManager().createDefect("com.ibm.rqm.execution.linktype.eresultrelatedtodefect", [this.ewiItemId], defectDescription, monitor, dojo.hitch(this, function(status, draftItemUri, draftLinkParams){
                    monitor.done();
                    if (status.isOK()) {
                        WindowUtil.openArtifactInNewWindow(draftItemUri);
						this.propertiesMap[RTC_DEFECT_VIEW_TYPE].elements.push(this._convertPropertiesViaProvider(draftLinkParams));
						this._updateCurrentStepProps(RTC_DEFECT_VIEW_TYPE);
                    }
                    else 
                        if (status.getSeverity() != Status.CANCEL) {
                            status.log();
                            this._displayAlertDialog(Constants.getMessage("labelUnableCreateWorkItem", status.getMessage()));
                        }
                }));
            }));
		},

		_addExistingDefectViaProvider: function() {
			var selectionDialog= WorkItemSelectionDialog.create(getDefectsManager(), "queryExistingDefects");

			this.connect(selectionDialog, "onOk", dojo.hitch(this, function(selection) { 
				var workItem= selection[0];
				
				var addLinkParams= {
					ewiUri: this._getEwiUri() + "?runScript=" + this.runScriptId, 
					linkType: "com.ibm.team.workitem.linktype.relatedartifact",
					workItemId: workItem.id,
					workItemUri: workItem.reference,
					comment: (this.ewi.name && this.ewi.name != this.ewi.testCase.name) ? Constants.getMessage("labelFailingTestCaseWithEWI", this.ewi.testCase.name, this.ewi.name) : Constants.getMessage("labelFailingTestCaseWithoutEWI", this.ewi.testCase.name),
					label: workItem.label
				};

				ProgressDialog.doRunWithProgress(Constants.getMessage("labelAssociateDefect"), dojo.hitch(this, function(monitor) {
					getDefectsManager().associateDefect("com.ibm.rqm.execution.linktype.eresultrelatedtodefect", addLinkParams, monitor, dojo.hitch(this, function(status, response) {
						monitor.done();
						if (status.isOK()){
							addLinkParams.draftUri = addLinkParams.workItemUri;
							addLinkParams.summary = addLinkParams.label;
							this.propertiesMap[RTC_DEFECT_VIEW_TYPE].elements.push(this._convertPropertiesViaProvider(addLinkParams));
							this._updateCurrentStepProps(RTC_DEFECT_VIEW_TYPE);
						} else if (!status.isOK() && status.getSeverity() != Status.CANCEL) {
							status.log();
							this._displayAlertDialog(Constants.getMessage("labelUnableCreateWorkItem", status.getMessage()));
						}
					}));
				}));
			}));
		},
		
		_getEwiUri: function() {
			var result= window.location.protocol + "//" + window.location.hostname + ":" + window.location.port;
			result+= window.location.pathname.match(/(.*)\/web\/console\/[^\/]*$/)[1];
			result+= "/resource/itemOid/com.ibm.rqm.execution.ExecutionWorkItem/" + this.ewiItemId;
			return result;
		},

		_listAssociatedDefectsViaProvider: function() {
			var listDialog= AssociatedWorkItemViewer.create(getDefectsManager(), this.ewiItemId, "com.ibm.rqm.execution.linktype.eresultrelatedtodefect", false);
		},
		
		_defectIconClicked: function(e,contextMenuSelection,properties){
			var defectsManager= getDefectsManager();
			defectsManager.ensureInitialized(new NullProgressMonitor(), dojo.hitch(this, function(status) {
				var defectsProviders = defectsManager.getDefectsProviders();
				var currentProviderInstance = defectsManager.getDefectsProvider(defectsManager.getCurrentDefectsProviderId());
				if (currentProviderInstance != null && currentProviderInstance != undefined && currentProviderInstance.isConfigured()) {
					this._dispatchDefectActionViaProvider(contextMenuSelection,properties);
				} else {
					this._defectIconClicked2(e,contextMenuSelection,properties);
				}
			})); 
		},
		
		_dispatchDefectActionViaProvider: function(contextMenuSelection,properties) {
			if (!contextMenuSelection || contextMenuSelection == "new") {
				this._addNewDefectViaProvider();
			} else if (contextMenuSelection == "existing") { 
				this._addExistingDefectViaProvider();
			} else if (contextMenuSelection == "show") {
				this._showDefectViaProvier(properties)
			} else {
				this._listAssociatedDefectsViaProvider();
			}
		},
		
		_defectIconClicked2: function(e,contextMenuSelection,properties){
			if(!this._defectView)
				this._defectView = new DefectView();
			if(!properties)	
				this._defectView.setData(this.propertiesMap[DEFECT_VIEW_TYPE].elements);
			else
				this._defectView.setData(properties);
			if(!contextMenuSelection)
				contextMenuSelection = "new";
			var dialogArgs = {
				primaryTitle: this.labelDefectsView,
	            isClosable: true,
				showActions:false,
				movable: true,
				style: "z-index: 100;",
				zIndex : 100
            };
			if (contextMenuSelection != "show") {
				dialogArgs.onClose = dojo.hitch(this, function(){
					this._checkAndupdateBlockingDefectList(this._defectView.isBlockingDefect(), this.propertiesMap[DEFECT_VIEW_TYPE].elements, this._convertProperties(this._defectView.getData()))
					this.propertiesMap[DEFECT_VIEW_TYPE].elements = this._convertProperties(this._defectView.getData());
					this._updateCurrentStepProps(DEFECT_VIEW_TYPE);
				});

				var details;
				
				details = (this.script) ? Constants.getMessage("labelTestScript") + ": " + this.script.name + "\n" : "";
				details += (this.ewi.testCase) ? Constants.getMessage("labelTestCase") + ": " + this.ewi.testCase.name + "\n" : "";
				details += (this.ewi.testPlan) ? Constants.getMessage("labelTestPlan") + ": " + this.ewi.testPlan.name + "\n" : "";
				
				this._defectView.setViewType(contextMenuSelection, details);
			}
			else
				this._defectView.setViewType("list");
            this._defectsViewer = new com.ibm.asq.common.web.ui.internal.widgets._CommonDialog(dialogArgs);
			this._defectView.setParentDialog(this._defectsViewer);
			this._defectsViewer.contentContainer.appendChild(this._defectView.domNode);
			var self = this;
			this._defectsViewer._onClose = function(){
				if(dojo.isIE)
					self._defectsViewer.contentContainer.removeChild(self._defectView.domNode);
				this.destroy();//dont destroy recursive;
			}
			this._defectsViewer.open();
			this._defectsViewer.setWidth('800px');
			
			this.Menu.onClose();
		},

		_commentIconClicked: function(e){
			var dialogArgs = {
			primaryTitle: this.labelCommentsView,
            isClosable: true,
			okCallback: dojo.hitch(this, function(){
				this.propertiesMap[COMMENT_VIEW_TYPE].elements =this._convertProperties(this._commentView.getData());
				this._updateCurrentStepProps(COMMENT_VIEW_TYPE);
				}),
			cancelCallback: dojo.hitch(this, function(){
				this._comment.focus();
				})
            };                
            this._commentsViewer = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
            this._commentsViewer.setWidth('600px');
			if(this._commentView)
				this._commentView.destroy();
			this._commentView = new CommentView();
			this._commentView.setData(this.propertiesMap[COMMENT_VIEW_TYPE].elements);
			this._commentsViewer.contentContainer.appendChild(this._commentView.domNode);			
			this._commentsViewer.open();
		},
		
		_checkAndupdateBlockingDefectList: function(isBlocking, oldList, newList){
			if(isBlocking && oldList.length != newList.length){
				var blockingDefectList = newList;
				for(var i=0;i<newList.length;i++){
					for(var j=0;j<oldList.length;j++){
						if(newList[i].propertyValue == oldList[j].propertyValue){
							for(var k=0;k<blockingDefectList.length;k++){
								if(blockingDefectList[k].propertyValue == newList[i].propertyValue){
									blockingDefectList.splice(k,1)
									break;
								}
							}
						}
					}
				}
				var blockingDefectId = blockingDefectList.length > 0 ? blockingDefectList[0].propertyValue : null;
				console.debug("Blocking Defect found - "+blockingDefectId);
				if(blockingDefectId){
					var manuSelf =this;
				    var callbackObj ={
					    success: function(ewi){
					  		manuSelf.ewi = ewi;
					  	},
					  	failure: function(error){
					  		console.error("could not updateEWI with blocking defect "+blockingDefectId +"Error code "+error.message);
					  	}
					}
					var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");			
					ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, {id: this.ewi.id, ewiStateId:this.ewi.stateId,addDefectIds: [blockingDefectId]});
				}
			}
		},
		
        ////////////////////////////////
		// Properties related stuff
		////////////////////////////////
        _showCompareDialog:function(stepNum,properties){
			var stepProperties = properties ? properties:this.stepProperties[stepNum];
			if(!stepProperties){
				if(stepNum.indexOf('_')>0){
					var keywordStepNum = stepNum.split('_')[1];
					var keywordNum = stepNum.split('_')[0];
					keywordNum = parseInt(keywordNum,10);
					var props = this.stepProperties[keywordNum];
					for(var i=0;i<props.length;i++){
						if(props[i].propertyName ==keywordStepNum && props[i].propertyType == KEYWORD_STEP_COMPARE){
							var propName = props[i].propertyValue.split('#')[0];
							var propValue = props[i].propertyValue.split('#')[1];
							stepProperties = [{propertyName:propName,propertyType:COMPARE_VIEW_TYPE,propertyValue:propValue}];
							break;
						}
					}
				}else
					return;
			}
			var compareButton = dojo.byId(this.COMPARE_ICON + stepNum);
			dijit.popup.close(this.compareView);
			this.compareView = new CompareView({
				hideActual: false,
				callback: dojo.hitch(this, "_closePopup"),
				callbackData: stepNum
			});
			dojo.style(this.compareView.domNode,"background","white");
			dojo.style(this.compareView.domNode,"border","1px solid gray");
			dojo.style(this.compareView.domNode,"padding","5px");
			dojo.style(this.compareView.domNode,"width","200px");
			this.compareView.setData(stepProperties);
			var self = this;
			dijit.popup.open({ parent: compareButton,
				popup: this.compareView,
				around: compareButton,
				orient: {'BL':'TL', 'BR':'TR', 'TL':'BL', 'TR':'BR'},
				onClose: function(){
					dojo._destroyElement(self.compareView.domNode);
				}
			});
			this.compareView.setFocus();
		},
		_closePopup:function(stepNum){
			var changedProperty =this._convertProperties(this.compareView.getData());
			if(stepNum.indexOf && stepNum.indexOf('_')>0){
				var keywordStepNum = stepNum.split('_')[1];
				var keywordNum = stepNum.split('_')[0];
				keywordNum = parseInt(keywordNum,10);
				var props = this.stepProperties[keywordNum];
				var propValue = changedProperty[0].propertyName+"#"+changedProperty[0].propertyValue;
				for(var i=0;i<props.length;i++){
					if(props[i].propertyName ==keywordStepNum && props[i].propertyType == KEYWORD_STEP_COMPARE){
						props[i].propertyValue = propValue;
						break;
					}
				}
				if(keywordNum == this._currentStepNumber){
					var kwStepProp = this.propertiesMap[KEYWORD_STEP_COMPARE].elements;
					for(var k=0;k<kwStepProp.length;k++){
						if(kwStepProp[k].propertyName ==keywordStepNum){
							kwStepProp[k].propertyValue = propValue;
							break;
						}
					}
				}
				if(this.originalStepNum != null)
                	this._staleStepUpdated = true;
			}else if(stepNum == this._currentStepNumber){
				this.propertiesMap[COMPARE_VIEW_TYPE].elements = changedProperty;
				this._updateCurrentStepProps();
			}
			else{
				if (this.stepProperties[stepNum]) {
					for (var j = 0; j < this.stepProperties[stepNum].length; j++) {
						if (this.stepProperties[stepNum][j].propertyType == COMPARE_VIEW_TYPE) {
							this.stepProperties[stepNum][j].propertyName = changedProperty[0].propertyName;
							this.stepProperties[stepNum][j].propertyValue = changedProperty[0].propertyValue;
							break;
						}
					}
				}
			}
			dijit.popup.close(this.compareView);
		},
		/*
		 * Called when any dialog is closed from the UI
		 * this.propertiesMap contains the current step only.
		 * After callback success, focus back to property button
		 */
		_updateCurrentStepProps:function(callbackType){
			var properties = [];
			for(var propertyType in this.propertiesMap)
				properties = properties.concat(this.propertiesMap[propertyType].elements);
			this.stepProperties[this._currentStepNumber] = properties;
			var attachCurr = dojo.byId(this.ATTACH_ID  + this._currentStepNumber);
			var defectCurr = dojo.byId(this.DEFECT_ID  + this._currentStepNumber);
			var commentCurr = dojo.byId(this.COMMENT_ID  + this._currentStepNumber);
			var compareCurr = dojo.byId(this.COMPARE_ID  + this._currentStepNumber);
			var propshtml = this._createPropertiesHtml(this._currentStepNumber,properties);
			if(attachCurr)
				attachCurr.parentNode.replaceChild(propshtml[0],attachCurr);
			if(defectCurr)
				defectCurr.parentNode.replaceChild(propshtml[1],defectCurr);
			if(commentCurr)
				commentCurr.parentNode.replaceChild(propshtml[2],commentCurr);
			if(this.originalStepNum != null)
                this._staleStepUpdated = true;
			if(callbackType) {
				switch(callbackType){
					case DEFECT_VIEW_TYPE:
					case RTC_DEFECT_VIEW_TYPE:
						this._defect.focus();
						break;
					case ATTACHMENT_VIEW_TYPE:
					case RESULT_ATTACTMENT_VIEW_TYPE:
						this._attachment.focus();
						break;
					case COMMENT_VIEW_TYPE:
						this._comment.focus();
						break;
					case COMPARE_VIEW_TYPE:
					default:
						//do Nothing
				}
			}
		},

		setProperties: function(properties){
			if(!this.propertiesMap)
				this.propertiesMap = [];
			this.propertiesMap[ATTACHMENT_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[RESULT_ATTACTMENT_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[DEFECT_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[RTC_DEFECT_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[COMMENT_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[COMPARE_VIEW_TYPE] = {elements:[]};
			this.propertiesMap[KEYWORD_TYPE] = {elements:[]};
			this.propertiesMap[KEYWORD_STEP_COMPARE] = {elements:[]};				
			this.removedAttachments = undefined;
			if(properties){
				for (var i = 0; i < properties.length; i++) {
					if(!this.propertiesMap[properties[i].propertyType])
						this.propertiesMap[properties[i].propertyType] = {elements:[]};
					this.propertiesMap[properties[i].propertyType].elements.push(properties[i]);
				}
			}
			if(this.propertiesMap[COMPARE_VIEW_TYPE] && this.propertiesMap[COMPARE_VIEW_TYPE].elements.length >0)
				this._showCompareDialog(this._currentStepNumber,this.propertiesMap[COMPARE_VIEW_TYPE].elements);
		},
		
		_convertProperties:function(properties){
			var elements = [];
			if(properties){
				for(var i=0;i<properties.length;i=i+3 ){
					var property = {
						propertyType: properties[i],
						propertyName: properties[i+1 ],
						propertyValue: properties[i+2 ]
					}
					if(property.propertyValue != null && property.propertyValue.length>0)
						elements.push(property);
				}
			}
			return elements;
		},

		getProperties:function(){
			var stepProps = [];
			for(var propertyType in this.propertiesMap)
				stepProps = stepProps.concat(this.propertiesMap[propertyType].elements);
            return stepProps;
		},
		
		_convertPropertiesViaProvider: function(draftLinkParams) {
			var property = {
				propertyType: RTC_DEFECT_VIEW_TYPE,
				propertyName: draftLinkParams.summary,
				propertyValue: draftLinkParams.draftUri
			}
			return property; 
		},
		
		_showDefectViaProvier: function(properties) {
			var draftUriFilter = [];
			for(var i = 0; i < properties.length; i++){
				draftUriFilter.push(
					properties[i].propertyValue
				);
			}
			var listDialog= AssociatedWorkItemViewer.create(getDefectsManager(), this.ewiItemId, "com.ibm.rqm.execution.linktype.eresultrelatedtodefect", false, draftUriFilter);
		},
		
        ////////////////////////////////
		// Going back to already executed stuff
		////////////////////////////////
		_setPointerOnFinalStep: function(stepNum){
			if(this.isExecutionOver && (parseInt(stepNum,10) == (this.script.elements.length*this._iterations))){
				//disable all buttons properties
				this._toggleApplyButton(true);
				this._disableImages();
				if(dojo.hasClass(this._stepsTable, "item-table-disabled"))
					dojo.removeClass(this._stepsTable, "item-table-disabled")
				this._stepsTable.className = "item-table";	
				this._resume.src = "";
				this._resume.setAttribute("tabIndex", -1);
				this._disableResultSelectBox(true);
				dojo.disconnect(this.resumeEvent);
                this.resumeEvent = null;
				dojo.disconnect(this.resumeEnterEvent);
                this.resumeEnterEvent = null;
			}else {
				//disable and then re-enable buttons (avoid multiple event attaching)
				this._toggleApplyButton(false);
				this._disableImages();
				this._enableImages();
			}
			if(this.isExecutionOver){
				this._resume.src = "";
				this._resume.setAttribute("tabIndex", -1);
				this._pause.src = ImageCache.NOIMAGE;
				this._pause.setAttribute("tabIndex", -1);
				if (this.resumeEvent) {
                    dojo.disconnect(this.resumeEvent);
                    this.resumeEvent = null;
                }
				if (this.resumeEnterEvent) {
                    dojo.disconnect(this.resumeEnterEvent);
                    this.resumeEnterEvent = null;
                }
				if (this.pauseEvent) {
                    dojo.disconnect(this.pauseEvent);
                    this.pauseEvent = null;
                }	
				if (this.pauseEnterEvent) {
                    dojo.disconnect(this.pauseEnterEvent);
                    this.pauseEnterEvent = null;
                }	
			}
			
		},
		
		_changeStepPointer: function(e){
			try{
				if(!e.currentTarget || !e.currentTarget.id)
					return;
				var stepNum = e.currentTarget.id.split(this.TR_ID)[1];				
				
				if(this._currentStepNumber == parseInt(stepNum,10))//Same step clicked twice
					return;
                if(this._staleStepUpdated)
                    this._onStaleStepUpdate(this._currentStepNumber);
				//Since we start with zero we should check for element length
				this._setPointerOnFinalStep(stepNum);
				if(!this.stepEERArray[this._currentStepNumber])
					this.originalStepNum = this._currentStepNumber;
				if(stepNum == this.originalStepNum)	{
					//Enable Apply / Apply All, Pause remove verdict change listener
					this.originalStepNum = null;
					if(!this.isExecutionOver)
						this._toggleApplyButton(false);
					if(this._resultSelectBox.changelistener){
						dojo.disconnect(this._resultSelectBox.changelistener);
						this._resultSelectBox.changelistener = null;
					}	
					this.pauseEvent = dojo.connect(this._pause, "onclick", this, this._handlePauseClick);
					this.pauseEnterEvent = dojo.connect(this._pause, "onkeypress", this, function(e){
						var charCode = (e.which) ? e.which : e.keyCode;
						if (charCode == 13 && this.pauseEvent) 	
							this._handlePauseClick();
					});	
					this._pause.title = Constants.getMessage("labelClickToPauseExe");
				}else {
					//Disable Apply and ApplyAll and Pause buttons
					this._toggleApplyButton(true);
					if(!this._resultSelectBox.changelistener)
						this._resultSelectBox.changelistener = dojo.connect(this._resultSelectBox, "onchange", this, this._onStaleStepVerdictUpdate)
					if(this.pauseEvent){
						dojo.disconnect(this.pauseEvent);
						this.pauseEvent = null;
					}	
					if(this.pauseEnterEvent){
						dojo.disconnect(this.pauseEnterEvent);
						this.pauseEnterEvent = null;
					}	
					this._pause.title = "";
                    this._updateResultCombo(this._results[stepNum]);	
				}
				this.stepProperties[this._currentStepNumber] = this.getProperties();
				if(this.inProgress)
					return;
				this.inProgress = true;
				this._moveStepPointer(true, this._currentStepNumber, parseInt(stepNum, 10))
				this.inProgress = false;
				this._currentStepNumber = parseInt(stepNum, 10);
			    this._disableResultSelectBox(false);
				this.setProperties(this.stepProperties[this._currentStepNumber]);
				
				if(this.isExecutionOver && (parseInt(stepNum,10) == (this.script.elements.length*this._iterations)))
					this._disableResultSelectBox(true);
			
			}catch(e){
				console.debug("----error changing step--- "+ stepNum)
			}
		},
		
		_onStaleStepUpdate: function(stepNum){
            var args = {};
			var properties = this.getProperties();
            if(properties.length > 0)
                args.addProperties = properties;
            var removeAttachmentItemIds = this._buildAttachmentIdList(this.stepEERArray[stepNum].properties);
            if(removeAttachmentItemIds.length>0)
                args.removeAttachmentItemIds = removeAttachmentItemIds;
            var defectIdList = this._buildDefectIdList(properties);
            if(defectIdList.length>0)
                args.defectIds = defectIdList;
            var addAttachmentItemIds = this._buildAttachmentIdList(properties);
            if(addAttachmentItemIds.length > 0)
                args.addAttachmentItemIds = addAttachmentItemIds;
            args.resultElementStateTypeId = this._results[stepNum];
			this._callUpdate(args,stepNum);
		},
		
		_onStaleStepVerdictUpdate: function(){
			var result = this._getStepResult(this._currentStepNumber);
			this._updateResult(result, this._currentStepNumber);
            this._staleStepUpdated = true;
		},
		
		_callUpdate: function(args,stepNum){
			var eerInternalId = this.stepEERArray[stepNum].internalId;
			args.ewiItemId = this.ewi.itemId;
			args.stepItemId =  eerInternalId;
			args.executionResult =  this._resultId;
			args.resultStateId = this._resultStateId;
            if(this.isExecutionOver && args.resultElementStateTypeId){
                this._collectDateTime("stop");
				args.startTime = parseInt(this._startTime);
				args.endTime =  parseInt(this._endTime);
				args.machine =  Constants.getMessage("labelLocalComputer");
				args.owner = getAuthenticatedContributor().userId;
            }
            else
                args.resultState = ResultStates.IN_PROGRESS;
            var self = this;
			var callbackObj ={
				success: function(eer){
					self.stepEERArray[stepNum] = eer;
                    self.stepProperties[stepNum] = eer.properties;
					self._resultStateId = eer.resultStateId;
                    self._staleStepUpdated = false;
				},
				error: function(errorObj){
					console.error("Error updating step details ["+errorObj.message+ "] _onStaleStepUpdate")
					self._saveError(errorObj);
				}
			}
			
			var responseHandler=new ServiceResponseHandler(callbackObj, "success", "error");
		    ResultClient.postApplyResult(responseHandler, args);
		},	
		
		///////////////////////////////////////////////////////////////////////////////
		// replace placeholder by real cell value
		///////////////////////////////////////////////////////////////////////////////
		_replaceVariable: function(desDiv, iteration){
			var children = desDiv.getElementsByTagName("BUTTON");//desDiv.childNodes;
			var newArray = [];
			for(var i=0; i<(children ? children.length : 0); i++) {
				newArray.push(children[i]);
			}
			if(newArray && newArray.length) {
				var newDiv = document.createElement("div");
				for(var i=0; i<newArray.length; i++) {
					var child = newArray[i];
					if (child.name == "variable") {
						var itemId = child.id;
						var preString = this._getButtonHTML(desDiv.innerHTML, itemId);
						var cell = this._getCellFromExist(itemId, iteration);
						if (!cell) {
							cell = "";
						}
						var preContent = desDiv.innerHTML;
						var newString = preContent.replace(preString, cell);
						desDiv.innerHTML = newString;
					}
				}
			}
			return desDiv;
		},
		
		_getButtonHTML: function(whole, itemId) {
			var hasMore = true;
			while(hasMore) {
				var tmpWhole = whole.toLowerCase(); 
				var start = tmpWhole.indexOf("<button ");
				var end = tmpWhole.indexOf("</button>");
				var tmpString = whole.substring(start, end+9);
				var idSite = tmpString.indexOf(itemId);
				if(idSite > 0){
					return tmpString;
				}
				whole = whole.substring(end+9, whole.length);
				hasMore = (whole.indexOf("<button ") > 0)?true: false;
			}
			return "";
		},
		
		_getCellFromExist: function(variableItemId, iteration) {
			if (!this._datapool || !this._datapool.variables || !this._datapool.records) {
				return null;
			}
			for(var i = 0; i < this._datapool.variables.length; i++){
				if (this._datapool.variables[i].itemId == variableItemId || this._datapool.variables[i].id == variableItemId) 
					return "<b>" + this._datapool.records[iteration].cells[i].value + "</b>";			
			}
			return null;
		},
		
		_contains: function(items, itemId){
            if(items && items.length) {
				for(var i = 0; i< items.length; i++) {
					if(items[i].itemId == itemId)
						return true;
				}
			}
			return false;
        },
        ////////////////////////////////
		// Error handling
		////////////////////////////////
		_saveError:function(errorObj){
			this._displayAlertDialog(errorObj.message);
		},
		_error: function(errorObj) {
			if(this.__timer){
				clearInterval(this.__timer);
				delete this.__timer;
			}
			console.error("Error: (message: '" + errorObj.message + "') from Manual Execution#_error");
		},
		
		_displayAlertDialog: function(message){
            var alertDialog = new AlertDialog({
                'message': message
            });
            alertDialog.open();
        }
		
});
})();	
