/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2006. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
console.debug("Loading: com.ibm.rqm.adapter.rpt.web.ui.internal.view.execution.PerformanceExecutionLog");
dojo.provide("com.ibm.rqm.adapter.rpt.web.ui.internal.view.execution.PerformanceExecutionLog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

// Utlities
//xojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.adapter.rpt.web.ui.internal.RptUiUtil");

//Clients
dojo.require("com.ibm.team.process.web.client.projectarea");

//xojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.VPStackedBarChart");

(function() { // module container

var ImageCache				= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var DOWNLOAD_SERVICE_URI 		= "com.ibm.rqm.planning.service.internal.rest.IAttachmentRestService/"; //RQM Downaload Service
var TeamServerClient 			= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentProjectArea		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var RptUiUtil	= com.ibm.rqm.adapter.rpt.web.ui.internal.RptUiUtil;

dojo.declare("com.ibm.rqm.adapter.rpt.web.ui.internal.view.execution.PerformanceExecutionLog",[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.adapter.rpt.web", "ui/internal/view/templates/execution/PerformanceExecutionLog.html"),
		postCreate: function() {		
		},
		
		initialize: function()
		{		
			var logMessage = null;
			var rLocationAvailable = null;
			var rAdapterName = null;
			var rWorkspaceRoot = null;
			var rProjectFolder = null;
			
			if (this.result.properties)
			{
				for (var i = 0; i < this.result.properties.length; i++)
				{
					var mPropertyName  = this.result.properties[i].propertyName;
					var mPropertyValue = this.result.properties[i].propertyValue;
					
					if(mPropertyName == "message")
					{
						logMessage = mPropertyValue;
					}
					if(mPropertyName == "r_location_available")
					{
						rLocationAvailable = mPropertyValue;
					}
					if(mPropertyName == "r_adapter_name")
					{
						rAdapterName = mPropertyValue;
					}
					if(mPropertyName == "r_workspace_path")
					{
						rWorkspaceRoot = mPropertyValue;
					}
					if(mPropertyName == "r_project_folder")
					{
						rProjectFolder = mPropertyValue;
					}
				}
			}
						
			if(logMessage != null && logMessage.length > 0){
				var logMessageHeader = RptUiUtil.getMessage("logMessageHeader");
				this._PerformanceLogMessageHeader.appendChild(document.createTextNode(logMessageHeader));
				// this._PerformanceLogMessageHeader.appendChild(document.createElement("br"));
				this._PerformanceLogMessageText.appendChild(document.createTextNode(logMessage));
			}else{	
				this._PerformanceLogMessageTable.deleteRow(0);
			}
								
			if (this.result.attachments) {
				
				this._PerformanceLogReportText.appendChild(document.createTextNode(RptUiUtil.getMessage("availableReports")));
				this._addAttachments(this.result.attachments);
				
				if (rLocationAvailable == "true") {
					
					this._PerformanceLogReportLocation.appendChild(document.createTextNode(RptUiUtil.getMessage("resultsLocation")));
					
					if(rAdapterName==null){
						rAdapterName = "";
					}
					var liAdapterName = document.createElement("li");
					liAdapterName.appendChild(document.createTextNode(RptUiUtil.getMessage("adapterName", rAdapterName)));
					this._PerformanceLogReportLocationList.appendChild(liAdapterName);
					
					if(rWorkspaceRoot==null){
						rWorkspaceRoot = "";
					}
					var liWorkspaceRoot = document.createElement("li");
					liWorkspaceRoot.appendChild(document.createTextNode(RptUiUtil.getMessage("workspaceRoot", rWorkspaceRoot)));
					this._PerformanceLogReportLocationList.appendChild(liWorkspaceRoot);
					
					if(rProjectFolder==null){
						rProjectFolder = "";	
					}
					var liProjectFolder = document.createElement("li");
					liProjectFolder.appendChild(document.createTextNode(RptUiUtil.getMessage("projectFolder", rProjectFolder)));
					this._PerformanceLogReportLocationList.appendChild(liProjectFolder);
				}
			}else{
				this._PerformanceLogReportText.appendChild(document.createTextNode(RptUiUtil.getMessage("noReports")));
			}
			
			// var vpChart = new com.ibm.rqm.execution.web.ui.internal.view.execution.VPStackedBarChart( {pass: "0", fail: "0", inconclusive: "0"});
			// this._PerformanceLogReport.appendChild(vpChart.domNode);					
		},
	
		_addAttachments: function(mAttachments){
			 for(var i in mAttachments){
			 	if (this._shouldShow(mAttachments[i])) {
					var listItem = document.createElement("li");
					listItem.appendChild(this._getDownloadAnchor(mAttachments[i]));
					this._PerformanceLogReportList.appendChild(listItem);
				}
			 }
		},
		
		_shouldShow: function(attachment){
			
			if(attachment.customField && attachment.customField.length > 0){
				return true;
			}
			
			return false;
			
			/*
			try{
				if(attachment.name.indexOf('.jpeg') > -1){
					return false;				
				}	
				if(attachment.name.indexOf('rpt_export_report_temp') > -1){
					return false;				
				}	
			}catch(e)
			{
				console.debug("PerformanceExecutionLog error filtering attachments: "+e);
				return false;
			}
			return true;	
			*/
		},
			
		_getDownloadAnchor: function(attachment) {
			var saveAnchor= document.createElement("a");
			saveAnchor.className= "actionLink";
			saveAnchor.href = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + attachment.itemId + "?attach=0";		
			saveAnchor.target="_blank";
			saveAnchor.appendChild(document.createTextNode(attachment.name));					
			return saveAnchor;
		},
		
		_error: function(e)
		{
			console.error("An error occurred: [" + e.message + "] @ PerformanceExecutionLog#_error");
		}
	}
);

}
)();