/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

//Clients
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
//Utilities
dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
//Local widgets
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionHistoryTableView");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.RelatedInfo");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection");

(function() 
{
	var ExecutionWorkItemClient     = com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
	var ExecutionResultStates       = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;
	var ImageCache                  = com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
	var ServiceResponseHandler      = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var Utility                     = com.ibm.rqm.execution.web.ui.internal.util.Utility;
	var Constants                   = com.ibm.rqm.planning.web.client.internal.Constants;
	var ExecutionHistoryTableView   = com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionHistoryTableView;
	var ResultStates 				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionElementResultStates;
	var getCurrentProjectArea		= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	var LOCATION                    = "jazz/web/projects/";
	var DEFECT_URL                  = "#action=com.ibm.team.workitem.viewWorkItem&id=";
	var MAX_DEFECTS					= 25;
	
	dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory",[dijit._Widget, dijit._Templated, 
					com.ibm.asq.common.web.ui.internal.view.common.RelatedInfoMixin],
	{
		templateString : '<div class="com-ibm-rqm-test-execution-ewi-list-container">'+
						 '<div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
						 '<div class="" dojoAttachPoint="_EWIDetails">'+
						 '<table width=\"100%\" style=\"padding:1px\"><tbody>'+
						 '<tr width="100%"><td width=\"10%\"><label>${labelTestPlan}</label></td><td><label dojoAttachPoint=\"_testPlan\"></label></td></tr>'+
						 '<tr width="100%"><td width=\"10%\"><label>${labelTestIteration}</label></td><td><label dojoAttachPoint=\"_testIteration\"></label></td></tr>'+
						 '<tr width="100%"><td width=\"10%\"><label>${labelTestCase}</label></td><td><label dojoAttachPoint=\"_testCase\"></label></td></tr>'+
						 '</table></tbody></div>'+
						 '<div class="" dojoAttachPoint="_envSection"></div>'+
						 '<div class="" dojoAttachPoint="_listContainer"></div>'+
						 '</div></div>',
		
		labelTestPlan: Constants.getMessage("labelTestPlan")+Constants.getMessage("labelColen"),
		labelTestIteration:Constants.getMessage("labelIteration")+Constants.getMessage("labelColen"),
		labelTestCase:Constants.getMessage("labelTestCase")+Constants.getMessage("labelColen"),						 
		ewiItemId: null,
		parentController: null,
		_ewi: null,
		widgetsInTemplate: true,
		_elementResults:[],
		
		postCreate: function(){
			//Will receive this.ewiItemId
			dojox.data.dom.removeChildren(this._envSection);
			this._envSection.innerHTML = Constants.LOADING;						
			var responseHandler = new ServiceResponseHandler(this, "_showResultHistoryTable", "_loadError");
			ExecutionWorkItemClient.getExecutionWorkItemByItemId(responseHandler, {itemId: this.ewiItemId});
		},
		_createHeader: function(){
			this.viewHeaderNode.setTitle(Constants.getMessage("labelResultHist"));
			this.viewHeaderNode.setIconClass("ewiresult-icon-48");
			this._testPlan.innerHTML = this._ewi.testPlan? this._ewi.testPlan.name:"";
			this._testIteration.innerHTML = this._ewi.phase? this._ewi.phase.name:"";
			this._testCase.innerHTML = this._ewi.testCase? this._ewi.testCase.name:"";
			dojox.data.dom.removeChildren(this._envSection);
			var args={
				parentController: this.parentController,
				showEnvDetails: true,
				ewi: this._ewi
			}
			var envWidget = new com.ibm.rqm.execution.web.ui.internal.view.execution.EnvironmentContainer(args);
			var params ={
				title: Constants.getMessage("labelTestEnvironment"),
				summary: envWidget.domNode,
				helpContextId: "rqm_execution_environments_help.html"
			};
			var envSection = this._createCollapsibleSection(params);
			this._envSection.appendChild(envSection.domNode);
		},
		refresh:function(){
			if(this.refreshBtn)
				this.refreshBtn.setDisabled(true);
			var responseHandler = new ServiceResponseHandler(this, "_refreshTable", "_loadError");
			ExecutionWorkItemClient.getExecutionWorkItemByItemId(responseHandler, {itemId: this.ewiItemId});
		},
		_refreshTable:function(ewi){
			this._ewi = ewi;
			if(this._relatedInfoPanel){
				this._createRelatedInfo(ewi);
			}
			var history = this._buildHistory(ewi);
			this._resultTableViewer.refresh(history);
			if(this.refreshBtn)
				this.refreshBtn.setDisabled(false);
		},
		_showResultHistoryTable: function(ewi) {	
			this._ewi = ewi;
			if(this._relatedInfoPanel && !this.relatedInfoCreated )
				this._createRelatedInfo(ewi);
			this._createHeader(); 
	        var history = this._buildHistory(ewi);	
	        this._resultTableViewer = new ExecutionHistoryTableView({results: history});
			this.refreshBtn = this._resultTableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), 
					this, "refresh-icon-image", dojo.hitch(this, "refresh"));
			var params ={
				title: Constants.getMessage("labelDetailResultHistory"),
				summary: this._resultTableViewer.domNode
			};
			var listSection = this._createCollapsibleSection(params);
	        this._listContainer.appendChild(listSection.domNode);  						
		},
		_createRelatedInfo: function(ewi){
			this.relatedInfoCreated = true;
			if(this._defectSummaryGroup)
				dojox.data.dom.removeChildren(this._defectSummaryGroup._actionListNode);
			var defectList = [];
			for(var k=0;k<(ewi.results ? ewi.results.length : 0);k++){
				var result = ewi.results[k];
				if(result.defects){
					for (var m = 0; m < result.defects.length; m++) {
						var found = false;
						for(var n=0;n<defectList.length;n++){
							if(defectList[n].itemId == result.defects[m].workItem.itemId){
								found = true;
								break;
							}
						}
						if (!found) {
							var defect = result.defects[m].workItem;
		                    var defectId = "";
		                    var defectStatus = Constants.getMessage("labelUnknown");
		                    var defectSummary = "";
		                    var defectInternalState = null;
							for(var j=0;j<defect.attributes.length;j++){
								switch (defect.attributes[j].key){
									case "id":
										defectId = defect.attributes[j].value.id;
										break;
									case "summary":
										defectSummary = defect.attributes[j].value.content;
										break;
		                            case "internalState":
		                                defectInternalState = defect.attributes[j].value.label;
		                                break;		                                
								}
							}
	                        defectStatus = defectInternalState;
							defectList.push({
								itemId:defect.itemId,
								id:defectId,
								summary:defectSummary,
								status:defectStatus
							});
						}
					}
				}
			}
			//this will eventually grow too big. Limiting to last MAX_DEFECTS
			defectList.sort(function(defect1,defect2){
			 	var id1 = parseInt(defect1.id, 10);
				var id2 = parseInt(defect2.id, 10);
				return id2-id1;  //if id2 is greater than id1 return positive 
			 });
			if(defectList.length>0){
				var length = defectList.length;
				if(length > MAX_DEFECTS)
					length = MAX_DEFECTS;
				for(var i=0;i<length;i++){
					var defectText = "";
					if(defectList[i].summary.length>10)
						defectText = defectList[i].id+":"+defectList[i].summary.substr(0, 9) +"... -- "+defectList[i].status;
					else
						defectText = defectList[i].id+":"+defectList[i].summary+" -- "+defectList[i].status;
					var defectUrl = DEFECT_URL+defectList[i].id;
					this._relatedInfoPanel.addLink(Constants.getMessage("labelDefectSummary"),defectText,defectUrl);
				}
			}
		},
		_buildHistory: function(ewi) {
			var history = [];
			 //sort the ewi list first .. WI 3236
			if(ewi.results){
				ewi.results.sort(function(result1,result2){
				 	var time1 = result1.endTime?result1.endTime:result1.startTime;
					var time2 = result2.endTime?result2.endTime:result2.startTime;
					return time2-time1;  //if time2 is greater than time1 return positive 
				 });
			 }
	         for (var i = 0; i < (ewi.results ? ewi.results.length : 0); i++) {   //ExecutionResultDTO
	            var start = ewi.results[i].startTime;
	            var end = ewi.results[i].endTime;
	            var result = {
	               date: Utility._convertLongToDate(start, true),
	               time: Utility.getTimeString(start),
				   longTime: end ? end : start,               
	               duration: end ? Utility.getTimeDifferenceInHrMinSec(end - start) : Constants.getMessage("labelNA"),
				   state:ewi.results[i].state.name,
	               script: ewi.results[i].script? ewi.results[i].script : ""
	            };				
	            //handle linkage TODO add logic to determine if incomplete
	            result.icon = ImageCache.EWI_LOG;
	            result.link = Utility.getResultURI({
	                  ewiId: ewi.id,
	                  resultItemId: ewi.results[i].itemId
	            });
				if(ewi.results[i].script){
					if(ewi.results[i].script.scriptType.name == "Manual" && ewi.results[i].state.id === ExecutionResultStates.IN_PROGRESS){
						//Incomplete Execution, use the resume icon and link
						result.icon = ImageCache.EWI;
			            result.link = Utility.startExecution(ewi.itemId, ewi.results[i].script.id, ewi.results[i].itemId);
					}
				}
				      
	            history.push(result);                  
			}
			return history;			
		},		
		_showTable: function(){
			this._listContainer.appendChild(this._list.domNode);
			this._list.displayTable();
		},

		//override RelatedInfoMixin methods
		getStaticRelatedInfo: function() {
	        return this._relatedInfoPanel;
	    },
	    getStaticRelatedInfoId: function() {
			//need a unique one for each EWI
	        return "com.ibm.rqm.execution.web.ui.internal.view.execution.ResultHistory"+this.ewiItemId;
	    },
		setupRelatedInfo: function(relatedInfoPanel){
			this._relatedInfoPanel = relatedInfoPanel;
			this._defectSummaryGroup = this._relatedInfoPanel.getInfoGroup(Constants.getMessage("labelDefectSummary"),true);
			if(this._ewi && !this.relatedInfoCreated)
				this._createRelatedInfo(this._ewi);
         },
		 _createCollapsibleSection: function(args){
			var expando = new com.ibm.asq.common.web.ui.internal.view.common.CollapsibleSection({open: true, collapsible: false});
	        expando.domNode.name = "first-section";
	        expando.setTitle(args.title ? args.title : "");
	        expando.infoNode.innerHTML = args.info ? args.info: "" ;
			if(args.summary)
				expando.summaryNode.appendChild(args.summary);
			else
				expando.summaryNode.innerHTML = "";
	        if(args.headerRight)
				expando.headerRightNode.appendChild(args.headerRight);
			else
				expando.headerRightNode.innerHTML = "";
			expando.containerHeaderNode.innerHTML = "";
        	var content = document.createElement('div');
			content.innerHTML = "";
        	expando.containerNode.appendChild(content);
			expando.setCSHelpId(args.helpContextId);
			expando.setCSHelpButtonLabel(Constants.getMessage("labelCSHelp"), args.title ? args.title : "");
			expando.headerCollapsNode.style.display = "none";
		   	return expando;
		},

        _loadError: function(e) {
            com.ibm.asq.common.web.ui.internal.util.Utility.handleArtifactLoadError(Constants.getMessage("labelResultHist"), e.message);
        },

		_error: function(e){
			console.error("An error occurred: [" + e.message + "] @ ResultHistory#_error");
		}
	}	
	);
}
)();
