/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.appscan.web.ui.internal.view.extension.ASEExecutionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.adapter.appscan.web.ui.internal.view.execution.ASEExecution");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.appscan.web.client.internal.ScanClient");
dojo.require("com.ibm.rqm.appscan.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() { // module container

var ViewHeaderLayout    	= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var ExecutionViewer    		= com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionViewer;
var ScanClient				= com.ibm.rqm.appscan.web.client.internal.ScanClient;
var Constants 				= com.ibm.rqm.appscan.web.client.internal.Constants;

dojo.declare(
   "com.ibm.rqm.adapter.appscan.web.ui.internal.view.extension.ASEExecutionSection", 
   [dijit._Widget, dijit._Templated, ExecutionViewer], 
   {
   templateString: "<div dojoAttachPoint=\"_functionalExecutionSection\" class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-ASEExecutionSection\"></div>",
   
   constructor: function(args) {    
   },
   
   postCreate: function() {
   },

   initialize: function(){   
 		var scriptInfo = {
			itemId: this.script.itemId,
			id: this.script.id,
			type: this.script.scriptType.id,
			_resultId: this._resultId,
			parentWidget:this.parentEditor,
			properties: this.script.properties
		};
		this.scriptInfo = scriptInfo;
		dojox.data.dom.removeChildren(this._functionalExecutionSection);
		this._funcWidget = new com.ibm.rqm.adapter.appscan.web.ui.internal.view.execution.ASEExecution({ parentController: this.parentController, ewiItemId: this.ewiItemId, scriptInfo: scriptInfo});
		this._functionalExecutionSection.appendChild(this._funcWidget.domNode);     
		this.inherited("initialize", arguments);   
   },
   
   //@Overriden from ExecutionViewer
	getHelpContextID: function()
	{
		return "com.ibm.rqm.adapter.appscan.web.ui.internal.view.extension.ASEExecutionSection.html";
	}, 

	//@Overriden from ExecutionViewer
	setCurrentRequest: function(request)
	{
		if (request) {
			this._funcWidget.showMessages(request.response);
		}
		
		var success = true;
		var percent = request.progress+"%"; 
		
		// Check if execution has results, if it does then it was successful, otherwise an error occured, most likely because no scan was created
		if (percent == "100%") {
			var properties = request.propertiesMap;
			var executionResultId = "";
			success = false;
			for(var i = 0; i < properties.length; i++) {
				if(properties[i].propertyName == "resultItemId") {
					success = true;
					executionResultId = properties[i].propertyValue;
					break;
				}
			}
		}
		
		if (success == false) {
			this._finalizedCancelled();
		}
		else {
			this.inherited("setCurrentRequest", arguments);
		}
	},
	
	_finalizedCancelled: function() {
		// Disable cancel button and say execution was canceled
		this.parentEditor.cancelButton.disabled = true;
		this.parentEditor.setHeaderStatus(Constants.getMessage("execution_canceled"), ViewHeaderLayout.ERROR);
	}
});

})();