/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.datapool.web.ui.internal.view.extension.DatapoolFileSection");
dojo.provide("com.ibm.rqm.datapool.web.ui.internal.view.extension.DatapoolFileSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.datapool.web.ui.internal.widgets.DatapoolAttachmentViewer");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() { // module container 	

var AbstractArtifactEditorSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;

dojo.declare("com.ibm.rqm.datapool.web.ui.internal.view.extension.DatapoolFileSection", [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
    templateString: '<div class="com-ibm-rqm-test-requirement-plan-section">' +
    '   <div dojoAttachPoint="_tableContainer"></div>' +
    '</div>',
    //@Overriden from AbstractArtifactEditorSection
    initialize: function(isEditable){
        this._showAttachmentView();
    },
    
    _showAttachmentView: function(){
        if (!this._attView) {
            this._attView = new com.ibm.rqm.datapool.web.ui.internal.widgets.DatapoolAttachmentViewer();
        }
        var attachmentObjects = new Array();
        
        if (this.getArtifact()) {
            var attachment = this.getArtifact().dataAttachment;
			if (attachment) {
				attachmentObjects.push({
					id: attachment.id,
					size: attachment.size,
					fileName: attachment.fileName,
					path: "",
					uuid: attachment.uuid
				});
			}
        }
        
        this._attView.initialize({
            isNonEditableMode: false,
			showPath: false,
            elements: attachmentObjects,
            parentSection: this
        });
        this._tableContainer.appendChild(this._attView.domNode);
        
    },
    
    //@Override for SaveParticipant
    getAttributes: function(){
        if (!this._attView) {
            //has not been initialized, no need to provide attributes
            return null;
        }		
        var attributes = {};
        //add attributes from sections into main args
        attributes.attachmentId = this._attaches[0].uuid;
        
        // FIXME - set parent to dirty
        this.getParentEditor().setDirty(true);
        return attributes;
    },
    
    //@Abstract: Override to provide section level validation
    validate: function(){
		if (!this._attView) {
			//has not been initialized, no need to validate
			return;
		}
        var allAttaches = this._attView.getAllAttachments();
        this._attaches = new Array();
        for (var index in allAttaches) {
            if (!allAttaches[index].isRemoved) {
                this._attaches.push(allAttaches[index]);
            }
        }
        if (this._attaches.length != 1) {
            this.getParentEditor().setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, Constants.DATAPOOL_ADDING_ATTACHMENT);
			return false;
        }
        return true;
    },
    
    //@Abstract: Override if desired; Default: no header information			
    getHeaderContent: /* String || DOM Node */ function(isEditable){
        return null; // override abstract header to disable section remove action. 
    },
    
    //@Overridden from AbstractArtifactEditorSection
    saveFinished: function(savedItem){
        this.inherited('saveFinished', arguments);
        this._showAttachmentView();
    }
});
})();