//TSTCS
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.extension.TestSuiteTestCasesSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTestCasesTableView");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.TestCaseConfigSelector");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

(function(){ // module container
	var ServiceResponseHandler 				    = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var AbstractArtifactEditorSection 			= com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
    var ExecutionWorkItemClient 				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
	var TestSuiteTestCasesTableView				= com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTestCasesTableView;
	var getCurrentProjectArea					= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	var TestCaseClient   			   			= com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
	var TestCaseConfigSelector					= com.ibm.rqm.execution.web.ui.internal.view.common.TestCaseConfigSelector;
	var getAuthenticatedContributor				= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var Constants    							= com.ibm.rqm.planning.web.client.internal.Constants;
	var EditorUtil 								= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
	var TestCaseMapper							= com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper;
	var ExecutionPopUp							= com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp;	
	var SelectItemTableDialog   				= com.ibm.rqm.planning.web.ui.internal.view.common.SelectItemTableDialog;
	var ViewHeaderLayout 						= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
			
    dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.extension.TestSuiteTestCasesSection", 
				[dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {

        templateString: "<div class=\"com-ibm-rqm-execution-web-ui-internal-view-extension-EWISection\">"+
							"<div dojoAttachPoint=\"_ewiSection\" ></div><div dojoAttachPoint=\"_ewiSelectionDialog\"></div>"+
						"</div>",
        
		isSerialExecution: true,
		_initialized: false,
		
        constructor: function(args){
        },
        
        postCreate: function(){
            this.inherited('postCreate', arguments);
        },
        
		//@Overriden from AbstractArtifactEditorSection
        initialize: function(isEsitable) {
			EditorUtil.loadStateTransitionConstraintSettings();  //Load the prefs in case we attempt actions that require checking (like execute)		
            dojox.data.dom.removeChildren(this._ewiSection);
			this._suite = this.getArtifact();
			this.ewis = [];
			
			//sort based on indexes
			if(this._suite  && this._suite.elements)
			{
				for(var i=0; i <this._suite.elements.length ;i++)
				{
					for(var j=i + 1; j <this._suite.elements.length;j++)
					if(this._suite.elements[i].index > this._suite.elements[j].index)
					{
						var tempElement = this._suite.elements[i];
						this._suite.elements[i] = this._suite.elements[j];
						this._suite.elements[j] = tempElement;
					}
				}
			}
	
			
			if(this._suite && this._suite.elements && this._suite.elements.length >0){
				for(var i=0;i<this._suite.elements.length;i++){
					this.ewis.push(this._suite.elements[i].workitem);
					this.ewis[i].rowId = this._suite.elements[i].index;
					this.ewis[i].defaultScript = this._suite.elements[i].script;
				}
			}
			if(this._suite){
				this.isSerialExecution = this._suite.sequentialExecution;
			}
			this._showEWITable(this.ewis,Constants.getMessage("labelTestCases"));
			this._initialized = true;
            this.defaultConfigId = null;
        },
		
		isInitialized: function(){
			return this._initialized;
		},
		
        //@Overriden from AbstractArtifactEditorSection
        getHelpContextID: function(){
            return "rqm_ewis.html";
        },
		
		getAttributes: function(){
			if(!this._initialized)
				return null;
			var content = this.ewis ? this.ewis : [];
			var values = [];
			//VS: Also get the selected scripts...save them as part of suiteJsonElements
			for(var i=0;i<content.length;i++){
				if(content[i]){
					var element = {index: i, workItemid: content[i].id};
					 if(content[i].defaultScript)
					 	element.testScriptId = content[i].defaultScript.id;
					values.push(element);	
				}
			}
			var returnArgs = {
				suiteElementsJsonString: dojo.toJson(values)
			};
			if(this._ewiTableViewer){
				returnArgs.isSerialExecution = !this._ewiTableViewer.getSerialExecutionState();//Checkbox is for parallel wi6856
			}
			return returnArgs;
		},
		
		validate: function(){
			return true;
		},
		
		_showEWITable: function(ewis, name) {
			this.ewis = ewis ? ewis : [];
			//lazy load config info
			for (var i = 0; i < (this.ewis ? this.ewis.length : 0); i++) {
		        this.ewis[i].configurationText = Constants.getMessage("labelLoading");
				if(this.ewis[i].testCase.scripts){
					var defaultScriptFound = false;
					for(var j=0;j<this.ewis[i].testCase.scripts.length;j++){
						if(this.ewis[i].testCase.scripts[j].archived){
							if(this.ewis[i].defaultScript && this.ewis[i].defaultScript.id == this.ewis[i].testCase.scripts[j].id)
								this.ewis[i].defaultScript = null;
							this.ewis[i].testCase.scripts.splice(j,1);
							j=j-1;
						}else if(this.ewis[i].defaultScript && this.ewis[i].defaultScript.id == this.ewis[i].testCase.scripts[j].id){
							defaultScriptFound = true;
						}
					}
					if(!defaultScriptFound)
						this.ewis[i].defaultScript = null;
				}
		    }
			//initially show ewis without config info (lazy loaded)
			var args = {
				executionWorkItems: this.ewis,				
				executable: true,
		        queryName: name ? name : this.queryTitle,
		        actions: this.getTableActions(),
				isSerialExecution: this.isSerialExecution,
				setParentSectionDirty: dojo.hitch(this, "setDirty") 
			};
		    if (this.isEditorSection) {
		        args.showTestCase = this.showTestCase;
		        args.queryName = null;
		        args.editable = this.editable;               
		    }
		    this._ewiTableViewer = new TestSuiteTestCasesTableView(args);
			
		    //display the table
			dojox.data.dom.removeChildren(this._ewiSection);
			this._ewiSection.appendChild(this._ewiTableViewer.domNode);	
			//lazy load config info
			for (var j = 0; j < (this.ewis ? this.ewis.length : 0); j++) {
			   this.getConfiguration(this.ewis[j]);
			}		                     
		},
      
		getConfiguration: function(ewi) {
			 if (ewi.configuration) {
				if (!this.configuration) {
					var self = this;
					var callbackObj = {
						success: function(config){
							self.configuration = config;
							self._createCatalog(ewi);
						},
						failure: function(e){
							self.error(e);
						}
					};
					var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
			   		var config = new com.ibm.rational.test.lm.web.client.internal.config(); 
					config.retrieveConfigurationWithDetails(responseHandler, ewi.configuration);
				} else {
					this._createCatalog(ewi);
				}
			 } else {
				ewi.configurationText = Constants.getMessage("labelNotConfig");
				this._ewiTableViewer.addConfigurationInfo(ewi.id, Constants.getMessage("labelNotConfig"));
			 }			
		},
		
		_createCatalog: function(ewi){	
		   this.theCatalog = this.theCatalog ? this.theCatalog : new com.ibm.asq.common.web.client.internal.Catalog();
         //initialize the catalog if necessary
			var catalog = com.ibm.asq.common.web.client.internal.Catalog;
			if (!catalog.theCatalog) {			
				var self = this;
				var callbackObj = {
					success: function(){
						self._setConfig(ewi);
					},
					failure: function(e){
						self._error(e);
					}
				};
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				this.theCatalog.initializeTemplates(responseHandler);
		
			} else {
				this._setConfig(ewi);
			}
		},
		
		_setConfig: function(ewi){
			this._ewiTableViewer.addConfigurationInfo(ewi.rowId, this.configuration);
		},
		
        getTableActions: function(){
            var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_TEST_SUITE;
            var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
            var canEdit = (!perm || perm.edit);
            var actions = [];
            
            if (canEdit) {
                actions.push({
                    actionId: "addtestcase",
                    label: Constants.getMessage("labelAddExistingTestCases"),
                    actionHandler: dojo.hitch(this, "_handleAddTestCase"),
                    iconClass: "add-icon-image",
                    disabledOnReadOnly: true
                });
            }

            var ewi_type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_EXECUTION_EWI_EXE;
            var ewi_exe_perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(ewi_type);
            
            if (!ewi_exe_perm || ewi_exe_perm.execute) {
                actions.push({
                    actionId: "execute",
                    label: Constants.getMessage("labelExeTest"),
                    actionHandler: dojo.hitch(this, "_handleExecute"),
                    iconClass: "execute-icon-image",
                    disabledOnReadOnly: false
                });
            }
            
            if (canEdit) {
                actions.push({
                    actionId: "edit",
                    label: Constants.getMessage("labelChangeExecProps"),
                    actionHandler: dojo.hitch(this, "_handleEdit"),
                    iconClass: "change-exec-props-image",
                    disabledOnReadOnly: true
                });
                
                actions.push({
                    actionId: "changescript",
                    label: Constants.getMessage("labelEditDefaultScript"),
                    actionHandler: dojo.hitch(this, "_handleEditScript"),
                    iconClass: "edit-icon-image",
                    disabledOnReadOnly: true
                });
                actions.push({
                    actionId: "save",
                    label: Constants.getMessage("labelSave"),
                    actionHandler: dojo.hitch(this, "_handleSave"),
                    iconClass: "save-icon-image",
                    disabledOnReadOnly: true,
                    hidden: true
                });
                actions.push({
                    actionId: "moveup",
                    label: Constants.getMessage("labelMoveUp"),
                    actionHandler: dojo.hitch(this, "_handleMoveUp"),
                    iconClass: "move-up-image",
                    disabledOnReadOnly: true,
                    disabled: true
                });
                actions.push({
                    actionId: "movedown",
                    label: Constants.getMessage("labelMoveDown"),
                    actionHandler: dojo.hitch(this, "_handleMoveDown"),
                    iconClass: "move-down-image",
                    disabledOnReadOnly: true,
                    disabled: true
                });
                actions.push({
                    actionId: "remove",
                    label: Constants.getMessage("labelRemoveTestCases"),
                    actionHandler: dojo.hitch(this, "_handleRemoveTestCase"),
                    iconClass: "delete-icon-image",
                    disabledOnReadOnly: true
                });
            }
            return actions;
        },
        
        //@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
			this._suite = this.getArtifact();
			if(this._ewiTableViewer){
				this._ewiTableViewer.refresh(this.ewis, this._startEditOnSave ? false : true);
				if(this._startEditOnSave){
					for(var i=0;i<this._startEditOnSave.length;i++){
						this._ewiTableViewer.setRowChecked(this.ewis[this._startEditOnSave[i]],true);
					}
					this._startEditOnSave = null;
					this._ewiTableViewer.toggleSelectScript(true);
				}
			}
            this.inherited('saveFinished', arguments);
        },
        
        update: function(){
            this.initialize();
        },

		/*
		 * Action Handlers for the table
		 */

		_handleAddTestCase: function(){
			 var params = {
                title: Constants.getMessage("labelAddItems", Constants.TYPE_CASE),
                showQueryFilters: true,
                exclusionList: [],
                itemType: Constants.TYPE_CASE,               
                onOk: dojo.hitch(this, "_updateTable"),                    
                onAddNew: function() {
                    alert(Constants.getMessage("labelNotSupported"));
                }
            };
            var itemListWidget = new SelectItemTableDialog(params);
            itemListWidget.setExclusionList([]);
            itemListWidget.show();						
		},
	
		_cancelClicked: function(){
			
		},
		
		_updateTable: function(addedItems){
			var items = [];
			for (var j = 0; j < addedItems.length; j++) {
				var testCase = addedItems[j];//TestCaseMapper.map(addedItems[j]); // converts the summaryDTO to fullDTO
				var item = {
					isNew: true,
					testCase: testCase,
					config: null
				};
				items.push(item);
			}
			if (items.length > 0) {
				this.setDirty(true);
				this._ewiTableViewer.appendItem(items);
			}
		},
		
		_handleExecute: function(){
			if (this._suite){
				var selectedItems = this._ewiTableViewer.getSelectedItems();
				if (EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ONLYEXECUTEAPPROVED)){
					var alertString = "";
					var badTestCaseString = "";
					if(!selectedItems || selectedItems.length == 0){
						alertString = "Select a test case to run.";
						if (this.parentEditor && this.parentEditor._header)
							this.parentEditor._header.setStatus(Constants.getMessage("cantExecuteTestCase"), ViewHeaderLayout.WARNING, alertString);
						return;
					}
					else if(selectedItems.length > 1){
						alertString = "Select only one test case to run.";
						if (this.parentEditor && this.parentEditor._header)
							this.parentEditor._header.setStatus(Constants.getMessage("cantExecuteTestCase"), ViewHeaderLayout.WARNING, alertString);
						return;
					}
					else if(selectedItems[0].testCase.state != Constants.STATETRANSITION_STATE_APPROVED){
						badTestCaseString += " " + selectedItems[0].testCase.name;		
					}
					if (badTestCaseString != ""){ //Found an offending test case so display a message and return
						var errorStr = Constants.getMessage("msgCannotExecuteTestCaseNotApproved", badTestCaseString);
						if (this.parentEditor && this.parentEditor._header)
							this.parentEditor._header.setStatus(Constants.getMessage("cantExecuteTestCase"), ViewHeaderLayout.WARNING, errorStr);
						else
							alert(errorStr);
						return;
					}
				}
			 	var execPopUp = new ExecutionPopUp();
				var args = {
					testCase: selectedItems[0].testCase,
					defaultScript:selectedItems[0].defaultScript
				};
				execPopUp.initialize(args);
			}
		},
		_handleEdit: function(){
			var selectedTestCases = this._ewiTableViewer.getSelectedItems();
			if(!selectedTestCases || selectedTestCases.length == 0){
				return;
			}
			this.selectedItem = selectedTestCases;
			var responseHandler= new ServiceResponseHandler(this, "_setEditConfigurations", "_error");
			var cfg = new com.ibm.rational.test.lm.web.client.internal.config();
			cfg.getAll(responseHandler);
		},
		_handleEditScript: function(){
			if(this._ewiTableViewer.scriptsEditing){
				this._ewiTableViewer.toggleSelectScript(true);
				return;
			}
			var selectedItems = this._ewiTableViewer.getSelectedItems();
			var selectedIds = [];
			var foundNewItem = false;
			for(var i=0;i<selectedItems.length;i++){
				if(selectedItems[i].isNew == true){
					foundNewItem = true;
				}
				selectedIds.push(parseInt(selectedItems[i].rowId,10));
			}
			if(!foundNewItem)
				this._ewiTableViewer.toggleSelectScript(true);
			else
				this._askToSave(selectedIds);
		},
		_handleSave: function(){
			this._ewiTableViewer.toggleSelectScript();
			this._ewiTableViewer.refresh(this.ewis, true);
			this.setDirty(true);
		},
		_setEditConfigurations: function(response){
			this.configs = [];
			this.configs.push({name: Constants.getMessage("labelUnassigned"), id: null, stateId: null, configuration: null});
			
			if (response) {
				for(var i=0; i < response.length; i++){
					this.configs.push(response[i]);
				}
			}

			var args = {
				okCallback: dojo.hitch(this, this._editOkClicked),
				cancelCallback: dojo.hitch(this, this._cancelClicked) 
			};
			this._testCaseSelector = new TestCaseConfigSelector(args);
			var testcases = [];
			for(var i=0;i<this.selectedItem.length;i++){
				testcases.push(this.selectedItem[i].testCase);
			}
			this._testCaseSelector.initialize({testCases: testcases, configs: this.configs, selectedItem: this.selectedItem[0].testCase});
		},
		
		_editOkClicked: function(args){
			for (var j = 0; j < this.selectedItem.length; j++) {
				this.selectedItem[j].isNew = true;
				var changed = false;
				if(args.selectedConfig && args.selectedConfig[0]){

					// Check if the "Unassigned" Configuration is selected
					if (args.selectedConfig[0].name == Constants.getMessage("labelUnassigned") 
							&& (args.selectedConfig[0].id == "null") || (args.selectedConfig[0].id == null))
					{
						this.selectedItem[j].config = null;
						this.selectedItem[j].configuration = null;
					}
					else 
					{
						this.selectedItem[j].config = args.selectedConfig[0];
						this.selectedItem[j].configuration = args.selectedConfig[0].id;
					}
					changed = true;
				}	
				if(args.testPlanId){
					this.selectedItem[j].testPlan = {}
					this.selectedItem[j].testPlan.name = args.testPlanName;
					this.selectedItem[j].testPlan.id = args.testPlanId;
					this.selectedItem[j].testPlan.versionableItemId = args.testPlanVersionableItemId;
					changed = true;
					if(args.testPhaseItemId){
						this.selectedItem[j].testPhase = {};
						this.selectedItem[j].testPhase.name = args.testPhaseName;
						this.selectedItem[j].testPhase.itemId = args.testPhaseItemId;
						changed = true;
					}
				}
				if(changed)
					this.selectedItem[j].id = null;//To make this as New
			}
			this.setDirty(true);
			this._ewiTableViewer.refresh();
		},
		
		_handleRemoveTestCase: function(){
			if(this._ewiTableViewer){
				var selectedItems = this._ewiTableViewer.getSelectedItems();
				var content = this._ewiTableViewer.getTableContent();
				if(selectedItems.length == 0){
					return;
				}
				for(var i=0;i<selectedItems.length;i++){
					var updatedContent = [];
					for(var j=0;j<content.length;j++){
						if(content[j].rowId == selectedItems[i].rowId){
							continue;
						}
						updatedContent.push(content[j]);
					}
					content = updatedContent;//swap updated content so that less traversal is needed.
				}
				this.setDirty(true);
				this._ewiTableViewer.refresh(content,true);
				if(content.length ==0)
					this._ewiTableViewer.disableAllActions();
				this.ewis = content;
			}
		},
		_handleMoveUp:function(){
			var selectedItems = this._ewiTableViewer.getSelectedItems();
			var content = this._ewiTableViewer.getTableContent();
			for(var i=0;i<selectedItems.length;i++){
				var rowId = parseInt(selectedItems[i].rowId,10);
				if (rowId != 0) {
					var rowToSwap = dojo.clone(content[rowId - 1]);
					content[rowId - 1] = content[rowId];
					content[rowId - 1].rowId = rowId -1;
					content[rowId] = rowToSwap;
					content[rowId].rowId = rowId;
					this._ewiTableViewer.setRowChecked(content[rowId-1],true);
					this._ewiTableViewer.setRowChecked(content[rowId],false);
				} 
			}
			this.setDirty(true);
			this._ewiTableViewer.refresh();
			this.ewis = content;
		},
		_handleMoveDown:function(){
			var selectedItems = this._ewiTableViewer.getSelectedItems();
			var content = this._ewiTableViewer.getTableContent();
			for(var i=selectedItems.length;i>0;i--){
				var rowId = parseInt(selectedItems[i-1].rowId,10); 
				if (rowId != content.length-1) {
					var rowToSwap = dojo.clone(content[rowId + 1]);
					content[rowId + 1] = content[rowId];
					content[rowId + 1].rowId = rowId + 1;
					content[rowId] = rowToSwap;
					content[rowId].rowId = rowId;
					this._ewiTableViewer.setRowChecked(content[rowId+1],true);
					this._ewiTableViewer.setRowChecked(content[rowId],false);
				}
			}
			this.setDirty(true);
			this._ewiTableViewer.refresh();
			this.ewis = content;
		},
		preProcess: function(){
			if(this._ewiTableViewer){
				var content = this._ewiTableViewer.getTableContent();
				var items = [];
				for(var i=0;i<content.length;i++){
					if(content[i].isNew || content[i].archived){
						content[i].isNew = true;
						items.push(content[i]);
					}
				}
				this.totalCount = items.length;
				this.saveCompleteCount = 0;
				this.saveErrorCount = 0;
				if(this.totalCount == 0){
					this.parentEditor.markSectionComplete(this.getSection().id, true);
				}else{
					//create/update EWI here
					for(var i=0;i<items.length;i++){
						var testCase = items[i].testCase.versionableItemId;
						var owner = getAuthenticatedContributor().userId;
						var name = items[i].testCase.name;
						if(items[i].config && items[i].config.name && (items[i].config.name != Constants.getMessage("labelUnassigned"))){
							name=name + "_" + items[i].config.name;
						}
						var params = {};
						params ={
								owner: owner,
								name: name,
								testCase: testCase
							};
						if(items[i].config)
							params.testConfig = items[i].config.id;
						
						//VS: Should not update the TER with default script - keep this for the suite only.
//						if (items[i].defaultScript) {
//							params.defaultScript = items[i].defaultScript.id;
//						}
						if (!items[i].id || items[i].archived){ 
							params.newExecutionWorkItem = true;
						}else {
							params.id = items[i].id;
							params.ewiStateId = items[i].stateId;
						}
						if(items[i].testPlan && items[i].testPlan.versionableItemId){
							params.testPlanItemId = items[i].testPlan.versionableItemId;
							if(items[i].testPhase && items[i].testPhase.itemId)
								params.testPhase = items[i].testPhase.itemId;
						}
						var responseHandler = new ServiceResponseHandler(this, "_saveSuccess", "_saveError");
						ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, params);
					}
				}
			}else{
				this.parentEditor.markSectionComplete(this.getSection().id, true);
			}
		},

		_saveSuccess: function(ewi){
			if(ewi.testCase.scripts){
				var defaultScriptFound = false;
				for(var j=0;j<ewi.testCase.scripts.length;j++){
					if(ewi.testCase.scripts[j].archived){
						if(ewi.defaultScript && ewi.defaultScript.id == ewi.testCase.scripts[j].id)
							ewi.defaultScript = null;
						ewi.testCase.scripts.splice(j,1);
						j=j-1;
					}else if(ewi.defaultScript && ewi.defaultScript.id == ewi.testCase.scripts[j].id){
						defaultScriptFound = true;
					}
				}
				if(!defaultScriptFound)
					ewi.defaultScript = null;
			}
			this._appendItemsInTable(ewi);
			this.saveCompleteCount++;
			this._saveComplete();
		},
		
		_appendItemsInTable: function(ewi){
			if(this._ewiTableViewer)
				this._ewiTableViewer.updateItem(ewi);
			this.ewis = this._ewiTableViewer.getTableContent();
		},
		
		_saveError: function(errorObj){
			console.error("save error in TSTCSection");
			this.saveErrorCount++;
			this._saveComplete();
		},
		
		_saveComplete: function(){
			 this._ewiTableViewer.refresh(null, this._ewiTableViewer.getSelectedItems().length > 0 ? false : true);
			if(this.totalCount == (this.saveCompleteCount+this.saveErrorCount)){
				this.parentEditor.markSectionComplete(this.getSection().id, true);
			}
		},
		
		_askToSave:function(selectedIds){
			var self = this;
			var args = {
				message: Constants.getMessage("msgSaveRequiredToChange", Constants.TYPE_SUITE, Constants.getMessage("labelDefaultTS")),
				yesCallback: function(){
					self._startEditOnSave = selectedIds;
            		self.getParentEditor().onSave();    
					return true;          
				},
				noCallback: function() {
					return;
				}
			}
			var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
       	 	dialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
			dialog.open();
		},
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from TestSuiteTestCasesSection#_error");
		}
		
        
    });
    
})();
