/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.keyword.web.ui.internal.view.keyword.NewKeywordPopup");
dojo.provide("com.ibm.rqm.keyword.web.ui.internal.view.keyword.NewKeywordPopup");

dojo.require("dojox.data.dom");
dojo.require("dojo.number");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.TagSelector");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView");

(function(){
    var CSHelp 					= com.ibm.asq.common.web.ui.internal.util.CSHelp;
    var Constants 				= com.ibm.rqm.planning.web.client.internal.Constants; 
	var TagWidget				= com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget;
	var WidgetUtil 				= com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
	var TestScriptClient        = com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
	var TestScriptTableView     = com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView;
	var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	
    dojo.declare("com.ibm.rqm.keyword.web.ui.internal.view.keyword.NewKeywordPopup", [dijit._Widget, dijit._Templated], {
        templateString: '<div class="com-ibm-rqm-construction-newitem-popup">' +
                        '   <table dojoAttachPoint="_formNode" width="100%"><tbody>' +
                        '       <tr dojoAttachPoint="_nameNode">' +
                        '			<td width="40%"><label for="name" class="label">${labelName}</label></td>' +    
                        '			<td width="60%" style=\"padding-top:5px;\"><input id="name" type="text" size="40" dojoAttachPoint="_name" class="input"></input></td>' +
                        '		</tr>' +   
                        '		<tr dojoAttachPoint="_tagsNode">' +
                        '			<td width="40%"><span class="label">${labelTags}<span></td>' +    
                        '			<td width="60%" style=\"padding-top:5px;\"><div dojoAttachPoint="_tags"></div></td>' +
                        '		</tr>'+
						'		<tr>'+
						'		<td colspan=2 style=\"padding-top:5px;\">'+
						'				<input type="checkbox" dojoAttachPoint="_checkValue" dojoAttachEvent="onclick: _checkValueChange"></input>'+
						'				<label style=\"padding:5px\">${labelUseExistingScript}</label></td>'+
						'		</tr>'+						  
                        '   </tbody></table>' +
						'	<div dojoAttachPoint="_scriptTable"></div>'+                                        
                        '</div>',
        
		width: "600px",
		labelName:Constants.getMessage("labelName"),
		labelTags:Constants.getMessage("labelTags"),
		labelUseExistingScript:Constants.getMessage("labelUseExistingScript"),
        constructor: function(args){
            this.onOkCallback = null;
			this.tagList = [];
        },
		postCreate: function() {
            if (!this.onOkCallback) {
                throw new Error("Parameter 'onOkCallback' is REQUIRED!");   
            }
            var dialogArgs = {
                okCallback: dojo.hitch(this, "_onOK"),
                cancelCallback: dojo.hitch(this, "_onCancel")
            };
            this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this._dialog.setWidth(this.width);
            this._dialog.contentContainer.appendChild(this.domNode);
            this._dialog.setSecondaryTitle(Constants.getMessage("labelNewItemTitle",Constants.TYPE_KEYWORD));
            this._dialog.getOkButton().disabled = false;                                
			this.show();			
		},
        updateTagList:function(tagList){
			this.tagList = tagList;
		},
		show:function(){
			if(this._tagWidget)
				this._tagWidget.destroy();
			this._tagWidget = new NewKeywordPopup.TagWidget({values:[""],_possibleValues:this.tagList});
			this._tags.appendChild(this._tagWidget.domNode);
			this._name.value = "";
			this._dialog.open(false);
			this._dialog.updatePosition();
		},
        getItemForDisplay: function() {
            var item = {
                name: this._name.value,
				tags:this._tagWidget.tags.value
            }
			if(this._checkValue.checked){
				item.selectedScriptItemId = this._list.getSelectedItems()[0].itemId;
			}
            return item;
        },        
        validate: function() {
            if (!this._name.value || dojo.trim(this._name.value).length == 0) {
                alert(Constants.getMessage("msgNameRequired"));
                return false;
            }
			if (this._checkValue.checked && this._list.getSelectedItems().length <=0) {
				alert(Constants.getMessage("labelSelectTestScript"));
				return false;
			}
			return true;           
        },
		_loadArtifacts:function(scripts){
			this.scripts = [];
			for(var i=0;i<scripts.length;i++){
				if(scripts[i].scriptTypeId == "com.ibm.rqm.planning.common.scripttype.manual")
					this.scripts.push(scripts[i]);
			}
			var tableArgs = {scripts: this.scripts, profile: Constants.TABLE_PROFILE_MINIMAL}				
			this._list = new TestScriptTableView(tableArgs);
			this._list.setTableRowsCheckable(true,true);
			this._scriptTable.appendChild(this._list.domNode);
			this._dialog.updatePosition();
		},
		_queryError:function(e){
			console.error(e.msg);
		},
		_checkValueChange:function(){
			if (this._checkValue.checked) {
				this._scriptTable.style.display = "inline";
				if (!this._list) {
					var srh = new ServiceResponseHandler(this, "_loadArtifacts", "_queryError");
					TestScriptClient.getTestScriptsMinimal(srh);
				}
				else
					this._dialog.updatePosition();
			}else {
				this._scriptTable.style.display = "none";
				this._dialog.updatePosition();
			}
		},
        _onOK: function() {      
            if (this.validate()) {
				this.onOkCallback();
			}
			else {
				return false;
			}
        },        
        _onCancel: function(){

        }        
        
    });
	dojo.declare("NewKeywordPopup.TagWidget", 
             com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget,
{    
		templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/layout/templates/TagWidget.html"),
		postCreate: function() {
//			WidgetUtil.setSpacerImage(this._spacer);
			var values = this.values;
			this.tags.value = WidgetUtil.getFirstValue(values, true, null, null);
			this._setReadOnlyTagValues(this.tags.value);
			this._previousTagsValue = this.tags.value;
			var self = this;
			this._tagSelector= /* createWidget */ new com.ibm.team.workitem.web.ui.internal.view.editor.TagSelector( {	
					_tagNode: this.tags,
					parentWidget: this,
					_parentNode: this.domNode,
					_callback: function(str) {
						self._updateTagText(str);
					}
				});
/*			if (this.parentController.pageController.isGuest()) {
				dojo.addClass(this.tags, "GuestField");
			}
*/			
			this._tagSelector.setAllTags(this._possibleValues);
			this._isChanged = false;
			this.setReadOnly(false);
		}
	});
})();
