/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.process.web.client.projectarea");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient");

(function(){

    var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
    var Utility = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
    var DOWNLOAD_SERVICE_URI = "com.ibm.rqm.integration.service.IIntegrationService/"; //RQM Downaload Service
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var DatapoolClient = com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient;
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
	
    dojo.declare("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableListener", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener, {
        constructor: function(parentView){
            this.parentView = parentView;
        },
        
        rowCheckStateChanged: function(tableViewer, rowObject, state){
            var selectionCount = tableViewer.getCheckedRows().length;
            if (this.parentView.deleteActionNode) 
                this.parentView.deleteActionNode.setDisabled(selectionCount == 0);
        },
        
        groupRowsCheckStateChanged: function(tableViewer, rowObjects, state){
            this.rowCheckStateChanged(tableViewer, rowObjects, state);
        },
        
        tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
            if (callback != null && dojo.isFunction(callback)) {
                if (callbackData != null) {
                    callback(callbackData);
                }
                else {
                    callback();
                }
            }
        }
    });
    
    dojo.declare("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableProvider", com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, {
        getNumColumns: function(content){
            return 3;
        },
        
        getColumnHeading: function(content, index){
            var headings = [Constants.getMessage("labelName"), Constants.getMessage("labelDescription"), Constants.getMessage("labelDateFileDatapool")];
            return headings[index];
        },
        
        getColumnHeadingImage: function(content, atColumnIndex){
            return null;
        },
        
        getIsColumnGroupable: function(content, atColumnIndex){
            return false;
        },
        
        getIsColumnSortable: function(content, atColumnIndex){
            return true;
        },
        
        getColumnWidth: function(content, atColumnIndex){
            switch (atColumnIndex) {
                case 0:
                    return 20;
                case 1:
                    return 50;
                case 2:
                    return 30;
            }
            return 0;
        },
        
        getContentObjects: function(content){
            return content;
        },
        
        getRowDataId: function(rowData){
            return "_table_row_for_datapool_" + rowData.itemId;
        },
        
        getCellDisplayType: function(rowData, atColumnIndex){
            var type = TableConstants.RENDER_TYPE_TEXT;
            if (atColumnIndex == 0 || atColumnIndex == 2) {
                type = TableConstants.RENDER_TYPE_LINK;
            }
            return type;
        },
        
        getCellAlignment: function(rowData, atColumnIndex){
            return TableConstants.ALIGN_LEFT;
        },
        
        getCellDisplayData: function(rowData, atColumnIndex){
            var val = "data";
            switch (atColumnIndex) {
                case 0:
                    val = rowData.name;
                    break;
                case 1:
                    val = rowData.description;
                    break;
                case 2:
                    val = rowData.dataAttachment ? rowData.dataAttachment.fileName : "";
                    break;
            }
            return val;
        },
        
        getCellDisplayExtendedInfo: function(rowData, atColumnIndex){
            var val = null;
            if (atColumnIndex == 0) {
                val = {};
                val.href = Utility.getViewDatapoolURI(rowData.itemId);
            }
            if (atColumnIndex == 2) {
                val = {};
				val.href = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + "attachment/urn:com.ibm.rqm:attachment:"+(rowData.dataAttachment ? rowData.dataAttachment.id : "");
            }
            return val;
        }
    });
    
    dojo.declare("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableView", [dijit._Widget, dijit._Templated], {
        templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
                    '</div>',
		widgetsInTemplate: true,
        
        constructor: function(){
            this.datapools = null;
            this.refreshCallback = null;
            this.queryName = null;
            this.showInitLoadProgress = false;
        },
        
        postCreate: function(){
            var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
                allowAdjustSettings: true,
                autoSaveSettings: true,
                tableId: "RQM-DATAPOOL-TABLEVIEWER"                          
            });
            this._tableViewerNode.appendChild(tableViewer.domNode);
            
            var content = this.datapools ? this.datapools : [];
            this.queryName = this.queryName ? this.queryName : "Datapools";
            this.viewHeaderNode.setTitle(this.queryName);
            tableViewer.setContentPageSize(20);
            tableViewer.setContent(content);
			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
            tableViewer.setContentProvider(new com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableProvider());
            tableViewer.setTableListener(new com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableListener(this));
            for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
                var action = this.actions[i];
                tableViewer.addAction(action.label, action.label, this, action.iconClass, action.actionHandler);
            }
            var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_DATAPOOL);
            // archive support
            if (!permission || permission[PermissionsClient.ACTION_ARCHIVE]) {
                this.deleteActionNode = tableViewer.addAction(
                    "delete",                                  // action id
                    Constants.getMessage("labelDelete"),       // label
                    null,                                      // callback data
                    "delete-icon-image",                       // icon class
                    dojo.hitch(this, "_onDeleteActionClick")); // callback
                this.deleteActionNode.setDisabled(true);
            }
            tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);
            if(this.showInitLoadProgress) {
                tableViewer.showLoadingProgress();
            }
            tableViewer.show();
            
            this.tableViewer = tableViewer;
        },
        
        _onDeleteActionClick: function() {
	        // check if any selected test cases are current displayed in another tabs
	        var openedArtifacts = [];
	        this.selectedDPs = [];
	        if (this.artifactsDisplayContainer) {
	            var userSelectedDPs = this.tableViewer.getCheckedRows();
	            
	            if (userSelectedDPs.length > 0) {
	                for (var i = 0; i < userSelectedDPs.length; i++) {
	                    var dpURI = Utility.getViewDatapoolURI(userSelectedDPs[i].id);
	                    if (this.artifactsDisplayContainer.hasPage(dpURI)) {
	                        openedArtifacts.push(userSelectedDPs[i]);
	                    } else {
	                        this.selectedDPs.push(userSelectedDPs[i]);
	                    }
	                }
	            }
	        } else {
	            this.selectedDPs = this.tableViewer.getCheckedRows();
	        }
	        
	        var prompt = Constants.getMessage("msgDelDatapoolConfirm");
	        if (openedArtifacts.length > 0) {
	            if (this.selectedDPs.length > 0) {
	                // some selected artifacts are not opened in tabs
	                prompt = Constants.getMessage("msgDelSomeOpenDatapoolConfirm");
	            } else {
	                // all selected artifacts are opened in tabs
	                prompt = Constants.getMessage("msgDelAllOpenDatapoolConfirm");
	            }
	        }
	
	        var args = {
	            'message': prompt,
	            'options': openedArtifacts,
	            'okCallback': 
	                function(view) {
	                    view._deleteAction();
	                },
	            'okCallbackData': this,
	            'cancelCallback': null,
	            'cancelCallbackData': null
	        };
	        this.confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.OptionsDialog(args);
	        this.confirmDialog.setTitle(Constants.getMessage("labelConfirmation"));
	        this.confirmDialog.open();
	    },
	    
	    _deleteAction: function() {         
	        this.selectedDPs = this.selectedDPs.concat(this.confirmDialog.getSelection());
	        this.selectedDPCount = this.selectedDPs.length;
	
	        if (this.selectedDPCount > 0) {
	            this.deleteActionNode.setDisabled(true);
	            this.errorDPCount = 0;
	            this.deletedDPCount = 0;
	
	            for (var i = 0; i < this.selectedDPCount; i++) {
	                var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
	                DatapoolClient.archiveDatapool(responseHandler,
	                        {
	                            itemId: this.selectedDPs[i].itemId,
	                            archive: true
	                        });
	                this.viewHeaderNode.setProgressStart(Constants.getMessage("msgDeletingDatapool", this.selectedDPs[i].name));
	            }
	        }
	    },
	    
	    _deleteSuccess: function(response) {
	        this.viewHeaderNode.setProgressEnd();
	        this.deletedDPCount++;
	        this._setDeleteStatus();
	
	    },
	    
	    _deleteFailure: function(err) {
	        this.viewHeaderNode.setProgressEnd();
	        this.errorDPCount++;
	        this._setDeleteStatus();
	    },
	    
	    _setDeleteStatus: function() {
	        if ((this.deletedDPCount + this.errorDPCount) == this.selectedDPCount) {
                this.viewHeaderNode.setStatus(
                    Constants.getMessage("msgDeletedDatapools", this.deletedDPCount, this.selectedDPCount),
                    this.errorDPCount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedDPCount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
                );
                if (this.deletedDPCount > 0) {
	                // notify all pages (including itself) datapool are deleted
	                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_DATAPOOL, this.selectedDPs]);
	            }
	        }
	    },
	    
	    // handler on artifacts changed
	    onArtifactChanged: function(changeType, artifactType, artifactArray) {
	        // only care about test cases
	        if (artifactType == Constants.TYPE_DATAPOOL) {
	            if (changeType == GlobalEvents.ArtifactsAdded) {
	                // add test cases to the table
	                if (!this.datapools) {
	                    this.datapools = artifactArray;
	                } else {
	                    this.datapools = this.datapools.concat(artifactArray);
	                }
	                this.refresh(this.datapools);
	            } else {
	                // iterate through the array of artifacts
	                for (var i = 0; i < artifactArray.length; i++) {
	                    // iterate through the array of test cases in the table
	                    for (var j = 0; j < this.datapools.length; j++) {
	                        // handle the matching test case
	                        if (artifactArray[i].itemId == this.datapools[j].itemId) {
	                            if (changeType == GlobalEvents.ArtifactsUpdated) {
	                                // swap datapool on update
	                                this.datapools.splice(j, 1, artifactArray[i]);
	                                this.refresh(this.datapools);
	                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
	                                // remove datapool from table on delete
	                                this.datapools.splice(j, 1);
	                                this.refresh(this.datapools);
	                            }
	                            break;
	                        }
	                    }
	                }
	            }
	        }
	    },	
        
        refresh: function(content){
			this.datapools = content;
            if(this.showInitLoadProgress) {
                this.tableViewer.endLoadingProgress();
                this.showInitLoadProgress = false;
            }
            this.tableViewer.setContent(content ? content : []);
            this.tableViewer.refresh();
        },
		
		setInProgress: function(msg) {
			this.viewHeaderNode.setProgressStart(msg);
		},
	
		stopInProgress: function() {
			this.viewHeaderNode.setProgressEnd();
		}
    });
    
})();
