/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ProgressBarCellRenderer");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
(function() {

var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache    			= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Utility     		   	= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants  			    = com.ibm.rqm.planning.web.client.internal.Constants;
var ConfigurationUriUtil 	= com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;

dojo.declare("ExecutionTableViewTableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
  
    rowCheckStateChanged: function(tableViewer, rowObject, state){
	},
    
    tableContentActionInvoked: function(tableViewer, actionId, callbackData){                
        if (callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        } 
    }
});

dojo.declare("ExecutionTableViewCellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
    },
    
    cellActionInvoked: function(rowObject, columnIndex){
    }
});

dojo.declare("ExecutionTableViewListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    _createListContents: function(viewer, rowObject, listWidget){
        this.inherited("_createListContents", arguments);   
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = Constants.getMessage("labelAddCustCrtl");
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("ExecutionTableViewTableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    constructor: function(args) {
        dojo.mixin(this, args);
    },
	
	setERGId: function(ergId){
		this.ergId = ergId;
	},
	
    getNumColumns: function(content){
        return 8;
    },
    
	getColumnHeading: function(content, index){
		var headings = [];
        if(this.getIsConsoleNode()){
			headings.push(Constants.getMessage("labelType"));
		}
		headings.push(
            Constants.getMessage("labelName"),
            Constants.getMessage("labelConfig"),
            Constants.getMessage("labelScript"),
			Constants.getMessage("labelHostname"),
			Constants.getMessage("labelstatus"),
			Constants.getMessage("labelProgress"),
			Constants.getMessage("labelModified")
        );
		if(!this.getIsConsoleNode())
			headings.push(Constants.getMessage("labelResult"));
        return headings[index];
    },
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
	 
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
		if(this.getIsConsoleNode())
			return (atColumnIndex === 0); 
		else
			return false;    
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex){
        atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
		switch(atColumnIndex) {
            case 0: 
                return 5;
			case 1: 
                return this.getIsConsoleNode() ? 10 : 15;
            case 2: 
                return 15;
            case 3: 
                return 15;
            case 4: 
                return 15;
			case 5: 
                return 5;
			case 6: 
                return 20;
            case 7: 
                return this.getIsConsoleNode() ? 15 : 10;
			case 8: 
                return 5;	 
        }
        return 0;
    },
   
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_table_row_for_con_" + rowData.itemId;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
		atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 2: 
                type = rowData.configuration ? TableConstants.RENDER_TYPE_LINK : (this._getPropertyValue(rowData.propertiesMap, "configuration") != "" ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT);
                break;
			case 3: 
                type = rowData.scriptName ? TableConstants.RENDER_TYPE_LINK : (this._getPropertyValue(rowData.propertiesMap, "scriptName") != "" ? TableConstants.RENDER_TYPE_LINK: TableConstants.RENDER_TYPE_TEXT);
                break;	
			case 5: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 6: 
                type = (rowData.state && rowData.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled")?
							TableConstants.RENDER_TYPE_TEXT:"RenderType.ProgressBar";
                break;
            case 7: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;                               
			case 8:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;					 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        if(atColumnIndex < 0)
            return TableConstants.ALIGN_CENTER;
		atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
		if(atColumnIndex == 0 || atColumnIndex == 5)
			return TableConstants.ALIGN_CENTER;	
        return TableConstants.ALIGN_LEFT;
    },
        
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
		atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
        switch(atColumnIndex) {
            case 0: 
                val = rowData.scriptTypeName ? Constants.getMessage("labelTestSuites") : Constants.getMessage("labelEWIs");
                break;
			case 1:
				val = rowData.testCaseName ? rowData.testCaseName : this._getPropertyValue(rowData.propertiesMap, "testCaseName");
				val = val + " "+Constants.getMessage("labelExecution"); 		
                break;
            case 2: 
                val = rowData.configuration ? rowData.configuration : (this._getPropertyValue(rowData.propertiesMap, "configuration") != "" ? this._getPropertyValue(rowData.propertiesMap, "configuration"): Constants.getMessage("labelUnassigned"));
                break;
            case 3: 
                val = rowData.scriptName ? rowData.scriptName : (this._getPropertyValue(rowData.propertiesMap, "scriptName") != "" ? this._getPropertyValue(rowData.propertiesMap, "scriptName"): Constants.getMessage("labelUnassigned"));
                break;   
            case 4: 
				val = rowData.machine ? rowData.machine : this._getPropertyValue(rowData.propertiesMap, "machine");
                break; 
			case 5: 
				val = rowData.state ? rowData.state.id : "";
                break;
			case 6: 
				if(rowData.state && rowData.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled")
					val = Constants.getMessage("msgSuiteExecCancelled");
				else
					val = rowData.progress;	
                break;
			case 7:
				var now = new Date();
				if (parseInt(now.getTime(), 10) > parseInt(rowData.modified, 10)) {
                    now.setTime(rowData.modified);
                }
                val = now;
                break;
			case 8:
				val = "";
				var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId");
				if (resultId && resultId != "")
					val = Constants.getMessage("labelExeResult");
				break;
        }
        return val;
    },
    
    _getPropertyValue: function(propertiesMap, key){
		var value = "";
		for(var i=0;i<(propertiesMap ? propertiesMap.length : 0);i++){
			if(propertiesMap[i].propertyName == key){
				value = propertiesMap[i].propertyValue;
				break; 
			}
		}
		return value;
	},
	
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){ 
        var val = {};  
		atColumnIndex += this.getIsConsoleNode() ? 0 : 1;
		if(atColumnIndex == 0){
			 val.image = rowData.icon ? rowData.icon : ImageCache.EWI;
			 if(rowData.link)
				val.href = rowData.link;
			else{
				var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId") !="" ? this._getPropertyValue(rowData.propertiesMap, "resultItemId") : null;
				var ergId = this.ergId?this.ergId:this._getPropertyValue(rowData.propertiesMap,"resultGroupId");
            	val.href = Utility.startExecution(this._getPropertyValue(rowData.propertiesMap, "ewiItemId"), this._getPropertyValue(rowData.propertiesMap, "scriptId"), resultId, rowData.id, ergId);
			} 
		} else if(atColumnIndex == 1) {
			if(rowData.link){
				 val.href = rowData.link;
			}else{
				var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId") !="" ? this._getPropertyValue(rowData.propertiesMap, "resultItemId") : null;
				var ergId = this.ergId?this.ergId:this._getPropertyValue(rowData.propertiesMap,"resultGroupId");				
	            val.href = Utility.startExecution(this._getPropertyValue(rowData.propertiesMap, "ewiItemId"), this._getPropertyValue(rowData.propertiesMap, "scriptId"), resultId, rowData.id, ergId);
				val.tooltip = Utility.getTestInformationToolTip({
					type: Constants.getExtensionDisplayMessage(this._getPropertyValue(rowData.propertiesMap, "scriptTypeName")),
					testPlan: this._getPropertyValue(rowData.propertiesMap, "testPlan"),
					testPhase: this._getPropertyValue(rowData.propertiesMap, "testPhase")
				});
			}	
        }else if(atColumnIndex == 2){
			if(rowData.link){
				val.href = rowData.link;
			}else{
				var id = this._getPropertyValue(rowData.propertiesMap, "configId");
				val.href = (id ? ConfigurationUriUtil.getEditConfigurationURI(id) : "");
			}
		}else if(atColumnIndex == 3) {
			if(rowData.link){
				val.href = rowData.link;
			}else{
            	val.href = Utility.getTestScriptURI(this._getPropertyValue(rowData.propertiesMap, "scriptId"), Utility.CONSTRUCTION_PERSPECTIVE);
			}	
		}else if(atColumnIndex == 5) {
			var stateId = rowData.state ? rowData.state.id : null;
			val.image = Utility.getStateInfo(stateId, null, true);
			val.tooltip = Utility.getRequestStateToolTip(rowData.state);
		}else if(atColumnIndex == 6) {
			if(rowData.state && rowData.state.id == "com.ibm.rqm.executionframework.common.requeststate.cancelled"){
				val.initialText = Constants.getMessage("msgSuiteExecCancelled");
			}else{
				if(rowData.link){
					val.href = rowData.link;
				}else{
					var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId") !="" ? this._getPropertyValue(rowData.propertiesMap, "resultItemId") : null;
					var ergId = this.ergId?this.ergId:this._getPropertyValue(rowData.propertiesMap,"resultGroupId");
	            	val.href = Utility.startExecution(this._getPropertyValue(rowData.propertiesMap, "ewiItemId"), this._getPropertyValue(rowData.propertiesMap, "scriptId"), resultId, rowData.id, ergId);
				}
				if(!this.getIsConsoleNode() && this._getPropertyValue(rowData.propertiesMap, "scriptType") == "com.ibm.rqm.planning.common.scripttype.manual"){
					val.initialText = Constants.getMessage("labelRunManTest");
				}
			}
		}else if(atColumnIndex == 8){
			val.image = ImageCache.NOIMAGE;
			var resultId = this._getPropertyValue(rowData.propertiesMap, "resultItemId");
			if (resultId && resultId != "") {
				val.href = Utility.getResultURI({resultItemId: resultId});
				val.image = ImageCache.EWI_LOG;
			}
		}
        return val;
    },
	
	setConsoleNode: function(bool){
		this.isConsoleNode = bool;
	},
	
	getIsConsoleNode: function(){
		return this.isConsoleNode;
	}
    
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
					'  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				  	'</div>',

    widgetsInTemplate: true,

    constructor: function() {
	 	this.requests = null;
	 },

    postCreate: function(){
        this.inherited("postCreate", arguments);
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-EXECUTION-TABLEVIEWER"            
        });        
        this._tableViewerNode.appendChild(tableViewer.domNode);
		this.isQueryPage = this.queryName;
		 if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
            this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            this.domNode.appendChild(tableViewer.domNode);
        }        tableViewer.setContentPageSize(20);
		          
        var content = this.requests ? this.requests : [];
        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
		var args = {ergId: null};
		if(this.ergId)
			args.ergId = this.ergId;
		var tableProvider = new ExecutionTableViewTableProvider(args);
        tableViewer.setContentProvider(tableProvider);
        tableViewer.setTableListener(new ExecutionTableViewTableListener({}));
        tableViewer.setCellModifier(new ExecutionTableViewCellModifier({}));
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName ? this.queryName: Constants.getMessage("labelExecCon")));
		  
		tableViewer.registerCellRenderer("RenderType.ProgressBar", 
			new com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ProgressBarCellRenderer());

		for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
            if (action.disabled && action.disabled == true) {
                actionButton.setDisabled(true);
            }
            if (action.hidden && action.hidden == true) {
                dojo.addClass(actionButton.domNode, "hidden");
            }
        }

		tableViewer.setTableRowsCheckable(false);
        tableViewer.show();
		this.tableViewer = tableViewer;
    },
	
	setContent: function(content){
		this.tableViewer.setContent(content);
		this.tableViewer.refresh();
	},
	
	showTable: function(){
		this.tableViewer.show();
	},
	
	appendItem: function(item){
		var content = this.tableViewer.getContent();
		content = content.concat([item]);//Concat as an array item
		this.tableViewer.setContent(content);
		this.tableViewer.refresh();
	},
	
	setInProgress: function(msg) {
		this.viewHeaderNode.setProgressStart(msg);
	},
	
	stopInProgress: function() {
		this.viewHeaderNode.setProgressEnd();
	},
	
	setERGId: function(ergId){
		var contentPvder =this.tableViewer.getContentProvider();
		contentPvder.setERGId(ergId);
		this.ergId = ergId;
		this.tableViewer.refresh();
	},
	
	setConsoleNode: function(bool){
		this.isConsoleNode = bool;
		this.tableViewer.getContentProvider().setConsoleNode(bool);
	},
	
	getIsConsoleNode: function(){
		return this.isConsoleNode;
	}
});

})();
