/******************TestSuiteTableView**********************/
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");

(function() {

var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants 				= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        				= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var GlobalEvents   				= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var TestExecutionSuiteClient 	= com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient;
var Constants                   = com.ibm.rqm.planning.web.client.internal.Constants;
var SelectionPopUp				= com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp;
var TESMapper					= com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper;
var EditorUtil 					= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var ViewHeaderLayout 			= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

dojo.declare("TestSuiteTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{        
	constructor: function(parentView) {
        this.parentView = parentView;
    },
	
    // Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selectionCount = tableViewer.getCheckedRows().length;
        if (this.parentView.deleteActionNode)
            this.parentView.deleteActionNode.setDisabled(selectionCount == 0);
			
		if (this.parentView.executeActionNode)
            this.parentView.executeActionNode.setDisabled(selectionCount != 1);	
		
		if (this.parentView.bulkchangeActionNode)
            this.parentView.bulkchangeActionNode.setDisabled(selectionCount == 0);
    },
    
	// Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
	// Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
         if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

	tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		if (this.parentView.parent && this.parentView.parent._TestSuiteHeaderColumnActionInvoked) {
			this.parentView.parent._TestSuiteHeaderColumnActionInvoked(tableViewer, columnIndex, actionId);
		}         
    } 	    
});

dojo.declare("TestSuiteTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    
    constructor: function(args) {
        dojo.mixin(this, args);
    },
    
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
    },
    
    cellActionInvoked: function(rowObject, columnIndex){
	}
});

dojo.declare("TestSuiteTableView.TableProvider",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    constructor: function(args) {
        dojo.mixin(this, args);
    },
        
    // Summary:
    //
    getNumColumns: function(content){
        return 7;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        var headings = [];
        headings.push(
			"",    
            Constants.getMessage("labelId"),
			Constants.getMessage("labelName"),
			Constants.getMessage("labelState"),
			Constants.getMessage("labelStatus"),
			Constants.getMessage("labelOwner"),
			Constants.getMessage("labelModified")
        );
        return headings[index];
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
		if (this.enableRowEditable) {
			var columnName = this.getColumnHeading(content, atColumnIndex);
			if (columnName == Constants.getMessage("labelOwner")) {
				return {
					actionId: columnName,
					tooltip: Constants.getMessage("labelChangeProperties", columnName),
					src: ImageCache.BULK_CHANGE
				};
			}
		}
		return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return (atColumnIndex != 0 && atColumnIndex != 1 && atColumnIndex != 6);     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
		return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 5;
            case 1: 
                return 5;
			case 2:
				return 35;	
            case 3: 
                return 15;
            case 4: 
                return 10;
            case 5: 
                return 15;
			case 6: 
                return 15;		
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_suite_" + rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
 			case 0:
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1:
				type = TableConstants.RENDER_TYPE_LINK;
				break;
			case 2:
				type = TableConstants.RENDER_TYPE_LINK;
				break;
			case 4:
				type = TableConstants.RENDER_TYPE_LINK;
				break;		
			case 6: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;	
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
		if(atColumnIndex == 0 || atColumnIndex == 1)
        	return TableConstants.ALIGN_CENTER;
		else
			return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = ""
                break;
            case 1: 
                val = rowData.id
                break;          
            case 2: 
				val = rowData.name
				break;
			case 3:
				val = rowData.state ? EditorUtil.getStateNameFromID(rowData.state) : "" ;
                break;
			case 4: 
                val = rowData.currentResultGroup ? (rowData.currentResultGroup.state ? rowData.currentResultGroup.state.name : Constants.getMessage("labelInProgress")) : Constants.getMessage("labelNotRun");
                break;
			case 5: 
                val = rowData.owner ? rowData.owner.name : "";
                break;  
			case 6:
				val = new Date();
                val.setTime(rowData.modified);
                break;			
        }
        return val;
    },
	
	getCellRawData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = ""
                break;
            case 1: 
                val = rowData.id
                break;          
            case 2: 
				val = rowData.name
				break;
			case 3:
				val = rowData.state ? EditorUtil.getStateNameFromID(rowData.state) : "" ;
                break;
			case 4: 
                val = rowData.currentResultGroup ? (rowData.currentResultGroup.state ? rowData.currentResultGroup.state.name : Constants.getMessage("labelInProgress")) : Constants.getMessage("labelNotRun");
                break;
			case 5: 
                val = rowData.owner ? rowData.owner.name : "";
                break;  
			case 6:
				val = rowData.modified;
                break;			
        }
        return val;
    },

    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
		var currentResult = rowData.currentResult;
		if(atColumnIndex == 0) {
            val = {};
			val.image = ImageCache.TEST_SUITE;
            val.href = Utility.getTestSuiteURI(rowData.id);
			val.tooltip = Constants.getMessage("labelClickToOpenTestSuite");				
        }
		if(atColumnIndex == 1){
			val={};
		 		val.href = Utility.getTestSuiteURI(rowData.id);
				val.linkType = Constants.getMessage("TestSuiteID");
				val.tooltip =""
		}
		if(atColumnIndex == 2){
			val={};
		 		val.href = Utility.getTestSuiteURI(rowData.id);
				val.tooltip="";
		}
		if(atColumnIndex == 4){
			val = {};
			if(rowData.currentResultGroup){
				var inprogress = rowData.currentResultGroup && rowData.currentResultGroup.state.name == Constants.getMessage("labelInProgress") ? true : false;
				if(inprogress)
					val.href = Utility.runSuite({groupId: rowData.currentResultGroup.id});
				else
					val.href = Utility.showSuiteResult({id: rowData.currentResultGroup.id});
			}
		}   
        return val;
    }
    
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				    '</div>',

    editable: true,
    widgetsInTemplate: true,

    constructor: function() {
        this.actions = [];
        this._actionButtons = [];
	 	this.suites = [];
		this.queryName = null;
		this.executable = false;
        this.showInitLoadProgress = false;
	 },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
		EditorUtil.loadStateTransitionConstraintSettings();  //Load the prefs in case we attempt actions that require checking (like execute)
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true            
        });        
        this._tableViewerNode.appendChild(tableViewer.domNode);
        var content = this.suites ? this.suites : [];

		this.isQueryPage = this.queryName;
        if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
            this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            this.domNode.appendChild(tableViewer.domNode);
        }		  

        // setup the table's id for saving table settings
        tableViewer.tableId = (this.isQueryPage) ? "RQM-TS-QUERY-TABLEVIWER" : "RQM-TS-TABLEVIWER";
        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
        tableViewer.setContentProvider(new TestSuiteTableView.TableProvider({
			enableRowEditable: (this.enableRowEditable ? this.enableRowEditable : false)
		}));
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName ? this.queryName: Constants.getMessage("labelTestSuites")));
		
		var tableListener = new TestSuiteTableView.TableListener(this);
		if (this.executable && this.rowCheckListener) {
           tableListener.setRowCheckListener(this.rowCheckListener);
		}        
		tableViewer.setTableListener(tableListener);
        tableViewer.setCellModifier(new TestSuiteTableView.CellModifier());
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
            
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
			var actionButton;
			if (action.label == Constants.getMessage("labelChangeTestSuiteProperties")) {
				this.bulkchangeActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
				this.bulkchangeActionNode.setDisabled(true);
				actionButton = this.bulkchangeActionNode;
			}
			else {
				actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
			}
			
            if (action.disabled && action.disabled == true) {
                actionButton.setDisabled(true);
            }
            if (action.hidden && action.hidden == true) {
                dojo.addClass(actionButton.domNode, "hidden");
            }
            this._actionButtons.push(actionButton);
        }
		
		if (this.isQueryPage) {
            var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_TEST_SUITE_EXE;
            var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
            
            if (!perm || perm.execute) {
                this.executeActionNode = tableViewer.addAction("execute", // action id
                    Constants.getMessage("labelExecute"), // label
                    null, // callback data
                    "execute-icon-image", // icon class
                    dojo.hitch(this, "_onExecuteActionClick")); // callback
                this.executeActionNode.setDisabled(true);
            }
        }
		
		//add refresh action if applicable
        if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
            tableViewer.addAction("Refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);
        }
		if (this.isQueryPage) {
            var ts_type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_TEST_SUITE;
            var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(ts_type);
            
            if (!perm || perm.archive) {
                this.deleteActionNode = tableViewer.addAction("delete", // action id
                    Constants.getMessage("labelDelete"), // label
                    null, // callback data
                    "delete-icon-image", // icon class
                    dojo.hitch(this, "_onDeleteActionClick")); // callback
                this.deleteActionNode.setDisabled(true);
            }
        }
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */ false);
        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
        tableViewer.show();
		tableViewer.setEditable(this.editable);
		this.tableViewer = tableViewer;	
    },
 
	 // API
    getSelectedItems: function() {
        return this.tableViewer.getCheckedRows();
    },

	 getTableContent: function() {
        return this.tableViewer.getContent();
    },
	
    getAction: function(actionId) {
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            if (this.actions[i].actionId == actionId) {
                return this.actions[i];
            }
        }        
    },
    
    getActionButton: function(actionId) {
        for (var i = 0; i < (this._actionButtons ? this._actionButtons.length : 0); i++) {
            if (this._actionButtons[i].actionId == actionId) {
                return this._actionButtons[i];
            }
        }        
    },
    
    hideAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button && !dojo.hasClass(button.domNode, "hidden")) {
            dojo.addClass(button.domNode, "hidden");
        } 
    },
    
    showAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button && dojo.hasClass(button.domNode, "hidden")) {
            dojo.removeClass(button.domNode, "hidden");
        } 
    },    
        
    appendItem: function(item) {
    	var content = this.tableViewer.getContent();
        content.push(item);
        this.tableViewer.setContent(content);
		this.suites = this.tableViewer.getContent()
        this.tableViewer.refresh();
    },
	
	refresh: function(content){
        if(this.showInitLoadProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }
		this.tableViewer.setContent(content);
		this.suites = this.tableViewer.getContent()
        this.tableViewer.refresh();
	},
	
	_onExecuteActionClick: function(){
		//See if we need to validate that all Test Cases are approved before we run
		var suites = this.getSelectedItems();
		if(suites && suites.length == 1){
			if (EditorUtil.applyTransactionConstraint(Constants.STATETRANSITION_PREFERENCE_ONLYEXECUTEAPPROVED)){
				//need to validate that all Test Cases are approved
				var suite = suites[0];
				var testCases = suite.elements;
				var badTestCaseString = "";
				if (testCases && testCases.length > 0){
					for (var i = 0; i < testCases.length; i++){
						var tc = testCases[i];
						var state = tc.workitem.testCase.state;
						if (state != Constants.STATETRANSITION_STATE_APPROVED) 
							badTestCaseString += " " + tc.workitem.testCase.name;
					}
				}
				if (badTestCaseString != ""){  //Found and offending test case so display a message and return
					var errorStr = Constants.getMessage("msgCannotExecuteSuiteTestCaseNotApproved", badTestCaseString);
					this.viewHeaderNode.setStatus(Constants.getMessage("cantExecuteTestSuite"), ViewHeaderLayout.WARNING, errorStr);
					return;
				}else{
					//check for approved test suite.
					var suite = suites[0];
					if (!suite.state || suite.state != Constants.STATETRANSITION_STATE_APPROVED){
						var errorStr = Constants.getMessage("msgCannotExecuteTestSuiteNotApproved", suite.name);
						this.viewHeaderNode.setStatus(Constants.getMessage("cantExecuteTestSuite"), ViewHeaderLayout.WARNING, errorStr);
						return;
					}
				}	
			}
			
            var responseHandler = new TESMapper(this, "_showPopup", "_popupFailure");
            TestExecutionSuiteClient.getTestExecutionSuiteDTOs(responseHandler,{
                id: suites[0].id,
				stateId: suites[0].stateId
            });
		}
	},
	
	_showPopup: function(suites) {
		if (suites!=null && suites.length>0) {
			var selPopUp = new SelectionPopUp();
			selPopUp.initialize(suites[0]);
		}
	},
	
    _popupFailure: function(err) {
		this.viewHeaderNode.setStatus(Constants.getMessage("msgErrorLoadingTestSuite"), ViewHeaderLayout.ERROR);
    },
	
	_onDeleteActionClick: function() {
        var args = {
            'message': Constants.getMessage("msgDelTestSuiteConfirm"),
            'yesCallback': 
                function(view) {
                    view._deleteAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
        confirmDialog.open();
    },

    _deleteAction: function() {         
        var selectedSuites = this.tableViewer.getCheckedRows();
        this.deleteActionNode.setDisabled(true);
        this.selectedSuiteCount = selectedSuites.length;
        this.errorSuiteCount = 0;
        this.deletedSuiteCount = 0;

        if (this.selectedSuiteCount > 0) {
            for (var i = 0; i < this.selectedSuiteCount; i++) {
                var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
                TestExecutionSuiteClient.archiveTestExecutionSuite(responseHandler,{
                            uuid_ts: selectedSuites[i].itemId,
							stateId: selectedSuites[i].stateId,
                            archive: true
                        });
                if (this.isQueryPage)
                    this.viewHeaderNode.setProgressStart(Constants.getMessage("msgDeletingTestSuite", selectedSuites[i].name));
            }
        }
    },
    
    _deleteSuccess: function(response) {
        if (this.isQueryPage)
            this.viewHeaderNode.setProgressEnd();
        this.deletedSuiteCount++;
        this._setDeleteStatus();
    },
    
    _deleteFailure: function(err) {
        if (this.isQueryPage)
            this.viewHeaderNode.setProgressEnd();
        this.errorSuiteCount++;
        this._setDeleteStatus();
    },
    
    _setDeleteStatus: function() {
        if ((this.deletedSuiteCount + this.errorSuiteCount) == this.selectedSuiteCount) {
            if (this.isQueryPage)
                this.viewHeaderNode.setStatus(
                    Constants.getMessage("msgDeletedTestSuite", this.deletedSuiteCount, this.selectedSuiteCount),
                    this.errorSuiteCount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedSuiteCount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
                );
            if (this.deletedSuiteCount > 0) {
                // notify all pages (including itself) test suites are deleted
                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_SUITE, this.tableViewer.getCheckedRows()]);
            }
        }
    },
	
	// handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about test suites
        if (artifactType == Constants.TYPE_SUITE) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add test suites to the table
                if (!this.suites) {
                    this.suites = artifactArray;
                } else {
                    this.suites = this.suites.concat(artifactArray);
                }
                this.refresh(this.suites);
            } else {
                // iterate through the array of artifacts
                for (var i = 0; i < artifactArray.length; i++) {
                    // iterate through the array of test cases in the table
                    for (var j = 0; j < this.suites.length; j++) {
                        // handle the matching test suite
                        if (artifactArray[i].id == this.suites[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap test suite on update
                                this.suites.splice(j, 1, artifactArray[i]);
                                this.refresh(this.suites);
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove test suite from table on delete
                                this.suites.splice(j, 1);
                                this.refresh(this.suites);
                            }
                            break;
                        }
                    }
                }
            }
        }
		 if (artifactType == Constants.TYPE_CASE) {
            if (changeType == GlobalEvents.ArtifactsUpdated) {
				for(var count=0; count < artifactArray.length; count++){
					for(var i=0; i < this.suites.length; i++){
						var elements = this.suites[i].elements ? this.suites[i].elements : [];
						for(var j=0; j < elements.length; j++){
							if(elements[j].workitem && elements[j].workitem.testCase && elements[j].workitem.testCase.id == artifactArray[count].id){
								elements[j].workitem.testCase = artifactArray[count];
								this.suites[i].elements.splice(j, 1, elements[j]);
							}
						}
					}
				}
			}
			this.viewHeaderNode.clearStatus();
			this.refresh(this.suites);
		}	
    },
	
	setInProgress: function(msg) {
		this.viewHeaderNode.setProgressStart(msg);
	},
	
	stopInProgress: function() {
		this.viewHeaderNode.setProgressEnd();
	}
	
});

})();
