/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineReservationTableProvider"); 

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.DefaultTableProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

(function() {

	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var column_types = [
						TableConstants.RENDER_TYPE_TEXT,
						TableConstants.RENDER_TYPE_TEXT,
						TableConstants.RENDER_TYPE_TIMESTAMPDATE,
						TableConstants.RENDER_TYPE_TIMESTAMPDATE ];
						

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.providers.MachineReservationTableProvider", 
             com.ibm.rational.test.lm.web.ui.internal.views.providers.DefaultTableProvider,
{
	constructor: function()
	{
		this.setParameters( { "column_headings" : this.getColumnHeadings(),
							  "column_types" : column_types } );
	},
	
	getColumnHeadings : function()
	{
		return( [{title: RtlmUiUtil.getMessage("reservedBy"), native_column: "reservedBy.name", isSortable: true, includeInFilter: true, width: 35},            
        {title: RtlmUiUtil.getMessage("reservedFor"), native_column: "reservedFor.name", isSortable: true, includeInFilter: true, width: 35},       
        {title: RtlmUiUtil.getMessage("reserveFrom"), native_column: "reserveFrom", isSortable: true, includeInFilter: true, width: 15},              
        {title: RtlmUiUtil.getMessage("reserveTo"), native_column: "reserveTo", isSortable: true, includeInFilter: true, width: 15}]);
	}
});

})();
