/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.viewlets.RequestViewlet");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.requests.QueryRequestWidget");

(function() {

var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;
var QueryRequestWidget = com.ibm.rational.test.lm.web.ui.internal.views.requests.QueryRequestWidget;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.viewlets.RequestViewlet",	Viewlet,
{
	
	templateString: "<div><div dojoAttachPoint=\"requestViewletContent\" \></div>",
	
	/*
	 * Called by the framework after the viewlet is instantiated, but before the
	 * first refresh. Viewlets that need to initialize themselves shoudl override.
	 */
	init: function() {
		var params = {
            defaultQuery: QueryRequestWidget.ASSIGNED_TO_ME_REQUEST_QUERY_ID,
            tableId: "RQM-LM-REQUEST-QUERY-TABLEVIWLET"
        };
		this.requestViewlet = new QueryRequestWidget(params, this.requestViewletContent);
	},
	
	/*
 	 * Public Method
 	 * 
 	 * Refreshes the viewlet content.
 	 * 
 	 * @param <none>
 	 * @return <none>
 	 */	
	refresh: function() {
		this.requestViewlet.loadQueryCombo();
		//Need to set the isRefreshing on the container so that refreshing of the viewlet can occur,
		//otherwise it can only happen once.
		this.container.isRefreshing = 0;
	},
	
	/*
	 * Repopulates the viewlet. New content should not be retrieved from the server.
	 * Called when presentation of the viewlet is changed in some way, but new information
	 * is not required.
	 * 
	 * Viewlets should override.
	 */
	update: function() {
	}
});

})();
