/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.attachmentViewer.AttachmentTextCellRenderer");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");

(function() {

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.attachmentViewer.AttachmentTextCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{    
    // Summary:
    //    Renders the cell content for Attachment Table.
	//	  Attachment description needs to be Strike-through when Undo delete action is visible 
    //    
    renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/cellModifier, rowObject, columnIndex, cellWidthHint)
    {
	   var node;
       var isCompactMode = (viewer.isCompactMode && typeof cellWidthHint != "undefined");
       var text = cellData;
       
	   if(rowObject.isRemoved){
			node = document.createElement('strike');
			var childNode = document.createElement("span");
			node.appendChild(childNode);
            
            if(isCompactMode)
                text = this._handleCompactCellText(viewer, text, extendedDisplayInfo, childNode, cellWidthHint);
			childNode.appendChild(document.createTextNode(text));
	   } else {
           node = document.createElement('span');
            if(isCompactMode)
                text = this._handleCompactCellText(viewer, text, extendedDisplayInfo, node, cellWidthHint);
		   node.appendChild(document.createTextNode(text));
        }
        var topNode;
        if(extendedDisplayInfo && (typeof extendedDisplayInfo['href'] != "undefined")) {
			topNode = document.createElement("a");
			var href = "#";
            href = extendedDisplayInfo['href'];
			topNode.appendChild(node);
			topNode.href = href;
        }else
		{
			topNode = document.createElement('span');
			topNode.appendChild(node);
		}
		
		if(!isCompactMode && extendedDisplayInfo && dojo.isObject(extendedDisplayInfo))
            this._attachTooltipToCell(topNode, extendedDisplayInfo['tooltip']);
		
        return topNode;
    }
});

})();
