/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
// Summary:
//    A basic Section header widget for the SectionLayoutForm. It provides the following layout:
//
//    +---------------------------------------------------------+
//      Section Title   action					collapse toggle
//    +---------------------------------------------------------+
//
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.ActionSectionHeader");

dojo.require("dojo.fx");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionHeader");

(function() {
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.ActionSectionHeader", 
    [com.ibm.rational.test.lm.web.ui.internal.widgets.layout.SectionHeader],
{
	callbackData: null,
    actionNode: null,
    linkDivNode: null,
    
	imgSrc: dojo.moduleUrl("com.ibm.rational.test.lm.web", "ui/internal/images/icons/elcl16/add_exc.gif"),					
					
	postCreate: function() 
    {
        this.inherited("postCreate", arguments);
        
        this.actionNode = this.addAction("add", dojo.hitch(this, "_actionNodeClickHandler"), null, "add-icon-image");
    },
	
	_actionNodeClickHandler: function()
	{
		this.onActionClick(this.callbackData);
	},
	
	/**
	 * Sets the data that will be passed to function onActionClick() 
	 * @param {Object} data
	 */
	setCallbackData: function(data) {
		this.callbackData = data;
	},
	
	// Summary:
	//    Application callback method to handle the add button click event.
	//    Override this method to receive the add button clicked event.
	// 
	onActionClick: function()
	{		
	},
	
	activateActionButton: function()
	{
		this.actionNode.domNode.style.display = "inline";
	},
	
	deactivateActionButton: function()
	{
		this.actionNode.domNode.style.display = "none";
	},
	
	disableActionButton: function()
	{
		this.actionNode.disabled = true;
	},
	
	enableActionButton: function()
	{
		this.actionNode.disabled = false;
	}
});

})();
