/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormLabelField");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.AbstractFormField");

(function() {
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormLabelField", 
    com.ibm.rational.test.lm.web.ui.internal.widgets.layout.AbstractFormField,
{
    postCreate: function() {
		this.inherited("postCreate", arguments);
		this.labelField = document.createElement("div");
        this.fieldHolderNode.appendChild(this.labelField);
		this.formField = this.labelField;
        this.formField.className = "field";
    },
	      
	setValue: function(value)
    {
        this.labelField.innerHTML = value;
    },

    // Summary:
    //    Returns the value from the field. Subclass must override. A null is returned if
    //    no value is specified.
    //
    getValue: function()
    {
        return this.labelField.innerHTML;
    },
   
    // Summary:
    //    This method is called when the field's value has been changed. Consumer of the widget 
    //    overrides this method to receive notification of the value changed event.
    //
    onValueChanged: function(oldValue, newValue)
    {
    }
});

})();
