/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormTextCheckboxField");

dojo.require("dijit.form.CheckBox");
dojo.require("dijit.Tooltip");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormTextField");

(function() {

var CheckBox = dijit.form.CheckBox;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormTextCheckboxField", 
    com.ibm.rational.test.lm.web.ui.internal.widgets.layout.FormTextField,
{

    postCreate: function() {
        this.inherited("postCreate", arguments);
        this.checkboxField = new CheckBox({
                    name: "checkboxField",
                    checked: true
                });
        var space = document.createElement("span");
        space.className = "field-space";
        this.fieldHolderNode.appendChild(space);
        this.fieldHolderNode.appendChild(this.checkboxField.domNode);
        if(this.tooltipMessage) {
            var tooltip = new dijit.Tooltip({label: this.tooltipMessage, connectId:[this.checkboxField.domNode]});
            // Cange the tooltip behavior to not show just because 
            // the checkbox is in focus.
            tooltip._onUnHover = function(/*Event*/ e){
                if(this._showTimer){
                    clearTimeout(this._showTimer);
                    delete this._showTimer;
                }
                this.close();
            }
 
        }

    },

    getCheckboxReference: function() {
        return this.checkboxField;
    }
});

})();
