/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
 // Summary:
 //    A TableCellModifier is a client implemented interface that receives cell 
 //    value changed events. Certain cell renderer types can allow the user to
 //    modify the cell data/state. For example, an ACTION renderer type can generate
 //    cell click events, etc. When a cell's value changed, or action invoked, the
 //    registereed cell modifier will be notified through this interface class methods.
 //
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");

(function() {

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier", null,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
    },
    
    // Summary:
    //    When a cell renderer type is ACTION, this methods is invoked.
    //
    cellActionInvoked: function(rowObject, columnIndex)
    {
    },
    
    // Summary:
    //    When a cell renderer type is the DROPDOWN_MENU, this methods is invoked.
    //
    cellMenuActionInvoked: function(actionId, rowObject, columnIndex)
    {
    }
    
    
});

})();
